-- name=int_button_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_task", "obj_int_inventory_task" );
  ObjSet( "int_button_task", { pos_z = pos_z } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_TIME      =  0.6;

  ObjSet( "obj_int_button_task", 
  {
    event_mdown = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );
  
end;
--******************************************************************************************
function public.Destroy ()

  --

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function private.MouseDown ()

  if ( int_dialog_task.show ) then

    interface.DialogTaskHide();

  else

    interface.DialogTaskShow( private.task_current, "current_task" );

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  interface.InventoryOpen();
  common_impl.DialogButtonMouseEnter( "int_button_task" );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  interface.InventoryClose();
  common_impl.DialogButtonMouseLeave( "int_button_task" );

end;
--******************************************************************************************
function public.Update ( state, task )

  private.task_current = task;
  ObjSet( "int_button_task", { active = state, visible = state, input = state } );

end;