-- name=int_dialog_impl
--******************************************************************************************
function public.Init ()

  public.GRID_CORNER_W =  58;
  public.GRID_CORNER_H =  58;
  public.GRID_MID_W    =   4;
  public.GRID_MID_H    =   4;

  public.GRID_BORDER_W = 100;
  public.GRID_BORDER_H = 100;

  public.MIN_W = 300;
  public.MAX_W = 500;
  public.MIN_H = 150;
  public.MAX_H = 500;

  private.SHOW_ANIM_TIME = 0.3;
  ObjSet( "obj_dialog_transpanent", {
    event_mdown = int_dialog.MouseDown
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id, extended )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_impl", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function public.ShowAnim( event_id, extended, params )

  local trg = function () int_dialog.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_dialog_impl", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

  local pos_x = - params.width / 2 + 19;
  local pos_y = params.height / 2 - 42;

  ObjSet( "spr_int_dialog_decor_left", { pos_x = pos_x, pos_y = pos_y } );
  ObjSet( "spr_int_dialog_decor_right", { pos_x = - pos_x, pos_y = pos_y } );

end;
--******************************************************************************************