-- name=rm_mine_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mine_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_victim", "room_hub" );
  ObjAttach( "zz_inventory", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_victim_inventorykey", { event_mdown = private.get_inventorykey }},
    { "obj_inventory_use_inventorykey", { event_mdown = function() common_impl.ShowBbt( "bbt_inventory_use_inventorykey", 1 ); end }},
    { "obj_inventory_clk_inventorykey", { event_mdown = function() private.clk_inventorykey() end }},
    { "obj_vid_mine_2_kevin", { event_mdown = private.vid_mine_2_kevin }},
    { "obj_vid_mine_2_savior", { event_mdown = private.vid_mine_2_savior }},
    { "obj_dlg_mine_2_saved_focus", { event_mdown = private.dlg_mine_2_saved }},
    { "obj_inventory_clk_handle", { event_mdown = private.clk_inventoryhandle,
                                    event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
                                    event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end}},
    { "spr_mine_2_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mine_2 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_mine_2_inventory",
    "gzz_mine_2_victim",
    "gzz_mine_2_inventory"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_victim",
      "zz_inventory",
      
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_mine_2", update_game_mode_mine_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mine_2 = function ()

  local effects_table = 
  {
    "obj_mine_2_anim",
    "anm_mine_2_kevin_1",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mine_2", update_performance_mode_mine_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mine_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_mine_2" ] = {
    type = "click",
    use_place = "grm_mine_1_mine_2",
    room = "rm_mine_1"
  };

  local opn_mine_2_map = function ()

    common_impl.VisitMapRoom( "mine_2" );

  end;
  cmn.AddSubscriber( "opn_mine_2", opn_mine_2_map, nil );

   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_6 = function ()
  
    ObjDelete( "obj_mine_2_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_6", get_collect_morph_item_2_6, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_inventorykey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_inventorykey" ] = {
    type = "get",
    get_obj = "spr_victim_inventorykey",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_mine_2_victim"
  };
    
  local get_inventorykey_inv = function ()
  
    interface.InventoryItemAdd( "inv_inventorykey", "spr_victim_inventorykey" );
  
  end;
  
  local get_inventorykey_closezz = function ()
  
    ObjDelete( "gfx_victim_inventorykey" );
    ObjDelete( "spr_victim_key_shadow" );
    --ObjDelete( "gzz_mine_2_victim" );

    if ( cmn.IsEventDone( "use_clippers_2" ) and cmn.IsEventDone( "use_slingshotframe" ) and cmn.IsEventDone( "get_inventorykey" )) then

        ObjDelete( "gzz_mine_2_victim" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_inventorykey", get_inventorykey_inv );
  cmn.AddSubscriber( "get_inventorykey", get_inventorykey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clippers_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clippers_2" ] = {
    type = "use",
    inv_obj = "inv_clippers",
    use_place = "obj_victim_use_clippers",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_mine_2_victim"
  };
  local use_clippers_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_clippers" );
  
  end;
  local use_clippers_2_beg = function ()
  
    ObjDelete( "obj_victim_use_clippers" );
    ObjDelete( "anm_mine_2_kevin_wire" );
  
  end;
  local use_clippers_2_end = function ()
  

    if ( cmn.IsEventDone( "use_clippers_2" ) and cmn.IsEventDone( "use_slingshotframe" ) and cmn.IsEventDone( "get_inventorykey" )) then

        ObjDelete( "gzz_mine_2_victim" );
        ObjSet( "obj_vid_mine_2_savior", { input = 1, active = 1 } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clippers_2", use_clippers_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2", use_clippers_2_inv );
  cmn.AddSubscriber( "use_clippers_2", use_clippers_2_end, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2_inv", use_clippers_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2_beg", use_clippers_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2_end", use_clippers_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_slingshotframe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_slingshotframe" ] = {
    type = "use",
    inv_obj = "inv_slingshotframe",
    use_place = "obj_victim_use_slingshotframe",
    room = private.room_objname,
    zz = "zz_victim",
    zz_gate = "gzz_mine_2_victim"
  };
  local use_slingshotframe_inv = function ()
  
    interface.InventoryItemRemove( "inv_slingshotframe" );
  
  end;
  local use_slingshotframe_beg = function ()
  
    ObjDelete( "obj_victim_use_slingshotframe" );
  
  end;
  local use_slingshotframe_end = function ()
  
    ObjDelete( "anm_victim_kevin" );
    ObjMultiSet({ 
     { "spr_victim_fork",    { alp = 1 }},
     { "spr_victim_log",     { alp = 1 }},
     { "anm_victim_kevin_2", { alp = 1, playing = true }},
     });

    if ( cmn.IsEventDone( "use_clippers_2" ) and cmn.IsEventDone( "use_slingshotframe" ) and cmn.IsEventDone( "get_inventorykey" )) then

        ObjDelete( "gzz_mine_2_victim" );
        ObjSet( "obj_vid_mine_2_savior", { input = 1, active = 1 } );

    end;

    ObjSet( "spr_mine_2_stick", { alp = 1 } );
    ObjSet( "anm_mine_2_kevin_2", { alp = 1, playing = true } );

    ObjDelete( "anm_mine_2_kevin" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_slingshotframe", use_slingshotframe_beg, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe", use_slingshotframe_inv );
  cmn.AddSubscriber( "use_slingshotframe", use_slingshotframe_end, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe_inv", use_slingshotframe_inv, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe_beg", use_slingshotframe_beg, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe_end", use_slingshotframe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_inventorykey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_inventorykey" ] = {
    type = "use",
    inv_obj = "inv_inventorykey",
    use_place = "obj_inventory_use_inventorykey",
    room = private.room_objname,
    zz = "zz_inventory",
    zz_gate = "gzz_mine_2_inventory"
  };
  local use_inventorykey_inv = function ()
  
    interface.InventoryItemRemove( "inv_inventorykey" );
  
  end;
  local use_inventorykey_beg = function ()
  
    ObjDelete( "obj_inventory_use_inventorykey" );
  
  end;
  local use_inventorykey_end = function ()

    ObjSet( "spr_inventory_key", { alp = 1 } );
    ObjSet( "spr_inventory_key_shadow", { alp = 1 } );
    ObjSet( "obj_inventory_clk_inventorykey", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_inventorykey", use_inventorykey_beg, private.room_objname );
  cmn.AddSubscriber( "use_inventorykey", use_inventorykey_inv );
  cmn.AddSubscriber( "use_inventorykey", use_inventorykey_end, private.room_objname );
  cmn.AddSubscriber( "use_inventorykey_inv", use_inventorykey_inv, private.room_objname );
  cmn.AddSubscriber( "use_inventorykey_beg", use_inventorykey_beg, private.room_objname );
  cmn.AddSubscriber( "use_inventorykey_end", use_inventorykey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_inventorykey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_inventorykey" ] = {
    type = "click",
    use_place = "obj_inventory_clk_inventorykey",
    room = private.room_objname,
    zz = "zz_inventory",
    zz_gate = "gzz_mine_2_inventory"    
  };
  local clk_inventorykey_beg = function ()
  
    ObjDelete( "obj_inventory_clk_inventorykey" );
  
  end;
  local clk_inventorykey_end = function ()
  
    ObjSet( "gho_mine_2_inventory", { input = true, active = true } );

    ObjDelete( "gzz_mine_2_inventory" );
    ObjDelete( "spr_inventory_key" );
    ObjDelete( "spr_inventory_key_shadow" );

    ObjSet( "spr_mine_2_open_door", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_inventorykey", clk_inventorykey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_inventorykey", clk_inventorykey_end, private.room_objname );
  cmn.AddSubscriber( "clk_inventorykey_beg", clk_inventorykey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_inventorykey_end", clk_inventorykey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_mine_2_kevin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_mine_2_kevin" ] = {

      type = "click",
      use_place = "obj_vid_mine_2_kevin",
      room = private.room_objname
  };
  local vid_mine_2_kevin_beg = function ()

    ObjDelete( "obj_vid_mine_2_kevin" );

  end;
  local vid_mine_2_kevin_end = function ()
    

  end;
  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_mine_2_kevin", vid_mine_2_kevin_beg, private.room_objname );
  cmn.AddSubscriber( "vid_mine_2_kevin", vid_mine_2_kevin_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_2_kevin_beg", vid_mine_2_kevin_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_2_kevin_end", vid_mine_2_kevin_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_mine_2_savior () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_mine_2_savior" ] = {

      type = "click",
      use_place = "obj_vid_mine_2_savior",
      room = private.room_objname
  };
  local vid_mine_2_savior_beg = function ()

    ObjDelete( "obj_vid_mine_2_savior" );

  end;
  local vid_mine_2_savior_end = function ()

    ObjDelete( "spr_mine_2_stick" );
    ObjDelete( "anm_mine_2_kevin_2" );

    ObjMultiSet({ 
      { "spr_mine_2_debris", { alp = 1 }},
      { "spr_mine_2_stones", { alp = 1 }},
      { "anm_mine_2_kevin_1",   { active = true, visible = true               }},
      { "obj_mine_2_bbt_kevin", { active = true, visible = true, input = true }},
    });

  end;
  local vid_mine_2_savior_loc = function ()

    ObjSet( "obj_dlg_mine_1_saved", { input = true, active = true } );
    ObjSet( "obj_mine_1_kevin", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_mine_2_savior", vid_mine_2_savior_beg, private.room_objname );
  cmn.AddSubscriber( "vid_mine_2_savior", vid_mine_2_savior_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_2_savior", vid_mine_2_savior_loc, "rm_mine_1" );
  cmn.AddSubscriber( "vid_mine_2_savior_beg", vid_mine_2_savior_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_2_savior_end", vid_mine_2_savior_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_2_savior_loc", vid_mine_2_savior_loc, "rm_mine_1" );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_victim" );
  --------------------------------------------------------------------------------------------
  function zz_victim.PreOpen()

    if not cmn.IsEventDone( "use_slingshotframe" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_magic_zz_env", 1, "", 0.5 );
      common_impl.StopAudio( "env", "common/audio/aud_magic_loc_env", 0.5 );  

    end;  

  end;

  function zz_victim.PreClose()

    if not cmn.IsEventDone( "use_slingshotframe" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_magic_loc_env", 1, "", 0.5 );
      common_impl.StopAudio( "env", "common/audio/aud_magic_zz_env", 0.5 );   

    end;
  
  end;


end;
--*********************************************************************************************************************
function public.Open()

  private.opn_mine_2();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.InvestigationButtonCheck();
  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "common/audio/aud_mine_2_env" }, "", 0.5 );

  if cmn.IsEventDone( "vid_mine_2_kevin" ) and not cmn.IsEventDone( "use_slingshotframe" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_magic_loc_env", 1, "", 0.5 );

  end;

  if cmn.IsEventDone( "vid_mine_2_savior" ) then

    ObjAnimate( "obj_mine_2_mine_2", "ang", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.005,
      1.5, 0, -0.005,
      2.0, 0, 0.0,
      8.0, 0, 0.0
    } );

    ObjAnimate( "obj_mine_2_mine_2", "pos_x", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 5,
      0.9, 0, -5,
      1.2, 0, 0.0,
      8.0, 0, 0.0
    } );

    ObjAnimate( "obj_mine_2_mine_2", "pos_y", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 3,
      1.2, 0, -3,
      1.6, 0, 0.0,
      8.0, 0, 0.0
    } );

  end;

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_clippers_2()

  local item = "inv_clippers";

  if ( common.ApplyObj( item, "obj_victim_use_clippers", true ) ) then

    cmn.CallEventHandler( "use_clippers_2_inv" );
    cmn.CallEventHandler( "use_clippers_2_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_clippers_2" );
      cmn.CallEventHandler( "use_clippers_2_end" );

    --common.CloseSubRoom();

    common_impl.Lock(false);

      if ( cmn.IsEventDone( "use_clippers_2" ) and cmn.IsEventDone( "use_slingshotframe" ) and cmn.IsEventDone( "get_inventorykey" )) then

        common.CloseSubRoom();

      end;
    
    end;

    common_impl.Lock(true);
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_nippers_kevin", 0, "", 0 );

    AnimPlay( "anm_victim_nippers", "DoAnim", func_after );  

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_2_victim", false ) and cmn.IsEventDone( "vid_mine_2_kevin" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victim", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_slingshotframe()

  local item = "inv_slingshotframe";

  if ( common.ApplyObj( item, "obj_victim_use_slingshotframe", true ) ) then

    cmn.CallEventHandler( "use_slingshotframe_inv" );
    cmn.CallEventHandler( "use_slingshotframe_beg" );

    local func_after = function ()

      AnimPlay( "anm_victim_kevin_2", "DoAnim", "" );
      cmn.SetEventDone( "use_slingshotframe" );
      cmn.CallEventHandler( "use_slingshotframe_end" );
      --common.CloseSubRoom();
      common_impl.Lock(false);
      common_impl.StopAudio( "env", "common/audio/aud_magic_zz_env", 0.5 );    

      if ( cmn.IsEventDone( "use_clippers_2" ) and cmn.IsEventDone( "use_slingshotframe" ) and cmn.IsEventDone( "get_inventorykey" )) then

        common.CloseSubRoom();

      end;
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_wood_fork", 0, "", 0 );

    ObjAnimate( "spr_victim_fork", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    ObjAnimate( "spr_victim_log", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    
    ObjAnimate( "anm_victim_kevin", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "anm_victim_kevin_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;

  elseif common.ApplyObj( item, "gzz_mine_2_victim", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victim", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_inventorykey()

  local item = "inv_inventorykey";

  if ( common.ApplyObj( item, "obj_inventory_use_inventorykey", true ) ) then

    cmn.CallEventHandler( "use_inventorykey_inv" );
    cmn.CallEventHandler( "use_inventorykey_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_inventorykey" );
      cmn.CallEventHandler( "use_inventorykey_end" );
    --common.CloseSubRoom();
    
  end;

    common_impl.Lock( true );
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_inventory_key", 0, "", 0 );

    ObjAnimate( "spr_inventory_key", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_inventory_key_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;
    
  elseif common.ApplyObj( item, "gzz_mine_2_inventory", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_inventory", nil, { 512, 384 } );

    return true;   

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_inventorykey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_inventorykey" );
  cmn.CallEventHandler( "get_inventorykey" );

  if ( cmn.IsEventDone( "use_clippers_2" ) and cmn.IsEventDone( "use_slingshotframe" ) and cmn.IsEventDone( "get_inventorykey" )) then

    common.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_mine_2()

  if not ( cmn.IsEventDone( "opn_mine_2" ) ) then
    cmn.SetEventDone( "opn_mine_2" );
  end;
  cmn.CallEventHandler( "opn_mine_2" ); 
  -->EE, чтобы не было блокировки раньше обвала
  common_impl.LockMapRoom( "mine_2", false );

end;
--*********************************************************************************************************************
function private.vid_mine_2_kevin()

  cmn.CallEventHandler( "vid_mine_2_kevin_beg" );
  ObjSet( "vid_mine_2_kevin", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_mine_2_kevin" );
    cmn.CallEventHandler( "vid_mine_2_kevin_end" );

    common_impl.PlayAudio( "env", "common/audio/aud_magic_loc_env", 1, "", 0.5 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

    if skip then 

      common_impl.StopAudio( "sfx", "common/audio/aud_mine_2_kevin", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_mine_2_kevin_voc", 0.5 );

    end;

  end;
  
  common_impl.StopAllMus();

  interface.DialogVideoShow( "vid_mine_2_kevin", 1, function() func_after( 'skip' ) end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_mine_2_kevin", 0, "", 0.5 );
  common_impl.PlayAudio( "voc", "common/audio/aud_mine_2_kevin_voc", 0, "", 0.5 );
  VidPlay( "vid_mine_2_kevin", function() func_after( nil ) end ); 

end;
--*********************************************************************************************************************
function private.vid_mine_2_savior()

  cmn.CallEventHandler( "vid_mine_2_savior_beg" );
  ObjSet( "vid_mine_2_savior", { alp = 1, active = true, input = false, visible = true } );
    
  local func_after = function ( skip )

    common_impl.ShowBbt( 'bbt_mine_2_savior' );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_mine_2_savior" );
    cmn.CallEventHandler( "vid_mine_2_savior_end" );
    cmn.CallEventHandler( "vid_mine_2_savior_loc" );
    interface.KeyTaskDone( "save_man", true );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

    common_impl.AddPageDiary( 7 );

    local page_content = {1, 1, 1};
    common_impl.AddBookmarkDiary( 11, 1, page_content);

    ObjAttach( "vid_mine_2_smoke", "rm_mine_2" );
    ObjAnimate( "obj_mine_2_mine_2", "ang", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.005,
      1.5, 0, -0.005,
      2.0, 0, 0.0,
      8.0, 0, 0.0
    } );

    ObjAnimate( "obj_mine_2_mine_2", "pos_x", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 5,
      0.9, 0, -5,
      1.2, 0, 0.0,
      8.0, 0, 0.0
    } );

    ObjAnimate( "obj_mine_2_mine_2", "pos_y", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 3,
      1.2, 0, -3,
      1.6, 0, 0.0,
      8.0, 0, 0.0
    } );

    VidPlay( "vid_mine_2_smoke", function () 

      ObjDelete( "vid_mine_2_smoke" );

    end ); 
    --ObjSet( "vid_mine_2_smoke", { looped = true } );
    --VidPlay( "vid_mine_2_smoke", "" );
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_mine_2_savior", 0.5 );

    end;

  end;
  
  common_impl.StopAllMus();

  interface.DialogVideoShow( "vid_mine_2_savior", 1, function() func_after( 'skip' ) end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_mine_2_savior", 0, "", 0.5 );
  VidPlay( "vid_mine_2_savior", function() func_after( nil ) end ); 

end;
--*********************************************************************************************************************
function private.clk_inventorykey()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_inventorykey" );
    cmn.CallEventHandler( "clk_inventorykey_end", private.room_objname );
    common.CloseSubRoom();

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_inventory_key", 0, "", 0 );

  cmn.CallEventHandler( "clk_inventorykey_beg", private.room_objname );

  ObjAnimate( "spr_inventory_key", "alp", 0, 0, func_after,
  {
    0.0, 0, 1.0,
    0.4, 0, 0.0
  } );

  ObjAnimate( "spr_inventory_key_shadow", "alp", 0, 0, "",
  {
    0.0, 0, 1.0,
    0.4, 0, 0.0
  } );

  ObjAnimate( "spr_inventory_key_2", "alp", 0, 0, "",
  {
    0.0, 0, 0.0,
    0.4, 0, 1.0
  } );

end;
--*********************************************************************************************************************
function private.clk_inventoryhandle()

  local func_after = function ()

    common_impl.Lock( false );

  end;

  common_impl.ShowBbt( "bbt_inventory_use_inventorykey", 1 );
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_inventory_door", 0, "", 0 );

  ObjAnimate( "spr_inventory_handle_1", "alp", 0, 0, func_after,
  {
    0.0, 0, 0.0,
    0.3, 0, 1.0,
    0.6, 0, 0.0
  } );

end;