-- name=mg_pathfind
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_pathfind";
  private.target_count = { 4,6,6 };
  private.animflag = false;
  private.animmas = {};
  private.newpos = { { { "ang", 0.67 }, nil, nil, { "pos_xy", 490, 404, 432, 406 } }, 
                     { { -171,0, -410, 97 }, { "pos_xy", 171, 287, 54, 294}, { -171, 0, -261, -3}, { -171,0, -144, 0 }, { "vid" }, { "pos_xy", 760, 98, 690, 127  } },
                     { { "pos_xy", 575, 581, 624, 589}, { "pos_xy", 111,452, 166, 465 }, { "vid" }, { "pos_xy", 996, 245, 993, 343}, { -171,0, -129, 3 }, { "pos_xy", 674, 412, 595, 416  } }
                  };
  private.isplaying = false;
  local set_table = {};

  for i = 1, #private.target_count do

    table.insert( set_table, 
                  { "spr_pathfind_mg_"..i.."_path_end", { 
                    event_menter = function() private.GateMouseEnter( CURSOR_UP, "spr_pathfind_mg_"..i.."_path_end" ) end, 
                    event_mleave = function() private.GateMouseLeave( "spr_pathfind_mg_"..i.."_path_end" ) end,
                    event_mdown = function() private.changeback() end } 
                  });    

  end;

  --общий сет подсветки
  for i = 1, #private.target_count do

    for j = 1, private.target_count[i] do

      table.insert( set_table, 
                      { "spr_pathfind_mg_"..i.."_over_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_over( j ) end } });
      table.insert( set_table, { "spr_pathfind_mg_"..i.."_light_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_animlight( j ) end } });

    end;

  end;

  ObjMultiSet( set_table );

  --сэт для перекрывающих первого бэка
  ObjMultiSet( {
    { "anm_pathfind_mg_1_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_anim( 2 ) end } },
    { "spr_pathfind_mg_1_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "anm_pathfind_mg_1_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_anim( 3 ) end } },
    { "spr_pathfind_mg_1_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },
  --сэт для перекрывающих второго бэка
    { "spr_pathfind_mg_2_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "anm_pathfind_mg_2_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 3 ) end } },
    { "anm_pathfind_mg_2_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 1 ) end } },
    { "anm_pathfind_mg_2_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 4 ) end } },
    { "vid_pathfind_mg_2_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 5 ) end } },
    { "spr_pathfind_mg_2_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },
  --сэт для перекрывающих третьего бэка
    { "spr_pathfind_mg_3_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "spr_pathfind_mg_3_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "vid_pathfind_mg_3_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 3 ) end } },
    { "spr_pathfind_mg_3_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },
    { "anm_pathfind_mg_3_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 5 ) end } },
    { "spr_pathfind_mg_3_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },
  } );
 
  private.sounds = { { "log", "tortoise", "raccoon", "bush" }, { "frog", "bush", "heron_1", "owl_1", "crocodile_1", "bush" }, 
                     { "skull", "bush", "crocodile_2", "owl_2", "heron_2", "bush" } };

  --------------------------------------------------------------------------------------------
  -- function win_pathfind () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pathfind" ] = {
    type = "win",
    room = "rm_nightsville_3",
    zz = "mg_pathfind",
    zz_gate = "gmg_nightsville_3_pathfind"
  };
  local win_pathfind = function ()

    if ( cmn.IsEventDone( "win_pathfind" ) ) then  

    else

      if ng_global.progress[ "std" ][ "win_pathfind" ].state then

        local paths = 0;
        local gateflag = true;
        local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;

        ObjSet( "spr_pathfind_back", { res = "assets/levels/level3/mg_pathfind/back"..state.."/back" } );

        for i = 1,private.target_count[state] do

          local statelvl = ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i];

          private.animflag = true;
          
          if statelvl == 1 then

            table.insert( private.animmas, i );
            gateflag = false;

          elseif statelvl == 2 then

            paths = paths + 1;
            ObjMultiSet({ 
              { "spr_pathfind_mg_"..state.."_over_"..i, { alp = 0, input = false }},
              { "spr_pathfind_mg_"..state.."_light_"..i, { alp = 1, color_r = 0, color_b = 0 }},
            });

          else

            gateflag = false;

          end;

          if statelvl ~= 0 then

            if private.newpos[ state ][ i ] then

              if private.newpos[ state ][ i ][ 1 ] == "ang" then

                ObjSet( "spr_pathfind_mg_"..state.."_over_"..i, { ang = private.newpos[ state ][ i ][ 2 ], input = false } );

              elseif  private.newpos[ state ][ i ][ 1 ] == "pos_xy" then

                ObjSet( "spr_pathfind_mg_"..state.."_over_"..i, { pos_x = private.newpos[ state ][ i ][ 4 ], pos_y = private.newpos[ state ][ i ][ 5 ], input = false } );

              else

                ObjSet( "anm_pathfind_mg_"..state.."_over_"..i, { pos_x = private.newpos[ state ][ i ][ 3 ], pos_y = private.newpos[ state ][ i ][ 4 ], input = false } );

              end;

            else

              ObjSet( "spr_pathfind_mg_"..state.."_over_"..i, { alp = 0, input = false } );                

            end;

            ObjSet( "spr_pathfind_mg_"..state.."_cross_"..i, { color_g = 1, color_r = 0 } );

          end;

        end;

        if gateflag then
                     
          ObjSet( "spr_pathfind_mg_"..state.."_path_end" , { input = true, active = true } );

        end;

        for i = 1, paths do

          ObjSet( "spr_pathfind_mg_"..state.."_path_"..i, { alp = 1 } );

        end;

      end;

      if ng_global.progress[ "std" ][ "win_pathfind" ].state == 1 then

        if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[2] ~= 0 then

          ObjSet( "anm_pathfind_mg_1_over_2_3", { alp = 1, playing = true } );
          ObjDelete( "anm_pathfind_mg_1_over_2" );

        end;

        if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[3] ~= 0 then

          ObjSet( "anm_pathfind_mg_1_over_3_3", { alp = 1, playing = true } );
          ObjDelete( "anm_pathfind_mg_1_over_3" );

        end;

      else 

        for i = 1,ng_global.progress[ "std" ][ "win_pathfind" ].state - 1 do

          ObjDelete( "obj_pathfind_mg_"..i);

        end;

        ObjSet( "obj_pathfind_mg_"..ng_global.progress[ "std" ][ "win_pathfind" ].state, { alp = 1, input = true } );

      end;


    end;

  end;

  local win_pathfind_loc = function ()

    if ( cmn.IsEventDone( "win_pathfind" ) ) then  

      ObjSet( "grm_nightsville_3_mansion", { input = true, active = true, visible = true } );
      if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_nightsville_3_mansion_focus");
      end;
      ObjDelete( "gmg_nightsville_3_pathfind" );
      if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_nightsville_3_pathfind_focus");
      end;
      ObjDelete( "grm_nightsville_3_pathfind_focus" );
      ObjDelete( "spr_nightsville_3_map" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pathfind", win_pathfind, private.room_objname );
  cmn.AddSubscriber( "win_pathfind", win_pathfind_loc, "rm_nightsville_3" );  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open() 
  
  common_impl.VisitMapRoom( "nightsville" );

  if not cmn.IsEventDone( "win_pathfind" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
    ObjSet( "obj_int_button_reset_impl", { visible = false } );
    ObjSet( "int_button_reset", { input = false } );

  end;

  private.AnimButterfly();
  
  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  
  if cmn.IsEventDone( "win_pathfind" ) then
    cmn.GotoRoom( "rm_mansion" );
  elseif ( not cmn.IsEventStart( "win_pathfind" ) ) then

    ng_global.progress[ "std" ][ "win_pathfind" ].state = 1;
    ng_global.progress[ "std" ][ "win_pathfind" ].statelvl = { 0,0,0,0,0,0 };

  elseif not private.isplaying then

    local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;
    local play = true;
    for i = 1,private.target_count[state] do

      if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i] == 0 then

        play = false

      end;

    end;

    if play then

      private.isplaying = true;
      private.AnimLight();

    end;

  end;

  interface.InvestigationButtonCheck();

  common_impl.PlayAudio( "env", "common/audio/aud_mg_pathfind_env", 1, "", 0 );

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_pathfind" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

  ObjSet( "int_button_reset", { input = true } );

  common_impl.StopAudio( "env", "common/audio/aud_mg_pathfind_env", 1 );

end;
--*********************************************************************************************************************
function private.AnimLight()

  if private.isplaying and #private.animmas > 0 then

    local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;
    --local spr_number =  private.animmas[math.random( 1, #private.animmas )];
    local spr_number =  private.animmas[1];

    local func_after = function ()

      ObjSet( "spr_pathfind_mg_"..state.."_light_"..spr_number, { input = false } );
      private.AnimLight()

    end;

    local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;
    ObjSet( "spr_pathfind_mg_"..state.."_light_"..spr_number, { input = true } );
    ObjAnimate( "spr_pathfind_mg_"..state.."_light_"..spr_number, "alp", 0, 0, func_after, { 0,3,0, 1,3,1, 2,3,0 });

  end;

end;
--*********************************************************************************************************************
function private.clk_over( spr_number )

  local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;

  ObjSet( "spr_pathfind_mg_"..state.."_over_"..spr_number, { input = false } );
  common_impl.Lock( true );
  local count = 0;
  local func_after = function ()

    table.insert( private.animmas, spr_number );
    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[ spr_number ] = 1;
    for i = 1, private.target_count[ng_global.progress[ "std" ][ "win_pathfind" ].state] do

      if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i] == 1 then

        count = count + 1;

      else 

        break;

      end;

    end;

    if private.target_count[ng_global.progress[ "std" ][ "win_pathfind" ].state] == count then

      for i = 1, count do

        private.animmas[i] = i;

      end;
      private.isplaying = true
      private.AnimLight();

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_".. private.sounds[state][spr_number], 0, "", 0 );

  if private.newpos[ state ] [ spr_number ] then

    if private.newpos[ state ] [ spr_number ][1] == "ang" then

      ObjAnimate( "spr_pathfind_mg_"..state.."_over_"..spr_number, "ang", 0, 0, func_after, { 0,3,0, 1,3,private.newpos[ state ] [ spr_number ][2] });

    elseif private.newpos[ state ] [ spr_number ][1] == "vid" then

      ObjSet( "vid_pathfind_mg_"..state.."_over_"..spr_number, { alp = 0, input = false } );
      ObjSet( "vid_pathfind_mg_"..state.."_over_"..spr_number.."_2", { alp = 1 } );
      VidPlay( "vid_pathfind_mg_"..state.."_over_"..spr_number.."_2", func_after );

    else

      local pos_x = private.newpos[ state ] [ spr_number ][2];
      local pos_y = private.newpos[ state ] [ spr_number ][3];
      local new_pos_x = private.newpos[ state ] [ spr_number ][4];
      local new_pos_y = private.newpos[ state ] [ spr_number ][5];
      ObjAnimate( "spr_pathfind_mg_"..state.."_over_"..spr_number, "pos_xy", 0, 0, func_after, { 0,3,pos_x,pos_y, 1,3,new_pos_x,new_pos_y });

    end;

   else

    ObjAnimate( "spr_pathfind_mg_"..state.."_over_"..spr_number, "alp", 0, 0, func_after, { 0,3,1, 1,3,0 });

  end;

  ObjAnimate( "spr_pathfind_mg_"..state.."_cross_"..spr_number, "color_r", 0, 0, "", { 0,3,1, 0.4,3,0 });
  ObjAnimate( "spr_pathfind_mg_"..state.."_cross_"..spr_number, "color_g", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.clk_over_anim( spr_number )

  local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;

  ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number, { alp = 0, input = false } );
  ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_2", { alp = 1 } );
  common_impl.Lock( true );
  local count = 0;
  local func_after = function ()

    ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_2", { alp = 0 } );
    ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_3", { alp = 1, playing = true } );
    table.insert( private.animmas, spr_number );
    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[ spr_number ] = 1;
    for i = 1, private.target_count[ng_global.progress[ "std" ][ "win_pathfind" ].state] do

      if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i] == 1 then

        count = count + 1;

      else 

        break;

      end;

    end;

    if private.target_count[ng_global.progress[ "std" ][ "win_pathfind" ].state] == count then

      for i = 1, count do

        private.animmas[i] = i;

      end;
      private.isplaying = true
      private.AnimLight();

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_".. private.sounds[state][spr_number], 0, "", 0 );

  AnimPlay( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_2", "DoAnim", func_after );
  ObjAnimate( "spr_pathfind_mg_"..state.."_cross_"..spr_number, "color_r", 0, 0, "", { 0,3,1, 0.4,3,0 });
  ObjAnimate( "spr_pathfind_mg_"..state.."_cross_"..spr_number, "color_g", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.clk_over_animpos( spr_number )

  local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;

  ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number, { alp = 0, input = false } );
  ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_2", { alp = 1 } );
  common_impl.Lock( true );
  local count = 0;
  local func_after = function ()

    local new_pos_x = private.newpos[ state ] [ spr_number ][3];
    local new_pos_y = private.newpos[ state ] [ spr_number ][4];
    ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number, { alp = 1, pos_x = new_pos_x, pos_y = new_pos_y } );
    ObjSet( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_2", { alp = 0 } );
    table.insert( private.animmas, spr_number );
    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[ spr_number ] = 1;
    for i = 1, private.target_count[ng_global.progress[ "std" ][ "win_pathfind" ].state] do

      if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i] == 1 then

        count = count + 1;

      else 

        break;

      end;

    end;

    if private.target_count[ng_global.progress[ "std" ][ "win_pathfind" ].state] == count then

      for i = 1, count do

        private.animmas[i] = i;

      end;
      private.isplaying = true
      private.AnimLight();

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_".. private.sounds[state][spr_number], 0, "", 0 );

  AnimPlay( "anm_pathfind_mg_"..state.."_over_"..spr_number.."_2", "DoAnim", func_after );
  ObjAnimate( "spr_pathfind_mg_"..state.."_cross_"..spr_number, "color_r", 0, 0, "", { 0,3,1, 0.4,3,0 });
  ObjAnimate( "spr_pathfind_mg_"..state.."_cross_"..spr_number, "color_g", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.clk_animlight( spr_number )

  local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;
  local name = "spr_pathfind_mg_"..state.."_light_"..spr_number
  ObjStopAnimate( name, 8 );
  local start_alp = ObjGet( name ).alp
  local time = 1 - start_alp;
  ObjSet( name, { input = false } );
  local func_after = function ()

    common_impl.Lock( false );

    local pos_in_mas = 0;

    if private.animmas[1] == spr_number then
        
      table.remove( private.animmas, 1 );
      if #private.animmas > 0 then

        private.AnimLight()
        ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[ spr_number ] = 2;

      elseif ng_global.progress[ "std" ][ "win_pathfind" ].state ~= 3 then

        private.isplaying = false;
        ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[ spr_number ] = 2;
          --private.changeback();

      else

        private.isplaying = false;
        private.Win()

      end;

    end;

  end;

  local path_number = 1;
  for i = 1,private.target_count[state] do

    if ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i] == 2 then

      path_number = path_number + 1;

    end;

  end;

  if path_number == private.target_count[state] then

    ObjSet( "spr_pathfind_mg_"..state.."_path_end", { input = 1, active = true } );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_light", 0, "", 0 );

  ObjAnimate( "spr_pathfind_mg_"..state.."_light_"..spr_number, "alp", 0, 0, func_after, { 0,3,start_alp, time,3,1 });
  ObjAnimate( "spr_pathfind_mg_"..state.."_light_"..spr_number, "color_r", 0, 0, "", { 0,3,1, time,3,0 });
  ObjAnimate( "spr_pathfind_mg_"..state.."_light_"..spr_number, "color_b", 0, 0, "", { 0,3,1, time,3,0 });
  ObjAnimate( "spr_pathfind_mg_"..state.."_path_"..path_number, "alp", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.changeback()

  common_impl.Lock( true );
  local state = ng_global.progress[ "std" ][ "win_pathfind" ].state + 1;
  local func_after = function ()

    local func_after2 = function ()

      for i = 1,6 do

        ng_global.progress[ "std" ][ "win_pathfind" ].statelvl[i] = 0;

      end;
      ng_global.progress[ "std" ][ "win_pathfind" ].state = state;
      common_impl.Lock( false );

    end;
    
    ObjSet( "spr_pathfind_back", { res = "assets/levels/level3/mg_pathfind/back"..state.."/back" } );
    ObjSet( "obj_pathfind_mg_"..ng_global.progress[ "std" ][ "win_pathfind" ].state, { alp = 0, input = false } );
    ObjSet( "obj_pathfind_mg_"..state, { alp = 1, input = true } );
    ObjAnimate( "mg_pathfind", "alp", 0, 0, func_after2, { 0,3,0, 1,3,1 });

  end;

  common_impl.StopAudio( "sfx", "common/audio/aud_mg_pathfind_butterfly", 0.5 );

  ObjSet( "tmr_pathfind_butterfly", { playing = false } );

  ObjAnimate( "mg_pathfind", "alp", 0, 0, func_after, { 0,3,1, 1,3,0 });


end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  private.animmas = {};
  private.isplaying = false;
  common_impl.Lock( true );
  local func_after = function ()

    local func_after2 = function ()

      for i = 1,6 do

        ng_global.progress[ "std" ][ "win_pathfind" ].statelvl = 0;

      end;
      ng_global.progress[ "std" ][ "win_pathfind" ].state = 1;
      common_impl.Lock( false );

    end;
    
    ObjSet( "spr_pathfind_back", { res = "assets/levels/level3/mg_pathfind/back1/back" } );
    
    local set_table = {};
    for i = 1, 3 do

      for j = 1, private.target_count[i] do

        obj_name = "spr_pathfind_mg_"..i.."_light_"..j;
        obj_name2 = "spr_pathfind_mg_"..i.."_over_"..j;
        obj_name3 = "spr_pathfind_mg_"..i.."_cross_"..j;

        table.insert( set_table, { obj_name, { alp = 0, input = 0 } } )
        table.insert( set_table, { obj_name2, { alp = 1, input = 1 } } )
        table.insert( set_table, { obj_name3, { color_r = 0, color_g = 1 } } )   

      end;

      table.insert( set_table, { "obj_pathfind_mg_"..i, { alp = 0, input = false } } );

    end;

    ObjMultiSet(
      set_table
    );
    ObjSet( "obj_pathfind_mg_1", { alp = 1, input = true } );
    private.isplaying = false;
    ObjAnimate( "mg_pathfind", "alp", 0, 0, func_after2, { 0,3,0, 0.4,3,1 });

  end;

  common_impl.Lock( true );
  ObjAnimate( "mg_pathfind", "alp", 0, 0, func_after, { 0,3,1, 0.4,3,0 });

end;
--*********************************************************************************************************************
function public.Skip()
port.skip_mg = true;
  local state = ng_global.progress[ "std" ][ "win_pathfind" ].state;

  local func_after = function() 

    private.Win();

  end;

  common_impl.Lock( true );

  ObjAnimate( "obj_pathfind_mg_"..state.."_over", "alp", 0, 0, func_after, { 0,3,1, 0.8,3,0, 1.6,3,0 });

  for i = 1,private.target_count[state] do

    obj_name = "spr_pathfind_mg_"..state.."_light_"..i;
    obj_name2 = "spr_pathfind_mg_"..state.."_path_"..i;
    ObjAnimate( obj_name, "alp", 0, 0, "", { 0,3,ObjGet( obj_name ).alp, 0.8,3,ObjGet( obj_name ).alp, 1.6,3,1 });
    ObjAnimate( obj_name2, "alp", 0, 0, "", { 0,3,ObjGet( obj_name ).alp, 0.8,3,ObjGet( obj_name ).alp, 1.6,3,1 });

  end;

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_pathfind" );
  cmn.CallEventHandler( "win_pathfind" );
  common_impl.PassingMgWin();
  cmn.GotoRoom( "rm_mansion" );

end;
--*********************************************************************************************************************
function private.Win()

  --TimerStart( "tmr_pathfind_win", private.WinEnd, 1.0 );
  private.WinEnd()

end;
--*********************************************************************************************************************
function private.AnimButterfly()

  if ng_global.progress[ "std" ][ "win_pathfind" ].state == 1 then

    local chance = math.random( 1,2 );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_butterfly", 0, "", 0 );

    AnimPlay( "anm_pathfind_anim_butterfy_"..chance, "DoAnim", "" );

    ObjSet( "tmr_pathfind_butterfly", { playing = true, time = 15, endtrig = function() private.AnimButterfly() end } );

  end;

end;
--*********************************************************************************************************************
function private.GateMouseEnter( type_cursor, name_obj )

  SetCursor( type_cursor );

  --local alp = ObjGet( name_obj ).alp;
  --local time = 0.3;
  --ObjAnimate( name_obj, "alp", 0, 0, "", 
  --{ 
  --  0.0,              0, alp, 
  --  time*( 1 - alp ), 0, 1
  --} );

end;
--*********************************************************************************************************************
function private.GateMouseLeave( name_obj )

  SetCursor( CURSOR_DEFAULT );
--
--  local alp = ObjGet( name_obj ).alp;
--  local time = 0.3;
--  ObjAnimate( name_obj, "alp", 0, 0, "", 
--  { 
--    0.0,              0, alp, 
--    time*( alp ), 0, 0
--  } );
--
end;
--*********************************************************************************************************************
for i = 1,3 do

  ObjAnimate( "spr_pathfind_mg_"..i.."_path_end", "alp", 1, 0, func_after, { 0,3,0.5, 0.3,3,1, 0.6,3,0.5 });

end;