-- name=mg_pathfind_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_pathfind_scr";
  private.target_count = { 4,6,6 };
  private.target_path = { 4,5,5 };
  private.animflag = false;
  private.animmas = {};

  private.oldpos = { { { "ang", 0 }, { "double_anm" }, { "double_anm" }, { "pos_xy", 490, 404 } }, 
                     { { "anm", -171, 0 }, { "pos_xy", 171, 287 }, { "anm", -171, 0 }, { "anm", -171,0 }, { "vid" }, { "pos_xy", 760, 98 } },
                     { { "pos_xy", 575, 581 }, { "pos_xy", 111, 452 }, { "vid" }, { "pos_xy", 996, 245 }, { "anm", -171, 0 }, { "pos_xy", 674, 412 } }
                   };

  private.newpos = { { { "ang", 0.67 }, nil, nil, { "pos_xy", 490, 404, 432, 406 } }, 
                     { { -171,0, -410, 97 }, { "pos_xy", 171, 287, 54, 294 }, { -171, 0, -261, -3 }, { -171,0, -144, 0 }, { "vid" }, { "pos_xy", 760, 98, 690, 127  } },
                     { { "pos_xy", 575, 581, 624, 589 }, { "pos_xy", 111,452, 166, 465 }, { "vid" }, { "pos_xy", 996, 245, 993, 343 }, { -171,0, -129, 3 }, { "pos_xy", 674, 412, 595, 416  } }
                   };

  private.oldpos_2 = { { { "ang", 0 }, { "pos_xy", 407, 495 }, { "double_anm" }, { "pos_xy", 490, 404 } }, 
                       { { "anm", -171, 0 }, { "pos_xy", 171, 287 }, { "pos_xy", 95, 214 }, {  "pos_xy", 567, 155 }, { "pos_xy", 872, 216 }, { "pos_xy", 760, 98 } },
                       { { "pos_xy", 376, 575 }, { "pos_xy", 111, 452 }, { "vid" }, { "pos_xy", 996, 245 }, { "anm", -86, 54 }, { "pos_xy", 674, 412 } }
                     };

  private.newpos_2 = { { { "ang", -0.83 }, { "pos_xy", 407, 495, 482, 504 }, nil, { "pos_xy", 490, 404, 432, 406 } }, 
                       { { -171,0, -410, 97 }, { "pos_xy", 171, 287, 37, 293 }, { "pos_xy", 95, 214, 20, 223 }, { "pos_xy", 567, 155, 529, 179 }, {  "pos_xy", 872, 216, 823, 221 }, { "pos_xy", 760, 98, 690, 127 } },
                       { { "pos_xy", 376, 575, 445, 593 }, { "pos_xy", 111,452, 166, 465 }, { "vid" }, { "pos_xy", 996, 245, 993, 343 }, { -86, 54, -51, 58 }, { "pos_xy", 674, 412, 595, 416 } }
                     };

  private.oldpos_3 = { { { "ang", 0 }, { "pos_xy", 332, 404 }, { "double_anm" }, { "pos_xy", 736, 393 } }, 
                       { { "anm", -171, 0 }, { "pos_xy", 171, 287 }, { "pos_xy", 346, 151 }, { "anm", -39,-4 }, { "pos_xy", 760, 98 } },
                       { { "anm", -584, -4 }, { "pos_xy", 376, 575 }, { "pos_xy", 111, 452 }, { "vid" }, { "ang", 0 }, { "pos_xy", 674, 412 } }
                     };

  private.newpos_3 = { { { "ang", -0.83 }, { "pos_xy", 332, 404, 378, 433 }, nil, { "pos_xy", 736, 393, 681, 405 } }, 
                       { { -171,0, -410, 97 }, { "pos_xy", 171, 287, 37, 293 }, { "pos_xy", 346, 151, 318, 237 }, { -39,-4, -129, -7 }, { "pos_xy", 760, 98, 690, 127 } },
                       { { -584, -4, -506, -1 }, { "pos_xy", 376, 575, 445, 593 }, { "pos_xy", 111,452, 166, 465 }, { "vid" }, { "ang", 1.47 }, { "pos_xy", 674, 412, 595, 416 } }
                     };


  private.isplaying = false;
  local set_table = {};

  for i = 1, #private.target_count do

    table.insert( set_table, 
                  { "spr_pathfind_scr_mg_"..i.."_path_end", { 
                    event_menter = function() private.GateMouseEnter( CURSOR_UP, "spr_pathfind_scr_mg_"..i.."_path_end" ) end, 
                    event_mleave = function() private.GateMouseLeave( "spr_pathfind_scr_mg_"..i.."_path_end" ) end,
                    event_mdown = function() private.changeback() end } 
                  });    

    table.insert( set_table, 
                  { "spr_pathfind_scr_2_mg_"..i.."_path_end", { 
                    event_menter = function() private.GateMouseEnter( CURSOR_UP, "spr_pathfind_scr_2_mg_"..i.."_path_end" ) end, 
                    event_mleave = function() private.GateMouseLeave( "spr_pathfind_scr_2_mg_"..i.."_path_end" ) end,
                    event_mdown = function() private.changeback() end } 
                  }); 

    table.insert( set_table, 
                  { "spr_pathfind_scr_3_mg_"..i.."_path_end", { 
                    event_menter = function() private.GateMouseEnter( CURSOR_UP, "spr_pathfind_scr_3_mg_"..i.."_path_end" ) end, 
                    event_mleave = function() private.GateMouseLeave( "spr_pathfind_scr_3_mg_"..i.."_path_end" ) end,
                    event_mdown = function() private.changeback() end } 
                  }); 
  end;

  --общий сет подсветки
  for i = 1, #private.target_count do

    for j = 1, private.target_count[i] do

      table.insert( set_table, 
                      { "spr_pathfind_scr_mg_"..i.."_over_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_over( j ) end } });
      table.insert( set_table, { "spr_pathfind_scr_mg_"..i.."_light_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_animlight( j ) end } });

      table.insert( set_table, 
                      { "spr_pathfind_scr_2_mg_"..i.."_over_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_over( j ) end } });
      table.insert( set_table, { "spr_pathfind_scr_2_mg_"..i.."_light_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_animlight( j ) end } });

      table.insert( set_table, 
                      { "spr_pathfind_scr_3_mg_"..i.."_over_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_over( j ) end } });
      table.insert( set_table, { "spr_pathfind_scr_3_mg_"..i.."_light_"..j, { 
                       event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
                       event_mdown = function() private.clk_animlight( j ) end } });

    end;

  end;

  ObjMultiSet( set_table );

  --сэт для перекрывающих первого бэка
  ObjMultiSet( {
    { "anm_pathfind_scr_mg_1_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_anim( 2 ) end } },
    { "spr_pathfind_scr_mg_1_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "anm_pathfind_scr_mg_1_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_anim( 3 ) end } },
    { "spr_pathfind_scr_mg_1_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },

  --перекрывающие первого бэка 2-го варианта
    { "spr_pathfind_scr_2_mg_1_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "spr_pathfind_scr_2_mg_1_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "anm_pathfind_scr_2_mg_1_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_anim( 3 ) end } },
    { "spr_pathfind_scr_2_mg_1_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },

  --перекрывающие первого бэка 3-го варианта
    { "spr_pathfind_scr_3_mg_1_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "spr_pathfind_scr_3_mg_1_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "anm_pathfind_scr_3_mg_1_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_anim( 3 ) end } },
    { "spr_pathfind_scr_3_mg_1_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },

  --сэт для перекрывающих второго бэка
    { "spr_pathfind_scr_mg_2_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "anm_pathfind_scr_mg_2_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 3 ) end } },
    { "anm_pathfind_scr_mg_2_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 1 ) end } },
    { "anm_pathfind_scr_mg_2_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 4 ) end } },
    { "vid_pathfind_scr_mg_2_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 5 ) end } },
    { "spr_pathfind_scr_mg_2_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },


  --сэт для перекрывающих второго бэка 2-го варианта
    { "spr_pathfind_scr_2_mg_2_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "spr_pathfind_scr_2_mg_2_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 3 ) end } },
    { "anm_pathfind_scr_2_mg_2_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 1 ) end } },
    { "spr_pathfind_scr_2_mg_2_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },
    { "spr_pathfind_scr_2_mg_2_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 5 ) end } },
    { "spr_pathfind_scr_2_mg_2_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },


  --сэт для перекрывающих второго бэка 3-го варианта
    { "spr_pathfind_scr_3_mg_2_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "spr_pathfind_scr_3_mg_2_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 3 ) end } },
    { "anm_pathfind_scr_3_mg_2_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 1 ) end } },
    { "anm_pathfind_scr_3_mg_2_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 4 ) end } },
    { "spr_pathfind_scr_3_mg_2_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 5 ) end } },

  --сэт для перекрывающих третьего бэка
    { "spr_pathfind_scr_mg_3_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "spr_pathfind_scr_mg_3_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "vid_pathfind_scr_mg_3_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 3 ) end } },
    { "spr_pathfind_scr_mg_3_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },
    { "anm_pathfind_scr_mg_3_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 5 ) end } },
    { "spr_pathfind_scr_mg_3_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },

  --сэт для перекрывающих третьего бэка 2-го варианта
    { "spr_pathfind_scr_2_mg_3_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 1 ) end } },
    { "spr_pathfind_scr_2_mg_3_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "vid_pathfind_scr_2_mg_3_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 3 ) end } },
    { "spr_pathfind_scr_2_mg_3_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },
    { "anm_pathfind_scr_2_mg_3_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 5 ) end } },
    { "spr_pathfind_scr_2_mg_3_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },

  --сэт для перекрывающих третьего бэка 3-го варианта
    { "anm_pathfind_scr_3_mg_3_over_1", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over_animpos( 1 ) end } },
    { "spr_pathfind_scr_3_mg_3_over_2", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 2 ) end } },
    { "spr_pathfind_scr_3_mg_3_over_3", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 3 ) end } },
    { "vid_pathfind_scr_3_mg_3_over_4", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 4 ) end } },
    { "spr_pathfind_scr_3_mg_3_over_5", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 5 ) end } },
    { "spr_pathfind_scr_3_mg_3_over_6", { 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
      event_mdown = function() private.clk_over( 6 ) end } },
  } );

  private.sounds = { { "log", "tortoise", "raccoon", "bush" }, { "frog", "bush", "heron_1", "owl_1", "crocodile_1", "bush" }, 
                     { "skull", "bush", "crocodile_2", "owl_2", "heron_2", "bush" } };

  private.sounds_2 = { { "bush", "log", "tortoise", "bush" }, { "frog", "bush", "bush", "bush", "bush", "bush" }, 
                       { "skull", "bush", "crocodile_2", "owl_2", "heron_2", "bush" } };

  private.sounds_3 = { { "bush", "log", "raccoon", "bush" }, { "frog", "bush", "bush", "heron_1", "bush" }, 
                       { "heron_2", "skull", "bush", "crocodile_2", "bush", "bush" } };


  local win_pathfind_scr = function ()

    if ( cmn.IsEventDone( "win_pathfind_scr" ) ) then  

    else

      local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
      local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];
      local infix = "";
      if numb == 2 then
        infix = "_2";
      elseif numb == 3 then
        infix = "_3";
      end;

      if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state then

        local paths = 0;
        local gateflag = true;

        local path_res = "assets/levels/level3/mg_pathfind/back"..state.."/back";
        if numb == 2 then
          path_res = "assets/levels/levelscr/mg_pathfind_scr/back"..state.."/back_"..numb;
        elseif numb == 3 then
          path_res = "assets/levels/levelscr/mg_pathfind_scr/back"..state.."/back_"..numb;
        end;
        
        ObjSet( "spr_pathfind_scr_back", { res = path_res } );
        local t_all = #private[ "oldpos"..infix ][ state ];

        for i = 1, t_all do

          local statelvl = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ i ];

          private.animflag = true;
          
          if statelvl == 1 then

            table.insert( private.animmas, i );
            gateflag = false;

          elseif statelvl == 2 then

            paths = paths + 1;

            ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..i, { alp = 0, input = false } );
            ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..i, { alp = 1, color_r = 0, color_b = 0 } );

          else

            gateflag = false;

          end;

          if statelvl ~= 0 then

            if private[ "newpos"..infix ][ state ][ i ] then

              if private[ "newpos"..infix ][ state ][ i ][ 1 ] == "ang" then

                ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..i, { ang = private[ "newpos"..infix ][ state ][ i ][ 2 ], input = false } );

              elseif  private[ "newpos"..infix ][ state ][ i ][ 1 ] == "pos_xy" then

                ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..i, { pos_x = private[ "newpos"..infix ][ state ][ i ][ 4 ], pos_y = private[ "newpos"..infix ][ state ][ i ][ 5 ], input = false } );

              else

                ObjSet( "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..i, { pos_x = private[ "newpos"..infix ][ state ][ i ][ 3 ], pos_y = private[ "newpos"..infix ][ state ][ i ][ 4 ], input = false } );

              end;

            else

              ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..i, { alp = 0, input = false } );   

            end;

            ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..i, { color_g = 1, color_r = 0 } );

          end;

        end;

        if gateflag then
                     
          ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_path_end" , { input = true, active = true } ); 

        end;

        for i = 1, paths do

          ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_path_"..i, { alp = 1 } );

        end;

      end;

      if numb == 1 then

        if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 1 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 2 ] ~= 0 then

            ObjSet( "anm_pathfind_scr_mg_1_over_2_3", { alp = 1, playing = true } );
            ObjDetach( "anm_pathfind_scr_mg_1_over_2" );

          end;

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 3 ] ~= 0 then

            ObjSet( "anm_pathfind_scr_mg_1_over_3_3", { alp = 1, playing = true } );
            ObjDetach( "anm_pathfind_scr_mg_1_over_3" );

          end;

        elseif ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 2 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 5 ] ~= 0 then

            ObjDetach( "vid_pathfind_scr_mg_2_over_5" );

          end;

        elseif ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 3 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 3 ] ~= 0 then

            ObjSet( "vid_pathfind_scr_mg_3_over_3_2", { alp = 0, playing = false } );
            ObjSet( "vid_pathfind_scr_mg_3_over_3",   { alp = 1, playing = true  } );
            ObjDetach( "vid_pathfind_scr_mg_3_over_3" );          

          end;
        
        end;      

      elseif numb == 2 then

        if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 1 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 3 ] ~= 0 then

            ObjSet( "anm_pathfind_scr_2_mg_1_over_3_3", { alp = 1, playing = true } );
            ObjDetach( "anm_pathfind_scr_2_mg_1_over_3" );

          end;

        elseif ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 3 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 3 ] ~= 0 then

            ObjSet( "vid_pathfind_scr_2_mg_3_over_3_2", { alp = 0, playing = false } );
            ObjSet( "vid_pathfind_scr_2_mg_3_over_3",   { alp = 1, playing = true  } );
            ObjDetach( "vid_pathfind_scr_2_mg_3_over_3" );

          end;
        
        end;

      elseif numb == 3 then

        if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 1 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 3 ] ~= 0 then

            ObjSet( "anm_pathfind_scr_3_mg_1_over_3_3", { alp = 1, playing = true } );
            ObjDetach( "anm_pathfind_scr_3_mg_1_over_3" );

          end;

        elseif ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 3 then

          if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ 4 ] ~= 0 then

            ObjSet( "vid_pathfind_scr_3_mg_3_over_4_2", { alp = 0, playing = false } );
            ObjSet( "vid_pathfind_scr_3_mg_3_over_4",   { alp = 1, playing = true  } );
            ObjDetach( "vid_pathfind_scr_3_mg_3_over_4" );          

          end;
        
        end;         

      end;

      if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state > 1 then 

        for i = 1, ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state - 1 do

          ObjDetach( "obj_pathfind_scr"..infix.."_mg_"..i );

        end;

      end;

      ObjSet( "obj_pathfind_scr"..infix.."_mg_"..ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state, { alp = 1, input = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pathfind_scr", win_pathfind_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open() 
  
  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if not cmn.IsEventDone( "win_pathfind_scr" ) then

    cmn.MiniGameShow();
    --common_impl.PassingMgStart();

    local set_table = {};
    table.insert( set_table, { "obj_int_button_reset_impl", { visible = false } } );  
    table.insert( set_table, { "int_button_reset", { input = false } } );  
    ObjMultiSet( set_table );

    int_button_timer.Show();

  end;

  if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state == 1 then

    private.AnimButterfly();

  end;

  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_pathfind_scr" ) and cmn.IsEventStart( "win_pathfind_scr" )  then

    private.animmas = {};
    private.isplaying = false;
    
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].start = 0;

    is_repeat = true;

  end; 

  if ( not cmn.IsEventStart( "win_pathfind_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state = 1;
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl = { 0,0,0,0,0,0 };
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].timer = { default = 70, time = 70, diff = 20, extra = 0 };
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb = { 1, 1, 1 }

    private.ResetInit();

  elseif not private.isplaying then

    local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
    local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

    local infix = "";
    if numb == 2 then
      infix = "_2";
    elseif numb == 3 then
      infix = "_3";
    end;

    local play = true;
    local t_all = #private[ "oldpos"..infix ][ state ];
    for i = 1, t_all do

      if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[i] == 0 then

        play = false

      end;

    end;

    if play then

      private.isplaying = true;
      private.AnimLight();

    end;

  end;

  interface.InvestigationButtonCheck();

  common_impl.PlayAudio( "env", "common/audio/aud_mg_pathfind_env", 1, "", 0 );

  local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

  local infix = "";
  if numb == 2 then
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  local set_table = {};

  for i = 1, 3 do

    table.insert( set_table, { "obj_pathfind_scr_3_mg_"..i, { alp = 0, input = false } } );  
    table.insert( set_table, { "obj_pathfind_scr_2_mg_"..i, { alp = 0, input = false } } );  
    table.insert( set_table, { "obj_pathfind_scr_mg_"..i,   { alp = 0, input = false } } );

  end;

  local path_res = "assets/levels/level3/mg_pathfind/back"..state.."/back";
  if numb == 2 or numb == 3 then
    path_res = "assets/levels/levelscr/mg_pathfind_scr/back"..state.."/back"..infix;
  end;

  table.insert( set_table, { "spr_pathfind_scr_back", { res = path_res } } );

  ObjMultiSet( set_table );

  ObjSet( "obj_pathfind_scr"..infix.."_mg_"..state, { alp = 1, input = true } );

  if is_repeat then
 
    public.ResetStart();

  end;

end;
--*********************************************************************************************************************
function public.Close()

  --

end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_pathfind_scr" ) then

    cmn.MiniGameHide();
    --common_impl.PassingMgStop();

  end;

  ObjSet( "int_button_reset", { input = true } );
  int_button_timer.Hide();

  common_impl.StopAudio( "env", "common/audio/aud_mg_pathfind_env", 1 );

end;
--*********************************************************************************************************************
function private.AnimLight()

  if private.isplaying and #private.animmas > 0 then

    local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
    local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

    local infix = "";
    if numb == 2 then
      infix = "_2";
    elseif numb == 3 then
      infix = "_3";
    end;

    local spr_number =  private.animmas[1];

    local func_after = function ()

      ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number, { input = false } );
      private.AnimLight()

    end;

    ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number, { input = true } );
    ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number, "alp", 0, 0, func_after, { 0,3,0, 1,3,1, 2,3,0 });

  end;

end;
--*********************************************************************************************************************
function private.clk_over( spr_number )

  local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

  local infix = "";
  if numb == 2 then
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, { input = false } );
  common_impl.Lock( true );

  local func_after = function ()

    local count = 0;
    table.insert( private.animmas, spr_number );
    common_impl.Lock( false );
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ spr_number ] = 1;           
    local t_all = #private[ "oldpos"..infix ][ state ];

    for i = 1, t_all do

      if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[i] == 1 then

        count = count + 1;

      else 

        break;

      end;

    end;

    if t_all == count then

      for i = 1, count do

        private.animmas[i] = i;

      end;
      private.isplaying = true
      private.AnimLight();

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_"..private[ "sounds"..infix ][state][spr_number], 0, "", 0 );

  if private[ "newpos"..infix ][ state ] [ spr_number ] then

    if private[ "newpos"..infix ][ state ] [ spr_number ][1] == "ang" then

      ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, "ang", 0, 0, func_after, { 0,3,0, 1,3,private[ "newpos"..infix ][ state ] [ spr_number ][2] });

    elseif private[ "newpos"..infix ][ state ] [ spr_number ][1] == "vid" then

      ObjSet( "vid_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, { alp = 0, input = false } );
      ObjSet( "vid_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", { alp = 1 } );
      VidPlay( "vid_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", func_after );

    else

      local pos_x = private[ "newpos"..infix ][ state ] [ spr_number ][2];
      local pos_y = private[ "newpos"..infix ][ state ] [ spr_number ][3];
      local new_pos_x = private[ "newpos"..infix ][ state ] [ spr_number ][4];
      local new_pos_y = private[ "newpos"..infix ][ state ] [ spr_number ][5];
      ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, "pos_xy", 0, 0, func_after, { 0,3,pos_x,pos_y, 1,3,new_pos_x,new_pos_y } );

    end;

   else

    ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, "alp", 0, 0, func_after, { 0,3,1, 1,3,0 });

  end;

  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..spr_number, "color_r", 0, 0, "", { 0,3,1, 0.4,3,0 });
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..spr_number, "color_g", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.clk_over_anim( spr_number )

  local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

  local infix = "";
  if numb == 2 then
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  local set_table = {};
  table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, { alp = 0, input = false } } );  
  table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", { alp = 1 } } );  
  ObjMultiSet( set_table );

  common_impl.Lock( true );

  local func_after = function ()

    local count = 0;

    local set_table = {};
    table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", { alp = 0 } } );  
    table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_3", { alp = 1, playing = true } } );  
    ObjMultiSet( set_table );

    table.insert( private.animmas, spr_number );
    common_impl.Lock( false );
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ spr_number ] = 1;
    local t_all = #private[ "oldpos"..infix ][ state ];

    for i = 1, t_all do

      if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ i ] == 1 then

        count = count + 1;

      else 

        break;

      end;

    end;

    if t_all == count then

      for i = 1, count do

        private.animmas[i] = i;

      end;
      private.isplaying = true
      private.AnimLight();

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_".. private[ "sounds"..infix ][state][spr_number], 0, "", 0 );

  AnimPlay( "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", "DoAnim", func_after );
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..spr_number, "color_r", 0, 0, "", { 0,3,1, 0.4,3,0 });
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..spr_number, "color_g", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.clk_over_animpos( spr_number )

  local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

  local infix = "";
  if numb == 2 then
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  local set_table = {};
  table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, { alp = 0, input = false } } );  
  table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", { alp = 1 } } );  
  ObjMultiSet( set_table );

  common_impl.Lock( true );

  local func_after = function ()

    local count = 0;
    local new_pos_x = private[ "newpos"..infix ][ state ] [ spr_number ][3];
    local new_pos_y = private[ "newpos"..infix ][ state ] [ spr_number ][4];

    local set_table = {};
    table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number, { alp = 1, pos_x = new_pos_x, pos_y = new_pos_y } } );  
    table.insert( set_table, { "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", { alp = 0 } } );  
    ObjMultiSet( set_table );

    table.insert( private.animmas, spr_number );
    common_impl.Lock( false );
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ spr_number ] = 1;
    local t_all = #private[ "oldpos"..infix ][ state ];

    for i = 1, t_all do

      if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[i] == 1 then

        count = count + 1;

      else 

        break;

      end;

    end;

    if t_all == count then

      for i = 1, count do

        private.animmas[i] = i;

      end;
      private.isplaying = true
      private.AnimLight();

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_".. private[ "sounds"..infix ][state][spr_number], 0, "", 0 );

  AnimPlay( "anm_pathfind_scr"..infix.."_mg_"..state.."_over_"..spr_number.."_2", "DoAnim", func_after );
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..spr_number, "color_r", 0, 0, "", { 0,3,1, 0.4,3,0 });
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_cross_"..spr_number, "color_g", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.clk_animlight( spr_number )

  local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state;
  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];

  local infix = "";
  if numb == 2 then
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  local name = "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number
  ObjStopAnimate( name, 8 );
  local start_alp = ObjGet( name ).alp
  local time = 1 - start_alp;
  ObjSet( name, { input = false } );
  local func_after = function ()

    common_impl.Lock( false );

    local pos_in_mas = 0;

    if private.animmas[1] == spr_number then
        
      table.remove( private.animmas, 1 );
      if #private.animmas > 0 then

        private.AnimLight()
        ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ spr_number ] = 2;

      elseif ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state ~= 3 then

        private.isplaying = false;
        ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ spr_number ] = 2;

      else

        private.isplaying = false;
        private.Win()

      end;

    end;

  end;

  local path_number = 1;
  local t_all = #private[ "oldpos"..infix ][ state ];

  for i = 1, t_all do

    if ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[i] == 2 then

      path_number = path_number + 1;

    end;

  end;

  if path_number == t_all then

    ObjSet( "spr_pathfind_scr"..infix.."_mg_"..state.."_path_end", { input = 1, active = true } );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_light", 0, "", 0 );

  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number, "alp", 0, 0, func_after, { 0,3,start_alp, time,3,1 });
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number, "color_r", 0, 0, "", { 0,3,1, time,3,0 });
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_light_"..spr_number, "color_b", 0, 0, "", { 0,3,1, time,3,0 });
  ObjAnimate( "spr_pathfind_scr"..infix.."_mg_"..state.."_path_"..path_number, "alp", 0, 0, "", { 0,3,0, 0.4,3,1 });

end;
--*********************************************************************************************************************
function private.changeback()

  common_impl.Lock( true );
  local state = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state + 1;

  local func_after = function ()

    local func_after2 = function ()

      for i = 1,6 do

        ng_global.progress[ "scr" ][ "win_pathfind_scr" ].statelvl[ i ] = 0;

      end;
      ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state = state;
      common_impl.Lock( false );

    end;

    local path_res = "assets/levels/level3/mg_pathfind/back"..state.."/back";
    local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ state ];
    local infix = "";
    if numb == 2 or numb == 3 then
      infix = "_"..numb;
      path_res = "assets/levels/levelscr/mg_pathfind_scr/back"..state.."/back"..infix;
    end;
    
    local set_table = {};
    table.insert( set_table, { "spr_pathfind_scr_back", { res = path_res } } );  
    table.insert( set_table, { "obj_pathfind_scr_mg_"..ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state, { alp = 0, input = false } } );  
    table.insert( set_table, { "obj_pathfind_scr_2_mg_"..ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state, { alp = 0, input = false } } );  
    table.insert( set_table, { "obj_pathfind_scr_3_mg_"..ng_global.progress[ "scr" ][ "win_pathfind_scr" ].state, { alp = 0, input = false } } );  
    table.insert( set_table, { "obj_pathfind_scr"..infix.."_mg_"..state, { alp = 1, input = true } } );  
    ObjMultiSet( set_table );

    ObjAnimate( "mg_pathfind_scr", "alp", 0, 0, func_after2, { 0,3,0, 1,3,1 });

  end;

  ObjAnimate( "mg_pathfind_scr", "alp", 0, 0, func_after, { 0,3,1, 1,3,0 });

  ObjSet( "tmr_pathfind_scr_butterfly",   { playing = false } );
  ObjSet( "tmr_pathfind_scr_2_butterfly", { playing = false } );
  ObjSet( "tmr_pathfind_scr_3_butterfly", { playing = false } );

end;
--*********************************************************************************************************************
function private.ResetInit()

  for i = 1, 3 do

    local numb = math.random( 1, 3 );
    ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ i ] = numb;

  end;

end;
--*********************************************************************************************************************
function public.Reset()

--

end;
--*********************************************************************************************************************
function public.ResetStart()

  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ 1 ];
  local path_res = "assets/levels/level3/mg_pathfind/back1/back";

  local infix = "";
  if numb == 2 or numb == 3 then
    infix = "_"..numb;
    path_res = "assets/levels/levelscr/mg_pathfind_scr/back1/back"..infix;
  end;

  local set_table = {};

  ObjAttach( "anm_pathfind_scr_mg_1_over_2", "obj_pathfind_scr_mg_1_over" );
  ObjAttach( "anm_pathfind_scr_mg_1_over_3", "obj_pathfind_scr_mg_1_over" );
  ObjAttach( "vid_pathfind_scr_mg_2_over_5", "obj_pathfind_scr_mg_2_over" );
  ObjAttach( "vid_pathfind_scr_mg_3_over_3", "obj_pathfind_scr_mg_3_over" );
  ObjAttach( "anm_pathfind_scr_2_mg_1_over_3", "obj_pathfind_scr_2_mg_1_over" );
  ObjAttach( "anm_pathfind_scr_3_mg_1_over_3", "obj_pathfind_scr_3_mg_1_over" );
  ObjAttach( "vid_pathfind_scr_3_mg_3_over_4", "obj_pathfind_scr_3_mg_3_over" );

  ObjAttach( "vid_pathfind_scr_2_mg_3_over_3", "obj_pathfind_scr_2_mg_3_over" );
  
  table.insert( set_table, { "vid_pathfind_scr_2_mg_3_over_3", { alp = 1, playing = true, input = true } } ); 
  table.insert( set_table, { "vid_pathfind_scr_2_mg_3_over_3_2", { alp = 0, playing = false } } );
  table.insert( set_table, { "spr_pathfind_scr"..infix.."_back", { res = path_res } } );

  for i = 1, #private.target_count do

    local t_all = #private[ "oldpos"..infix ][ i ];
    for j = 1, t_all do

      table.insert( set_table, { "spr_pathfind_scr_mg_"..i.."_over_"..j,  { alp = 1, input = true } } );  
      table.insert( set_table, { "spr_pathfind_scr_mg_"..i.."_light_"..j, { alp = 0, input = false } } );  
      table.insert( set_table, { "spr_pathfind_scr_2_mg_"..i.."_over_"..j,  { alp = 1, input = true } } );  
      table.insert( set_table, { "spr_pathfind_scr_2_mg_"..i.."_light_"..j, { alp = 0, input = false } } );  
      table.insert( set_table, { "spr_pathfind_scr_3_mg_"..i.."_over_"..j,  { alp = 1, input = true } } );  
      table.insert( set_table, { "spr_pathfind_scr_3_mg_"..i.."_light_"..j, { alp = 0, input = false } } );  

    end;
  end;

  for i = 1, #private.target_path do

    for j = 1, private.target_path[ i ] do

      table.insert( set_table, { "spr_pathfind_scr_mg_"..i.."_path_"..j, { alp = 0 } } );  
      table.insert( set_table, { "spr_pathfind_scr_2_mg_"..i.."_path_"..j, { alp = 0 } } );  
      table.insert( set_table, { "spr_pathfind_scr_3_mg_"..i.."_path_"..j, { alp = 0 } } );  

    end;

    table.insert( set_table, { "spr_pathfind_scr_mg_"..i.."_path_end", { alp = 0, active = false, input = false } } );  
    table.insert( set_table, { "spr_pathfind_scr_2_mg_"..i.."_path_end", { alp = 0, active = false, input = false } } );  
    table.insert( set_table, { "spr_pathfind_scr_3_mg_"..i.."_path_end", { alp = 0, active = false, input = false } } );  

  end;

  table.insert( set_table, { "spr_pathfind_scr_3_mg_3_path_6", { alp = 0 } } );  
  ObjMultiSet( set_table );
-------------------------------------
-------------------------------------

  set_table = {};
  for nn = 1, 3 do

    local postfix = "";
    if nn == 2 then 
      postfix = "_2";
    elseif nn == 3 then 
      postfix = "_3";
    end;

    for level = 1, #private[ "oldpos"..postfix ] do

      for over = 1, #private[ "oldpos"..postfix ][ level ] do

        if private[ "oldpos"..postfix ][ level ][ over ] then

          if private[ "oldpos"..postfix ][ level ][ over ][ 1 ] == "ang" then

            table.insert( set_table, { "spr_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over, { ang = private[ "oldpos"..postfix ][ level ][ over ][ 2 ] } } );  

          elseif private[ "oldpos"..postfix ][ level ][ over ][ 1 ] == "anm" then

            table.insert( set_table, { "anm_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over, { pos_x = private[ "oldpos"..postfix ][ level ][ over ][ 2 ], pos_y = private[ "oldpos"..postfix ][ level ][ over ][ 3 ], input = true } } );  

          elseif private[ "oldpos"..postfix ][ level ][ over ][ 1 ] == "pos_xy" then

            table.insert( set_table, { "spr_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over, { pos_x = private[ "oldpos"..postfix ][ level ][ over ][ 2 ], pos_y = private[ "oldpos"..postfix ][ level ][ over ][ 3 ] } } );

          elseif private[ "oldpos"..postfix ][ level ][ over ][ 1 ] == "vid" then

            table.insert( set_table, { "vid_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over,       { playing = true,  alp = 1, input = true } } );
            table.insert( set_table, { "vid_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over.."_2", { playing = false, alp = 0 } } );

          elseif private[ "oldpos"..postfix ][ level ][ over ][ 1 ] == "double_anm" then

            table.insert( set_table, { "anm_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over,       { playing = true,  alp = 1, input = true } } );
            table.insert( set_table, { "anm_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over.."_2", { playing = false, alp = 0 } } );
            table.insert( set_table, { "anm_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over.."_3", { playing = false, alp = 0 } } );

            ObjAttach( "anm_pathfind_scr"..postfix.."_mg_"..level.."_over_"..over.."_3", "obj_pathfind_scr_"..postfix.."_mg_"..level.."_over" );
          
          end;

        end;

        table.insert( set_table, { "spr_pathfind_scr"..postfix.."_mg_"..level.."_cross_"..over, { color_r = 1, color_g = 0 } } );

      end;

      ObjAttach( "obj_pathfind_scr"..postfix.."_mg_"..level, private.room_objname );
      table.insert( set_table, { "obj_pathfind_scr"..postfix.."_mg_"..level, { alp = 0, input = false } } );

    end;

    table.insert( set_table, { "obj_pathfind_scr"..postfix.."_mg_1", { alp = 0, input = false } } );

  end;

  table.insert( set_table, { "obj_pathfind_scr"..infix.."_mg_1", { alp = 1, input = true } } );
  ObjMultiSet( set_table );

end;
--*********************************************************************************************************************
function public.Skip()

--

end;
--*********************************************************************************************************************
function private.WinEnd()

  common_impl.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_pathfind_scr" );
  cmn.CallEventHandler( "win_pathfind_scr" );
  --common_impl.PassingMgWin();
  
  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd()

end;
--*********************************************************************************************************************
function private.AnimButterfly()

  local chance = math.random( 1,2 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pathfind_butterfly", 0, "", 0 );
  
  local numb = ng_global.progress[ "scr" ][ "win_pathfind_scr" ].numb[ 1 ];
  local infix = "";
  if numb == 2 or numb == 3 then
    infix = "_"..numb;
  end;
  
  AnimPlay( "anm_pathfind_scr"..infix.."_anim_butterfy_"..chance, "DoAnim", "" );

  ObjSet( "tmr_pathfind_scr"..infix.."_butterfly", { playing = true, time = 15, endtrig = function() private.AnimButterfly() end } );

end;
--*********************************************************************************************************************
function private.GateMouseEnter( type_cursor, name_obj )

  SetCursor( type_cursor );

end;
--*********************************************************************************************************************
function private.GateMouseLeave( name_obj )

  SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
for i = 1,3 do

  ObjAnimate( "spr_pathfind_scr_mg_"..i.."_path_end", "alp", 1, 0, func_after, { 0,3,0.5, 0.3,3,1, 0.6,3,0.5 });
  ObjAnimate( "spr_pathfind_scr_2_mg_"..i.."_path_end", "alp", 1, 0, func_after, { 0,3,0.5, 0.3,3,1, 0.6,3,0.5 });
end;