-- name=rm_mysteryroom
--*********************************************************************************************************************
-- function *** INIT *** () end;
--*********************************************************************************************************************
  function public.Init()
    --------------------------------------------------------------------------------------------
    private.room_objname = "rm_mysteryroom";
    private.double_click = false;
    private.double_click_name = "";
    private.time_double = 0.4;--время отклика для двойного клика открытия папки
    private.count_done = { mg = 6, ho = 6 };
    private.k_pos = 0;
    --------------------------------------------------------------------------------------------
    private.slider_pos = { -119, 49 };--граничные позиции слайдера по Y
    private.text_pos = { 30, -160 };
    --------------------------------------------------------------------------------------------
    --ObjAttach( "zz_bridge_4", "room_hub" );
    private.Init_Subroom();
    
    private.table_multiset = {
      { "spr_mysteryroom_frame_bernadette_1", { alp = 0 } },
      { "spr_mysteryroom_frame_bernadette_2", { alp = 0 } },
      { "spr_mysteryroom_frame_lorrain_1", { alp = 0 } },
      { "spr_mysteryroom_frame_lorrain_2", { alp = 0 } },
      { "spr_mysteryroom_frame_mary_1", { alp = 0 } },
      { "spr_mysteryroom_frame_mary_2", { alp = 0 } },
      { "spr_mysteryroom_frame_oldman_1", { alp = 0 } },
      { "spr_mysteryroom_frame_oldman_2", { alp = 0 } },
      { "spr_mysteryroom_frame_oliver_1", { alp = 0 } },
      { "spr_mysteryroom_frame_oliver_2", { alp = 0 } },
      { "spr_mysteryroom_frame_sam_1", { alp = 0 } },
      { "spr_mysteryroom_frame_sam_2", { alp = 0 } },

      { "spr_mysteryroom_frame_bernadette_1_1", { alp = 0 } },
      { "spr_mysteryroom_frame_bernadette_2_1", { alp = 0 } },
      { "spr_mysteryroom_frame_lorrain_1_1", { alp = 0 } },
      { "spr_mysteryroom_frame_lorrain_2_1", { alp = 0 } },
      { "spr_mysteryroom_frame_mary_1_1", { alp = 0 } },
      { "spr_mysteryroom_frame_mary_2_1", { alp = 0 } },
      { "spr_mysteryroom_frame_oldman_1_1", { alp = 0 } },
      { "spr_mysteryroom_frame_oldman_2_1", { alp = 0 } },
      { "spr_mysteryroom_frame_oliver_1_1", { alp = 0 } },
      { "spr_mysteryroom_frame_oliver_2_1", { alp = 0 } },
      { "spr_mysteryroom_frame_sam_1_1", { alp = 0 } },
      { "spr_mysteryroom_frame_sam_2_1", { alp = 0 } },
    };
    
    private.name_frame = "";
    private.frame = {
      [ "bernadette_1" ] = { time = 6.0, loc = "mg_pathfind_scr" },
      [ "bernadette_2" ] = { time = 8.0, loc = "ho_littlehouse_scr" },
      [ "lorrain_1" ] = { time = 8.0, loc = "mg_key_scr" },
      [ "lorrain_2" ] = { time = 6.0, loc = "ho_stock_scr" },
      [ "mary_1" ] = { time = 5.0, loc = "mg_uppershelf_scr" },
      [ "mary_2" ] = { time = 6.0, loc = "ho_trash_scr" },
      [ "oldman_1" ] = { time = 7.0, loc = "mg_bottles_scr" },
      [ "oldman_2" ] = { time = 9.0, loc = "ho_hos_scr" },
      [ "oliver_1" ] = { time = 7.0, loc = "mg_safe_scr" },
      [ "oliver_2" ] = { time = 7.0, loc = "ho_ladder_scr" },
      [ "sam_1" ] = { time = 10.0, loc = "mg_gate_scr" },
      [ "sam_2" ] = { time = 6.0, loc = "ho_intreehole_scr" }
    };
    
    private.frame_win = {
      [ "bernadette_1_1" ] = { time = 5.0, loc = "mg_pathfind_scr" },
      [ "bernadette_2_1" ] = { time = 4.0, loc = "ho_littlehouse_scr" },
      [ "lorrain_1_1" ] = { time = 3.0, loc = "mg_key_scr" },
      [ "lorrain_2_1" ] = { time = 3.0, loc = "ho_stock_scr" },
      [ "mary_1_1" ] = { time = 3.0, loc = "mg_uppershelf_scr" },
      [ "mary_2_1" ] = { time = 3.0, loc = "ho_trash_scr" },
      [ "oldman_1_1" ] = { time = 4.0, loc = "mg_bottles_scr" },
      [ "oldman_2_1" ] = { time = 6.0, loc = "ho_hos_scr" },
      [ "oliver_1_1" ] = { time = 3.0, loc = "mg_safe_scr" },
      [ "oliver_2_1" ] = { time = 3.0, loc = "ho_ladder_scr" },
      [ "sam_1_1" ] = { time = 3.0, loc = "mg_gate_scr" },
      [ "sam_2_1" ] = { time = 3.0, loc = "ho_intreehole_scr" }
    };  

    ObjMultiSet( { 
      {
        "spr_mysteryroom_envelope", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_envelope" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_envelope" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_envelope" ) end
        }
      },
      {
        "spr_mysteryroom_button_dossier_unlock", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_button_dossier_unlock" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_button_dossier_unlock" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_button_dossier_unlock" ) end
        }
      },
      {
        "spr_mysteryroom_icon_bernadette_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_bernadette_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_bernadette_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_bernadette_1" ) end
        }
      },
      {
        "spr_mysteryroom_icon_bernadette_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_bernadette_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_bernadette_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_bernadette_2" ) end
        }
      },
      {
        "spr_mysteryroom_icon_lorrain_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_lorrain_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_lorrain_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_lorrain_1" ) end
        }
      },
      {
        "spr_mysteryroom_icon_lorrain_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_lorrain_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_lorrain_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_lorrain_2" ) end
        }
      },
      {
        "spr_mysteryroom_icon_mary_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_mary_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_mary_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_mary_1" ) end
        }
      },
      {
        "spr_mysteryroom_icon_mary_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_mary_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_mary_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_mary_2" ) end
        }
      },
      {
        "spr_mysteryroom_icon_oldman_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_oldman_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_oldman_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_oldman_1" ) end
        }
      },
      {
        "spr_mysteryroom_icon_oldman_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_oldman_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_oldman_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_oldman_2" ) end
        }
      },
      {
        "spr_mysteryroom_icon_oliver_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_oliver_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_oliver_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_oliver_1" ) end
        }
      },
      {
        "spr_mysteryroom_icon_oliver_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_oliver_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_oliver_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_oliver_2" ) end
        }
      },
      {
        "spr_mysteryroom_icon_sam_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_sam_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_sam_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_sam_1" ) end
        }
      },
      {
        "spr_mysteryroom_icon_sam_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_sam_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_sam_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_sam_2" ) end
        }
      },
      {
        "spr_mysteryroom_folder_providence_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_folder_providence_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_folder_providence_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_folder_providence_1" ) end
        }
      },
      {
        "spr_mysteryroom_folder_providence_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_folder_providence_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_folder_providence_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_folder_providence_2" ) end
        }
      },
      {
        "spr_mysteryroom_folder_providence_3", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_folder_providence_3" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_folder_providence_3" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_folder_providence_3" ) end
        }
      },
      {
        "spr_mysteryroom_folder_providence_4", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_folder_providence_4" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_folder_providence_4" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_folder_providence_4" ) end
        }
      },
      {
        "spr_mysteryroom_button_yes", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_button_yes" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_button_yes" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_button_yes" ) end
        }
      },
      {
        "spr_mysteryroom_button_no", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_button_no" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_button_no" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_button_no" ) end
        }
      },
      {
        "txt_mysteryroom_player_skip", 
        { 
          event_mdown =  function () private.ButtonDown( "txt_mysteryroom_player_skip" ) end,
          event_menter = function () private.ButtonEnter( "txt_mysteryroom_player_skip" ) end,
          event_mleave = function () private.ButtonLeave( "txt_mysteryroom_player_skip" ) end
        }
      },
      {
        "obj_mysteryroom_button_dossier", 
        { 
          event_mdown =  function () private.ButtonDown( "obj_mysteryroom_button_dossier" ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end
        }
      },
      {
        "spr_mysteryroom_icon_help", 
        { 
          event_mdown =  function () private.ButtonDown( "help" ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end
        }
      },
      {
        "spr_mysteryroom_icon_providence", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_icon_providence" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_icon_providence" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_icon_providence" ) end
        }
      },
      {
        "spr_mysteryroom_folder_ho", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_folder_ho" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_folder_ho" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_folder_ho" ) end
        }
      },
      {
        "spr_mysteryroom_folder_mg", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_folder_mg" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_folder_mg" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_folder_mg" ) end
        }
      },
      {
        "spr_mysteryroom_dossier_inside_1", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_dossier_inside_1" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_dossier_inside_1" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_dossier_inside_1" ) end
        }
      },
      {
        "spr_mysteryroom_dossier_inside_2", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_dossier_inside_2" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_dossier_inside_2" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_dossier_inside_2" ) end
        }
      },
      {
        "spr_mysteryroom_dossier_inside_3", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_dossier_inside_3" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_dossier_inside_3" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_dossier_inside_3" ) end
        }
      },
      {
        "spr_mysteryroom_btn_exit", 
        { 
          event_mdown =  function () private.ButtonDown( "spr_mysteryroom_btn_exit" ) end,
          event_menter = function () private.ButtonEnter( "spr_mysteryroom_btn_exit" ) end,
          event_mleave = function () private.ButtonLeave( "spr_mysteryroom_btn_exit" ) end
        }
      },
      --{
      --  "obj_mysteryroom_psefolder_1", 
      --  { 
      --    event_startdrag =  function () private.PsefolderStartDrag() end,
      --    event_dragdrop = function () private.PsefolderDragDrop( "obj_mysteryroom_psefolder_1" ) end,
      --    event_drag = function () private.PsefolderDrag( "obj_mysteryroom_psefolder_1" ) end
      --  }
      --},
      --{
      --  "obj_mysteryroom_psefolder_2", 
      --  { 
      --    event_startdrag =  function () private.PsefolderStartDrag() end,
      --    event_dragdrop = function () private.PsefolderDragDrop( "obj_mysteryroom_psefolder_2" ) end,
      --    event_drag = function () private.PsefolderDrag( "obj_mysteryroom_psefolder_2" ) end
      --  }
      --},
      --{
      --  "obj_mysteryroom_psefolder_3", 
      --  { 
      --    event_startdrag =  function () private.PsefolderStartDrag() end,
      --    event_dragdrop = function () private.PsefolderDragDrop( "obj_mysteryroom_psefolder_3" ) end,
      --    event_drag = function () private.PsefolderDrag( "obj_mysteryroom_psefolder_3" ) end
      --  }
      --},
      --{
      --  "obj_mysteryroom_psefolder_4", 
      --  { 
      --    event_startdrag =  function () private.PsefolderStartDrag() end,
      --    event_dragdrop = function () private.PsefolderDragDrop( "obj_mysteryroom_psefolder_4" ) end,
      --    event_drag = function () private.PsefolderDrag( "obj_mysteryroom_psefolder_4" ) end
      --  }
      --},
      {
        "obj_mysteryroom_dossier_1_slider", 
        { 
          event_startdrag =  function () private.SliderStartDrag() end,
          event_dragdrop = function () private.SliderDragDrop( "dossier_1" ) end,
          event_drag = function () private.SliderDrag( "dossier_1" ) end
        }
      },
      {
        "obj_mysteryroom_dossier_2_slider", 
        { 
          event_startdrag =  function () private.SliderStartDrag() end,
          event_dragdrop = function () private.SliderDragDrop( "dossier_2" ) end,
          event_drag = function () private.SliderDrag( "dossier_2" ) end
        }
      },
      {
        "obj_mysteryroom_dossier_3_slider", 
        { 
          event_startdrag =  function () private.SliderStartDrag() end,
          event_dragdrop = function () private.SliderDragDrop( "dossier_3" ) end,
          event_drag = function () private.SliderDrag( "dossier_3" ) end
        }
      },
      { "obj_mysteryroom_folder_close",   { event_mdown =  function () private.ButtonDown( "folder_inside" ) end } },
      { "obj_mysteryroom_folder",         { event_mdown =  function () private.ButtonDown( "folder_close" ) end } },
      { "obj_mysteryroom_folder_providence_close",   { event_mdown =  function () private.ButtonDown( "providence_close" ) end } },
      { "obj_mysteryroom_folder_providence",         { event_mdown =  function () private.ButtonDown( "providence_close" ) end } },
      { "obj_mysteryroom_frame_close",    { event_mdown =  function () private.ButtonDown( "frame"  ) end } },
      { "obj_mysteryroom_dossier_close",  { event_mdown =  function () private.ButtonDown( "dossier_back" ) end } },
      { "obj_mysteryroom_dossier",        { event_mdown =  function () private.ButtonDown( "dossier_close" ) end } },
      { "spr_mysteryroom_btn_exit",       { event_mdown =  function () public.ExitRoom() end } },
      { "grm_mysteryroom_menu",           { event_mdown =  function () public.ExitRoom() end } },
      --{ "obj_mysteryroom_folder_inside",  { event_mdown =  function () private.ButtonFocusClick() end } },
      --{ "obj_mysteryroom_dossier_inside", { event_mdown =  function () private.ButtonFocusClick() end } },
      --{ "obj_mysteryroom_layers",         { event_mdown =  function () private.ButtonFocusClick() end } },
    } );

    common.dialog.common.buttons[ "button_dossier_unlock" ] = { left = nil, center = { text = "ok", func = "button_dossier_unlock" }, right = nil };
    common.dialog.common.buttons[ "icon_help" ]             = { left = nil, center = { text = "ok", func = "icon_help"  },            right = nil };
    common.dialog.common.buttons[ "providence_lock" ]       = { left = nil, center = { text = "ok", func = "providence_lock" },       right = nil };
    --------------------------------------------------------------------------------------------
    -- function UpdateGameMode () end;
    --------------------------------------------------------------------------------------------
    local update_game_mode_mysteryroom = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      --"gzz_",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    end;
    cmn.AddSubscriber( "update_game_mode_mysteryroom", update_game_mode_mysteryroom, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function UpdatePerfMode () end;
    --------------------------------------------------------------------------------------------
    local update_performance_mode_mysteryroom = function ()

    local effects_table = 
    {
      "obj_mysteryroom_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

    end;
    cmn.AddSubscriber( "update_performance_mode_mysteryroom", update_performance_mode_mysteryroom, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function opn_mysteryroom () end;
    --------------------------------------------------------------------------------------------
    local opn_mysteryroom = function ()

      local c_star = private.GetCountStar();

      if c_star == 12 then

        ObjDelete( "spr_mysteryroom_button_dossier_lock" );

        ObjMultiSet(  {
          { "spr_mysteryroom_button_dossier_unlock", { active = true, input = true, alp = 1 } },
          { "obj_mysteryroom_button_dossier", { event_mdown = "", event_menter = "", event_mleave = "" } },
        } );

      end;

    end;
    cmn.AddSubscriber( "opn_mysteryroom", opn_mysteryroom, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function opn_mysteryroom () end;
    --------------------------------------------------------------------------------------------
    local beg_levelscr = function ()

    --

    end;
    cmn.AddSubscriber( "beg_levelscr", beg_levelscr, private.room_objname );
    private.Animation();

  end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  function private.Init_Subroom()

    --

  end;
--*********************************************************************************************************************
-- function *** OPEN, CLOSE *** () end;
--*********************************************************************************************************************
  function public.Open()

    common_impl.PlayAudio(  "mus", "common/audio/aud_adventure1_mus", 1 );
    private.ShowDialogFrameWin();

    if ng_global.progress[ "scr" ][ "see_tutorial_scr" ].start == 0 and 
       cmn.IsEventDone( "opn_mysteryroom" ) then

      --DbgTrace( "tutorial_page_1" );
      common_impl.TutorialShow( "tutorial_page_1_scr" );

    elseif ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages[ "tutorial_page_5_scr" ].shown == 1 then

      common_impl.TutorialShow( "tutorial_page_7_scr" );

    end;

  end;
  function public.PreOpen()

    if not cmn.IsEventDone( "opn_mysteryroom" ) then

      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star = {
        [ "mg_pathfind_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "ho_littlehouse_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "mg_key_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "ho_stock_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "mg_uppershelf_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "ho_trash_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "mg_bottles_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "ho_hos_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "mg_safe_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "ho_ladder_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "mg_gate_scr" ] = { done = 0, halfstar = 0, piece = 0 },
        [ "ho_intreehole_scr" ] = { done = 0, halfstar = 0, piece = 0 }
      };

      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous = { loc = "", dialog = false };

      cmn.SetEventDone( "opn_mysteryroom" );

    else

      private.OutCountStar();

    end;

    levelscr.InventoryDisable();

  end;
  function public.Close()

    private.CloseFrame();

  end;
  function public.PreClose()

    levelscr.InventoryDisable();

    common_impl.StopAudio( "mus", "common/audio/aud_adventure1_mus", 1 );

  end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
-- function *** OTHER FUNC *** () end;
--------------------------------------------------------------------------------------------
  function private.GetCountStar()

    local count = 0;

    for i, value in pairs( ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star ) do

      if value.done == 1 then

        count = count + 1;
      
      end;

    end;
    
    --return 12;
    return count;

  end;
  --*********************************************************************************************************************
  function private.OutCountStar()

    local star = private.GetCountStar();
    
    if star > 0 then

      ObjSet( "spr_mysteryroom_star", { alp = 1 } );

      if star >= 6 then

        ObjDelete( "spr_mysteryroom_icon_providence_lock" );
        ObjDelete( "spr_mysteryroom_icon_providence_lock_focus" );
        ObjDelete( "spr_mysteryroom_icon_providence_lock_focus_click" );

      end;

    end;

    ObjSet( "txt_mysteryroom_star_count", { text = star.."/12" } );

    private.count_done = { mg = 6, ho = 6 };

    for i, value in pairs( ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star ) do

      local room_name = i;
      
      for frame, val_frame in pairs ( private.frame ) do

        if val_frame.loc == room_name then

          local table_multiset = { { "spr_mysteryroom_icon_"..frame.."_star_0", { alp = 1 } } };

          if ( value.done == 1 ) or ( value.halfstar == 1 and value.piece > 1 ) or
             ( value.piece == 4 ) or ( value.halfstar > 1 ) then
          
            table_multiset = {
              { "spr_mysteryroom_icon_"..frame.."_star_1", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_2", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_3", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_4", { alp = 1 } },
              { "anm_mysteryroom_icon_"..frame.."_star_shine", { alp = 1, active = 1 } }
            };

          elseif ( value.halfstar == 1 and value.piece == 0 ) or
                 ( value.piece == 2 ) then
            table_multiset = {
              { "spr_mysteryroom_icon_"..frame.."_star_1", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_2", { alp = 1 } },
              { "spr_mysteryroom_icon_"..frame.."_star_3", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_4", { alp = 0 } },
            };      

          elseif ( value.halfstar == 1 and value.piece == 1 ) or
                 ( value.piece == 3 ) then

            table_multiset = {
              { "spr_mysteryroom_icon_"..frame.."_star_1", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_2", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_3", { alp = 1 } },
              { "spr_mysteryroom_icon_"..frame.."_star_4", { alp = 0 } },
            }; 
         
          elseif value.halfstar == 0 and value.piece == 1 then

            table_multiset = {
              { "spr_mysteryroom_icon_"..frame.."_star_1", { alp = 1 } },
              { "spr_mysteryroom_icon_"..frame.."_star_2", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_3", { alp = 0 } },
              { "spr_mysteryroom_icon_"..frame.."_star_4", { alp = 0 } },
            };        

          end;        

          ObjMultiSet( table_multiset );

        end;

      end;

      if value.done == 1 then

        if common.GetObjectPrefix( room_name ) == "mg" then
          private.count_done.mg = private.count_done.mg - 1;
        elseif common.GetObjectPrefix( room_name ) == "ho" then
          private.count_done.ho = private.count_done.ho - 1;
        end;

      end;

    end;

    local sum = private.count_done.mg + private.count_done.ho;
    ObjMultiSet( {
      { "txt_mysteryroom_folder_ho",       { text = private.count_done.ho } },
      { "txt_mysteryroom_folder_mg",       { text = private.count_done.mg } },
      { "txt_mysteryroom_envelope_number", { text = sum } },
    } );

  end;
  --*********************************************************************************************************************
  function public.ShowTutorial()

    for key, value in pairs ( ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star ) do

      if value.done == 1 or value.halfstar == 1 or value.piece == 1 then

        common_impl.TutorialShow( "tutorial_page_5_scr" );
        break;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function public.WinTask()

    ObjSet( "tmr_int_button_timer",       { playing = false, active = false } );
    ObjSet( "tmr_int_button_timer_extra", { playing = false, active = false } );

    local name_room = GetCurrentRoom();
    local not_prefix = common.GetObjectName( name_room );

    ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous[ "loc" ] = name_room;
    ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous[ "dialog" ] = false;

    if ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.time > 0 then

      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].done = 1;
      cmn.CallEventHandler( "opn_mysteryroom" );

    else

      local time_all = ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default + ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.default * 0.3;
      if ng_global.progress[ "scr" ][ "win_"..not_prefix ].timer.extra < time_all then

        ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].halfstar = ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].halfstar + 1;

      else

        ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].piece = ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].piece + 1;

      end;    
      
      if ( ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].halfstar == 1 and
            ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].piece > 1 ) or
          ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].piece == 4 or
          ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].halfstar > 1 then

        ng_global.progress[ "scr" ][ "opn_mysteryroom" ].star[ name_room ].done = 1;
        cmn.CallEventHandler( "opn_mysteryroom" );

      end; 

    end;

  end;
  --*********************************************************************************************************************
  function private.Animation()

    ObjAnimate( "spr_mysteryroom_light_1", "alp", 1, 0, "", 
    { 
      0.0, 3, 0.4, 
      1.5, 3, 0.8,
      2.0, 3, 0.2,
      3.0, 3, 0.4
    } );

    ObjAnimate( "spr_mysteryroom_light_2", "alp", 1, 0, "", 
    { 
      0.0, 3, 0.2, 
      1.5, 3, 0.8,
      2.0, 3, 0.1,
      3.0, 3, 0.2
    } );

    ObjAnimate( "spr_mysteryroom_light_3", "alp", 1, 0, "", 
    { 
      0.0, 3, 0.8, 
      1.5, 3, 0.4,
      2.0, 3, 0.6,
      3.0, 3, 0.8
    } );

  end;
  --*********************************************************************************************************************
  function private.ButtonDown( but_name )

    --------------------------------------------------------------------------------------------
    --function envelope () end;
    --------------------------------------------------------------------------------------------
    if string.find( but_name, "envelope" ) then

      common_impl.Lock( true );

      ObjAttach( "obj_mysteryroom_folder", "obj_mysteryroom_layers" );
      ObjAnimate( "obj_mysteryroom_folder", "alp", 0, 0, function () private.ButtonDownEnd( "envelope" ) end, 
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      } );
      ObjAnimate( "spr_mysteryroom_folder", "scale_xy", 0, 0, "", 
      { 
        0.0, 3, 0.9, 0.9,
        0.3, 3, 1.0, 1.0 
      } );    

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

    --------------------------------------------------------------------------------------------
    --function spr_mysteryroom_icon_providence () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "spr_mysteryroom_icon_providence" ) then

      local star = private.GetCountStar();

      if star < 6 then

        common.DialogWindowShow( "common", "providence_lock" );

      else 
  
        common_impl.Lock( true );

        ObjAttach( "obj_mysteryroom_folder_providence", "obj_mysteryroom_layers" );
        ObjAnimate( "obj_mysteryroom_folder_providence", "alp", 0, 0, function () private.ButtonDownEnd( "providence" ) end, 
        { 
          0.0, 0, 0, 
          0.3, 0, 1 
        } );
        ObjAnimate( "spr_mysteryroom_folder_providence", "scale_xy", 0, 0, "", 
        { 
          0.0, 3, 0.9, 0.9,
          0.3, 3, 1.0, 1.0 
        } );    

        common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      end;

    --------------------------------------------------------------------------------------------
    --function folder_close () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "folder_close" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAnimate( "obj_mysteryroom_folder", "alp", 0, 0, function () private.ButtonDownEnd( "folder_close" ) end, 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );
      ObjAnimate( "spr_mysteryroom_folder", "scale_xy", 0, 0, "", 
      { 
        0.0, 3, 1.0, 1.0,
        0.3, 3, 0.9, 0.9 
      } );  
    --------------------------------------------------------------------------------------------
    --function providence_close () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "providence_close" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAnimate( "obj_mysteryroom_folder_providence", "alp", 0, 0, function () private.ButtonDownEnd( "providence_close" ) end, 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );
      ObjAnimate( "spr_mysteryroom_folder_providence", "scale_xy", 0, 0, "", 
      { 
        0.0, 3, 1.0, 1.0,
        0.3, 3, 0.9, 0.9 
      } );  
    --------------------------------------------------------------------------------------------
    --function folder_inside () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "folder_inside" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      if ObjGet( "obj_mysteryroom_folder_ho" ).alp == 1 then

        ObjAnimate( "obj_mysteryroom_folder_inside", "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.2, 0, 1 
        } );

        ObjAnimate( "obj_mysteryroom_folder_ho", "alp", 0, 0, function () private.ButtonDownEnd( "folder_inside" ) end, 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );  

      elseif ObjGet( "obj_mysteryroom_folder_mg" ).alp == 1 then

        ObjAnimate( "obj_mysteryroom_folder_inside", "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.2, 0, 1 
        } );

        ObjAnimate( "obj_mysteryroom_folder_mg", "alp", 0, 0, function () private.ButtonDownEnd( "folder_inside" ) end, 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );         

      else 

        private.ButtonDown( "folder_close" );

      end;
    --------------------------------------------------------------------------------------------
    --function dossier_back () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "dossier_back" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      if ObjGet( "obj_mysteryroom_dossier_1" ).alp == 1 then

        ObjAnimate( "obj_mysteryroom_dossier_inside", "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.2, 0, 1 
        } );

        ObjAnimate( "obj_mysteryroom_dossier_1", "alp", 0, 0, function () private.ButtonDownEnd( "dossier_back" ) end, 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );  

      elseif ObjGet( "obj_mysteryroom_dossier_2" ).alp == 1 then

        ObjAnimate( "obj_mysteryroom_dossier_inside", "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.2, 0, 1 
        } );

        ObjAnimate( "obj_mysteryroom_dossier_2", "alp", 0, 0, function () private.ButtonDownEnd( "dossier_back" ) end, 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );         

      elseif ObjGet( "obj_mysteryroom_dossier_3" ).alp == 1 then

        ObjAnimate( "obj_mysteryroom_dossier_inside", "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.2, 0, 1 
        } );

        ObjAnimate( "obj_mysteryroom_dossier_3", "alp", 0, 0, function () private.ButtonDownEnd( "dossier_back" ) end, 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );   

      else 

        private.ButtonDown( "dossier_close" );

      end;
    --------------------------------------------------------------------------------------------
    --function icon () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "icon" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjMultiSet( private.table_multiset );

      local name = string.sub( but_name, 22 );
      ObjSet( "spr_mysteryroom_frame_"..name, { alp = 1 } );

      local id_text = "str_mysteryroom_frame_"..name;
      ObjSet( "txt_mysteryroom_frame_dialog", { text = id_text } );

      private.name_frame = name;
      
      ObjAttach( "obj_mysteryroom_frame", "obj_mysteryroom_layers" );
      ObjAttach( "spr_mysteryroom_frame_"..name, "obj_mysteryroom_frame" );
      
      local event = "win_"..common.GetObjectName( private.frame[ private.name_frame ].loc );
      if cmn.IsEventDone( event ) or cmn.IsEventStart( event ) then

        local func_end = function ()

          ObjSet( "spr_mysteryroom_player_skip", { input = true } )

        end;

        ObjSet( "spr_mysteryroom_player_skip", { visible = true } );
        ObjAnimate( "spr_mysteryroom_player_skip", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0, 
          0.3, 0, 0,
          0.6, 0, 1
        } );

      end;

      local anim_after = function ()

        private.ButtonDownEnd( "icon" )

      end;

      ObjAnimate( "obj_mysteryroom_frame", "alp", 0, 0, anim_after, 
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      } );

    --------------------------------------------------------------------------------------------
    --function folder_providence_ () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "folder_providence_" ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      local name = "vid_"..common.GetObjectName( but_name );
      local aud_name = "aud_"..common.GetObjectName( but_name );

      local func_after = function ( skip )

        interface.DialogVideoHide();

        if skip then

          VidStop( name );
          common_impl.StopAudio( "sfx", "common/audio/"..aud_name, 0.2 );
          common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1.0 );
          common_impl.PlayAudio(  "mus", "common/audio/aud_adventure1_mus", 1 );

        end;

      end;

      common_impl.StopAllMus();
      ObjSet( name, { alp = 1, active = true, input = false, visible = true } );
      interface.DialogVideoShow( name, 1, function() func_after( 'skip' ); end, 1 );
      VidPlay( name, func_after );      
      
      common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 0, "", 0 );
      common_impl.PlayAudio( "sfx", "common/audio/"..aud_name, 0, "", 0.5 );

    --------------------------------------------------------------------------------------------
    --function frame () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "frame" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      private.HideDialogFrame();
      ObjAnimate( "obj_mysteryroom_frame", "alp", 0, 0, function () private.ButtonDownEnd( "frame" ) end, 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );

    --------------------------------------------------------------------------------------------
    --function button_no () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "button_no" ) then

      local func_end = function ()

        ObjSet( "spr_mysteryroom_message", { input = true } );

        private.ButtonDown( "frame" );
        private.HideMessageTask();

      end;

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjSet( "spr_mysteryroom_message", { input = false } );
      ObjAnimate( "spr_mysteryroom_button_no", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0, 
        0.2, 0, 1,
        0.4, 0, 1 
      } );

    --------------------------------------------------------------------------------------------
    --function button_yes () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "button_yes" ) then

      local func_end = function ()

        ObjSet( "spr_mysteryroom_message", { input = true } );
        private.OpenTask();

      end;

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjSet( "spr_mysteryroom_message", { input = false } );
      ObjAnimate( "spr_mysteryroom_button_yes", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0, 
        0.2, 0, 1,
        0.4, 0, 1 
      } );
    --------------------------------------------------------------------------------------------
    --function help () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "help" ) then

      common.DialogWindowShow( "common", "icon_help" );

      --ObjMultiSet({
      --  { "spr_mysteryroom_icon_providence_focus_click", { alp = 0 } },
      --  { "spr_mysteryroom_envelope_focus_click", { alp = 0 } }
      --});

    --------------------------------------------------------------------------------------------
    --function obj_mysteryroom_button_dossier () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "obj_mysteryroom_button_dossier" ) then

      common.DialogWindowShow( "common", "button_dossier_unlock" );

    --------------------------------------------------------------------------------------------
    --function button_dossier_unlock () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "button_dossier_unlock" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAttach( "obj_mysteryroom_dossier", "obj_mysteryroom_layers" );
      ObjAnimate( "obj_mysteryroom_dossier", "alp", 0, 0, function () private.ButtonDownEnd( "dossier_open" ) end, 
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      } );
      ObjAnimate( "spr_mysteryroom_dossier", "scale_xy", 0, 0, "", 
      { 
        0.0, 3, 0.9, 0.9,
        0.3, 3, 1.0, 1.0 
      } ); 

    --------------------------------------------------------------------------------------------
    --function dossier_close () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "dossier_close" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAnimate( "obj_mysteryroom_dossier", "alp", 0, 0, function () private.ButtonDownEnd( "dossier_close" ) end, 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );
      ObjAnimate( "spr_mysteryroom_dossier", "scale_xy", 0, 0, "", 
      { 
        0.0, 3, 1.0, 1.0,
        0.3, 3, 0.9, 0.9 
      } );  

    --------------------------------------------------------------------------------------------
    --function folder_ho () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "folder_ho" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAnimate( "obj_mysteryroom_folder_inside", "alp", 0, 0, "", 
      { 
        0.0, 0, 1, 
        0.2, 0, 0 
      } );

      ObjAnimate( "obj_mysteryroom_folder_ho", "alp", 0, 0, function () private.ButtonDownEnd( "folder_ho" ) end, 
      { 
        0.0, 0, 0, 
        0.2, 0, 1 
      } );

    --------------------------------------------------------------------------------------------
    --function folder_mg () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "folder_mg" ) then

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAnimate( "obj_mysteryroom_folder_inside", "alp", 0, 0, "", 
      { 
        0.0, 0, 1, 
        0.2, 0, 0 
      } );

      ObjAnimate( "obj_mysteryroom_folder_mg", "alp", 0, 0, function () private.ButtonDownEnd( "folder_mg" ) end, 
      { 
        0.0, 0, 0, 
        0.2, 0, 1 
      } );

    --------------------------------------------------------------------------------------------
    --function dossier_inside () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "dossier_inside" ) then

      local num = string.sub( but_name, 32 );

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      ObjAnimate( "obj_mysteryroom_dossier_inside", "alp", 0, 0, "", 
      { 
        0.0, 0, 1, 
        0.2, 0, 0 
      } );

      ObjAnimate( "obj_mysteryroom_dossier_"..num, "alp", 0, 0, function () private.ButtonDownEnd( "dossier_inside_"..num ) end, 
      { 
        0.0, 0, 0, 
        0.2, 0, 1 
      } );

    --------------------------------------------------------------------------------------------
    --function player_skip () end;
    --------------------------------------------------------------------------------------------
    elseif string.find( but_name, "player_skip" ) then

      if ObjGet( "vid_mysteryroom_"..private.name_frame ) then

        VidStop( "vid_mysteryroom_"..private.name_frame );
        common_impl.StopAudio( "voc", "common/audio/aud_mysteryroom_"..private.name_frame.."_voc", 0 );  

      end;

      common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );

      AnimStop( "anm_mysteryroom_frame_"..private.name_frame );
      ObjStopAnimate( "spr_mysteryroom_slider_1", "pos_xy" );
      ObjSet( "spr_mysteryroom_slider_1", { pos_x = 262, pos_y = 211 } );
      private.ShowMessageTask();

    end;

  end;
  --*********************************************************************************************************************
  function private.ButtonDownEnd( name )

    common_impl.Lock( false );

    if name == "envelope" then

      ObjSet( "obj_mysteryroom_folder", { input = true  } );
      common_impl.TutorialShow( "tutorial_page_3_scr" );

    elseif name == "providence" then

      ObjSet( "obj_mysteryroom_folder_providence", { input = true  } );

    elseif name == "dossier_open" then

      ObjSet( "obj_mysteryroom_dossier", { input = true  } );

    elseif name == "dossier_close" then

      ObjMultiSet( { 
        { "obj_mysteryroom_dossier_inside", { alp = 1, input = true } }, 
        { "obj_mysteryroom_dossier_1", { alp = 0, input = false } }, 
        { "obj_mysteryroom_dossier_2", { alp = 0, input = false } }, 
        { "obj_mysteryroom_dossier_3", { alp = 0, input = false } }, 
        { "obj_mysteryroom_dossier", { input = false } },
      } );

      for i = 1, 3 do

        ObjMultiSet( { 
          { "spr_mysteryroom_dossier_"..i.."_slider", { pos_y = private.slider_pos[ 1 ] } }, 
          { "obj_mysteryroom_dossier_"..i.."_slider", { pos_y = private.slider_pos[ 1 ] } }, 
          { "txt_mysteryroom_dossier_"..i.."_text", { pos_y = private.text_pos[ 1 ] } }, 
         } );

      end;

      ObjDetach( "obj_mysteryroom_dossier" );

    elseif name == "folder_close" then

      ObjMultiSet( { 
        { "obj_mysteryroom_folder_inside", { alp = 1, input = true } },
        { "obj_mysteryroom_folder_ho", { alp = 0, input = false } },
        { "obj_mysteryroom_folder_mg", { alp = 0, input = false } },
        { "obj_mysteryroom_folder", { input = false } },
      } ); 

      ObjDetach( "obj_mysteryroom_folder" );

      if ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages[ "tutorial_page_5_scr" ].shown == 1 then

        common_impl.TutorialShow( "tutorial_page_7_scr" );

      end;

    elseif name == "providence_close" then

      ObjMultiSet( { 
        { "obj_mysteryroom_folder_providence", { input = false } },
      } ); 

      ObjDetach( "obj_mysteryroom_folder_providence" );
     
    elseif name == "folder_inside" then

      ObjMultiSet( { 
        { "obj_mysteryroom_folder_inside", { alp = 1, input = true } },
        { "obj_mysteryroom_folder_ho", { alp = 0, input = false } },
        { "obj_mysteryroom_folder_mg", { alp = 0, input = false } },
      } ); 

    elseif name == "dossier_back" then

      ObjMultiSet( { 
        { "obj_mysteryroom_dossier_inside", { alp = 1, input = true } }, 
        { "obj_mysteryroom_dossier_1", { alp = 0, input = false } }, 
        { "obj_mysteryroom_dossier_2", { alp = 0, input = false } }, 
        { "obj_mysteryroom_dossier_3", { alp = 0, input = false } }, 
      } );

      for i = 1, 3 do

        ObjMultiSet( { 
          { "spr_mysteryroom_dossier_"..i.."_slider", { pos_y = private.slider_pos[ 1 ] } }, 
          { "obj_mysteryroom_dossier_"..i.."_slider", { pos_y = private.slider_pos[ 1 ] } }, 
          { "txt_mysteryroom_dossier_"..i.."_text", { pos_y = private.text_pos[ 1 ] } }, 
         } );

      end;

    elseif name == "icon" then

      ObjSet( "obj_mysteryroom_frame",  { input = true } );
      private.ShowDialogFrame();

    elseif name == "frame" then

      ObjSet( "obj_mysteryroom_frame",  { input = false } );
      ObjDetach( "obj_mysteryroom_frame" );
      ObjAttach( "spr_mysteryroom_frame_"..private.name_frame, "obj_mysteryroom_frame_hub" );

      if ObjGet( "vid_mysteryroom_"..private.name_frame ) then

        VidStop( "vid_mysteryroom_"..private.name_frame );
        common_impl.StopAudio( "voc", "common/audio/aud_mysteryroom_"..private.name_frame.."_voc", 0 );  

      end;

    elseif name == "folder_ho" then

      ObjSet( "obj_mysteryroom_folder_inside", { alp = 0, input = false } );
      ObjSet( "obj_mysteryroom_folder_ho", { alp = 1, input = true } );
      common_impl.TutorialShow( "tutorial_page_4_scr" );

    elseif name == "folder_mg" then

      ObjSet( "obj_mysteryroom_folder_inside", { alp = 0, input = false } );
      ObjSet( "obj_mysteryroom_folder_mg", { alp = 1, input = true } );
      common_impl.TutorialShow( "tutorial_page_4_scr" );      
    
    elseif string.find( name, "dossier_inside" )  then

      local num = string.sub( name, 16 );

      ObjSet( "obj_mysteryroom_dossier_inside", { alp = 0, input = false } );
      ObjSet( "obj_mysteryroom_dossier_"..num, { alp = 1, input = true } );      

    end;

  end;
  --*********************************************************************************************************************
  function private.ButtonEnter( but_name )

    SetCursor( CURSOR_HAND );

    local obj = but_name.."_focus";
    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ButtonLeave( but_name )

    SetCursor( CURSOR_DEFAULT );

    local obj = but_name.."_focus";
    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  end;
  --*********************************************************************************************************************
  function private.ButtonEnterSpecial( but_name )

    SetCursor( CURSOR_HAND );

    local obj = but_name.."_focus";
    local alp = ObjGet( obj ).alp;

    ObjSet( obj, { alp = 0.4 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );
    --ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 0.4 } );

  end;
  --*********************************************************************************************************************
--  function private.ButtonLeaveSpecial( but_name )
--
--    SetCursor( CURSOR_DEFAULT );
--
--    local obj = but_name.."_focus";
--    local alp = ObjGet( obj ).alp;
--
--    ObjSet( obj, { alp = 0.0 } );
--    --ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
--
--  end;
  --*********************************************************************************************************************
  function private.ButtonFocusClick()

    --ObjMultiSet( {
    --  { "spr_mysteryroom_folder_ho_focus_click",  { alp = 0 } },
    --  { "spr_mysteryroom_folder_mg_focus_click",  { alp = 0 } },
    --  { "spr_mysteryroom_dossier_inside_1_click", { alp = 0 } },
    --  { "spr_mysteryroom_dossier_inside_2_click", { alp = 0 } },
    --  { "spr_mysteryroom_dossier_inside_3_click", { alp = 0 } },
    --  { "spr_mysteryroom_icon_providence_focus_click", { alp = 0 } },
    --  { "spr_mysteryroom_envelope_focus_click", { alp = 0 } }
    --} );

  end;
  --*********************************************************************************************************************
  function private.ShowDialogFrame()

    local event = "win_"..common.GetObjectName( private.frame[ private.name_frame ].loc );

    AnimPlay( "anm_mysteryroom_frame_"..private.name_frame, "DoAnim", "" );

    if not cmn.IsEventDone( event ) and cmn.IsEventStart( event ) then

      private.ShowMessageTask();

    else

      local tme = private.frame[ private.name_frame ].time;

      ObjAnimate( "spr_mysteryroom_slider_1", "pos_xy", 0, 0, private.ShowMessageTask, 
      { 
        0.0, 0, -409, 256,
        tme, 0,  262, 211
      } );

      if ObjGet( "vid_mysteryroom_"..private.name_frame ) then

        VidPlay( "vid_mysteryroom_"..private.name_frame, "" );

      end;

      common_impl.PlayAudio( "voc", "common/audio/aud_mysteryroom_"..private.name_frame.."_voc", 0, "", 0.5 );

    end;

  end;
  --*********************************************************************************************************************
  function private.HideDialogFrame()

    ObjStopAnimate( "spr_mysteryroom_slider_1", "pos_xy" );
    ObjSet( "spr_mysteryroom_slider_1", { pos_x = -409, pos_y = 256 } );
    ObjSet( "spr_mysteryroom_player_skip", { input = false, visible = false, alp = 0 } );    

  end;
  --*********************************************************************************************************************
  function private.ShowMessageTask()

    common_impl.Lock( true );

    ObjAttach( "obj_mysteryroom_message", "obj_mysteryroom_layers" );
    ObjSet( "spr_mysteryroom_player_skip", { input = false, visible = false, alp = 0 } );

    ObjAnimate( "obj_mysteryroom_message", "alp", 0, 0, function () private.ShowMessageTaskEnd() end, 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    } );
    ObjAnimate( "spr_mysteryroom_message", "scale_xy", 0, 0, "", 
    { 
      0.0, 3, 0.9, 0.9,
      0.3, 3, 1.0, 1.0 
    } );    

  end;
  --*********************************************************************************************************************
  function private.ShowDialogFrameWin()

    local func_after_3 = function ()

      common_impl.Lock( false );

      ObjSet( "obj_mysteryroom_frame",  { input = false } );
      ObjDetach( "obj_mysteryroom_frame" );
      ObjAttach( "spr_mysteryroom_frame_"..private.name_frame, "obj_mysteryroom_frame_hub" );

      ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous[ "dialog" ] = true;

      public.ShowTutorial();

    end;

    local func_after_2 = function ()

      private.HideDialogFrame();
      ObjAnimate( "obj_mysteryroom_frame", "alp", 0, 0, func_after_3, 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );
      
    end;
    
    local func_after_1 = function ()

      local tme = private.frame_win[ private.name_frame ].time;

      AnimPlay( "anm_mysteryroom_frame_"..private.name_frame, "DoAnim", "" );

      ObjAnimate( "spr_mysteryroom_slider_1", "pos_xy", 0, 0, func_after_2, 
      { 
        0.0, 0, -409, 256,
        tme, 0,  262, 211
      } );    

      if ObjGet( "vid_mysteryroom_"..private.name_frame ) then

        VidPlay( "vid_mysteryroom_"..private.name_frame, "" );

      end;
      common_impl.PlayAudio( "voc", "common/audio/aud_mysteryroom_"..private.name_frame.."_voc", 0, "", 0.5 );

    end;

    if ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous[ "loc" ] ~= "" then

      if not ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous[ "dialog" ] then

        for i, value in pairs( private.frame ) do

          if value.loc == ng_global.progress[ "scr" ][ "opn_mysteryroom" ].previous[ "loc" ] then

            local name = i.."_1";

            common_impl.Lock( true );

            ObjMultiSet( private.table_multiset );
            ObjSet( "spr_mysteryroom_frame_"..name, { alp = 1 } );

            local id_text = "str_mysteryroom_frame_"..name;
            ObjSet( "txt_mysteryroom_frame_dialog", { text = id_text } );

            private.name_frame = name;
            
            ObjAttach( "obj_mysteryroom_frame", "obj_mysteryroom_layers" );
            ObjAttach( "spr_mysteryroom_frame_"..name, "obj_mysteryroom_frame" );

            ObjAnimate( "obj_mysteryroom_frame", "alp", 0, 0, func_after_1, 
            { 
              0.0, 0, 0, 
              0.3, 0, 1 
            } );

            break;

          end;

        end;
        
      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.ShowMessageTaskEnd()

    common_impl.Lock( false );
    ObjSet( "obj_mysteryroom_message",  { input = true } );
      
  end;
  --*********************************************************************************************************************
  function private.HideMessageTask()

    ObjAnimate( "obj_mysteryroom_message", "alp", 0, 0, function () private.HideMessageTaskEnd() end, 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    ObjAnimate( "spr_mysteryroom_message", "scale_xy", 0, 0, "", 
    { 
      0.0, 3, 1.0, 1.0,
      0.3, 3, 0.9, 0.9 
    } );    

  end;
  --*********************************************************************************************************************
  function private.HideMessageTaskEnd()

    ObjSet( "spr_mysteryroom_button_no",  { alp = 0 } );
    ObjSet( "spr_mysteryroom_button_yes", { alp = 0 } );
    ObjSet( "obj_mysteryroom_message",  { input = false } );
    ObjDetach( "obj_mysteryroom_message" );

  end;
  --*********************************************************************************************************************
  function private.OpenTask()

    common_impl.Lock( false );
    local task_room = private.frame[ private.name_frame ].loc;
    cmn.GotoRoom( task_room );

    --common_impl.TutorialShow( "tutorial_page_6_scr" );
    
  end;
  --*********************************************************************************************************************
  function private.CloseFrame()

    ObjMultiSet( {
      { "obj_mysteryroom_message", { input = false, alp = 0 } },
      { "obj_mysteryroom_frame",   { input = false, alp = 0 } },
      { "obj_mysteryroom_folder",  { input = true,  alp = 1 } }
    } );
    private.HideMessageTaskEnd();

  end;
  --*********************************************************************************************************************
  function public.ExitRoom()

    SaveProfiles();
    SaveSettings();

    SetCursor( CURSOR_DEFAULT );
    
    ng_global.is_scr = true;

    common.LevelSwitch( "menu", "game" );

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function common.dialog.common.button_dossier_unlock()

    common.DialogWindowHide( "common" );

  end;
  --*********************************************************************************************************************
  function common.dialog.common.icon_help()

    common.DialogWindowHide( "common" );

  end;
  --*********************************************************************************************************************
  function common.dialog.common.providence_lock()

    common.DialogWindowHide( "common" );

  end;
  --*********************************************************************************************************************
--------------------------------------------------------------------------------------------
-- function *** FUNC PSEFOLDER *** () end;
--------------------------------------------------------------------------------------------
  function private.PsefolderStartDrag()

    --DbgTrace( "PsefolderStartDrag " );

  end;
  --*********************************************************************************************************************
  function private.PsefolderDragDrop( name )

    local obj_name = "spr_"..common.GetObjectName( name );
    local locpos_x = ObjGet( obj_name ).pos_x;
    local locpos_y = ObjGet( obj_name ).pos_y;

    ObjSet( name, { pos_x = locpos_x, pos_y = locpos_y } );

  end;
  --*********************************************************************************************************************
  function private.PsefolderDrag( name )

    local pos = GetGameCursorPos();
    local locpos_x = pos[ 1 ];
    local locpos_y = pos[ 2 ];
    local obj_name = "spr_"..common.GetObjectName( name );

    if locpos_x < 170 then
      locpos_x = 170;
    end;

    if locpos_x > 720 then
      locpos_x = 720;
    end;

    if locpos_y < 260 then 
      locpos_y = 260;
    end;

    if locpos_y > 540 then
      locpos_y = 540;
    end;

    ObjSet( obj_name, { pos_x = locpos_x, pos_y = locpos_y } );
    
  end;
  --*********************************************************************************************************************
--------------------------------------------------------------------------------------------
-- function *** FUNC SLIDER *** () end;
--------------------------------------------------------------------------------------------
  function private.SliderStartDrag()

    

  end;
  --*********************************************************************************************************************
  function private.SliderDragDrop( name )  

    local spr_name = "spr_mysteryroom_"..name.."_slider";
    local locpos_x = ObjGet( spr_name ).pos_x;
    local locpos_y = ObjGet( spr_name ).pos_y;
    local obj_name = "obj_mysteryroom_"..name.."_slider";

    ObjSet( obj_name, { pos_x = locpos_x, pos_y = locpos_y } );    

  end;
  --*********************************************************************************************************************
  function private.SliderDrag( name )
  
    local pos = GetGameCursorPos();
    local position_y = pos[ 2 ] - ObjGet( "spr_mysteryroom_dossier" ).pos_y;
    local text_pos_y = private.text_pos[ 1 ];
    local spr_name = "spr_mysteryroom_"..name.."_slider";
    local txt_name = "txt_mysteryroom_"..name.."_text";
    if position_y < private.slider_pos[ 1 ] then
      
      position_y = private.slider_pos[ 1 ];

    elseif position_y > private.slider_pos[ 2 ] then

      position_y = private.slider_pos[ 2 ];

    end;

    private.k_pos = ( math.abs( private.slider_pos[ 1 ] ) + position_y ) / ( private.slider_pos[ 2 ] - private.slider_pos[ 1 ] )
    
    text_pos_y = ( private.text_pos[ 1 ] - private.text_pos[ 2 ] ) * ( - private.k_pos ) + private.text_pos[ 1 ];

    ObjSet( spr_name, { pos_y = position_y } );
    ObjSet( txt_name, { pos_y = text_pos_y } );

  end;
  --*********************************************************************************************************************