-- name=mg_uppershelf

--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_uppershelf";
  private.win_pos_mas = {};
  private.circles_ang_1 = { { -0,   1,2,3,4},  { -5, 4 } };
  private.circles_ang_2 = { { -0,1, 1,2,3,4 }, { -0.82, 2,3 }, { -4.7, 1 },  { -5.5, 1,2 } };
  private.circles_ang_3 = { { -0,1, 1,2,3,4 }, { -0.8 , 2,3 }, { -1.59, 3 },  { -4.7, 1 }, { -5.5, 1,2 } };

  ObjSet( "spr_uppershelf_evidence_1_3", { event_mdown = private.get_evidence_1_3 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_uppershelf = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

  local mas_parent_gfx = 

    {
    private.room_objname,

    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_uppershelf", update_game_mode_uppershelf, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_3" ] = {
    type = "get",
    get_obj = "spr_uppershelf_evidence_1_3",
    room = "rm_pier",
    zz = "mg_uppershelf",
    zz_gate = "gmg_pier_uppershelf"
  };

  local get_evidence_1_3_inv = function ()

  end;
  
  local get_evidence_1_3_closemg = function ()
  
    ObjDelete( "gfx_uppershelf_evidence_1_3" );
    ObjDelete( "spr_uppershelf_evidence_1_3_shadow" );
    ObjDelete( "spr_uppershelf_evidence_1_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evidence_1_3", get_evidence_1_3_inv );
  cmn.AddSubscriber( "get_evidence_1_3", get_evidence_1_3_closemg, private.room_objname );
--*********************************************************************************************************************
  common_impl.hint[ "win_uppershelf" ] = {
    type = "win",
    room = "rm_pier",
    zz = "mg_uppershelf",
    zz_gate = "gmg_pier_uppershelf"
  };

  local win_uppershelf = function ()

--  for i = 1,4 do
--
--    if ng_global.progress["std"]["win_uppershelf"].stage[i] == 1 then
--
--      --ObjSet( "spr_uppershelf_button_"..i.."_light", { alp = 1 } );
--
--    end;
--
--  end;

    if ( cmn.IsEventDone( "win_uppershelf" ) ) then  

      ObjSet( "spr_uppershelf_evidence_1_3", { input = 1 });
      ObjSet( "spr_uppershelf_evidence_1_3", { active = 1 });
      ObjDelete( "obj_uppershelf_mg" );

    else

      for i = 1,3 do

        local mas_name = 'circles_ang_'..i;
        ObjSet( "spr_uppershelf_circle_"..i, { ang = private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[i]][1] } );

      end;

      for i = 1,4 do 

        local flag = 0;

        for j = 1, 3 do

          local mas_name = "circles_ang_"..j
          for k = 2,#private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[j]] do

            if private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[j]][k] == i then

              flag = flag + 1;
              break;

            end;

          end;
        
        end;

        if flag == 3 then 

          ObjSet( "spr_uppershelf_pin_"..i, { alp = 1 } );

        end;

      end;

  end;

end;

  cmn.AddSubscriber( "win_uppershelf", win_uppershelf, private.room_objname );
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
function public.Open() 

  --common_impl.PlayAudio( "env", "common/audio/aud_pier_env", 1, "", 0.5 );

  if not cmn.IsEventDone( "win_uppershelf" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  int_slider.InitSlider( private.room_objname );
  common_impl.VisitMapRoom( "pier" );

end;
--*********************************************************************************************************************
function public.PreOpen()

  ObjAnimate( "spr_uppershelf_light", "alp", 1, 0, "", {0,0,0, 2,0,1, 4,3,0 });

 if not cmn.IsEventStart( "win_uppershelf" ) then

    ng_global.progress["std"]["win_uppershelf"].stage = { 1, 2, 3 };
    ng_global.progress["std"]["win_uppershelf"].progres = { 1,0,1,1 };

  end;

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  --

end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_uppershelf" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
--function public.Reset()
--
--end;
--*********************************************************************************************************************
--function public.Skip()
--
--  private.Win();
--
--end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_evidence_1_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_3", "spr_uppershelf_evidence_1_3" );

    cmn.SetEventDone( "get_evidence_1_3" );
    cmn.CallEventHandler( "get_evidence_1_3" );
  
  end;

  cmn.GotoRoom( "rm_pier" );
  interface.DialogEvidenceShow( "evidence_1_3", func_end )

end;
--*********************************************************************************************************************
function private.GetDefaultState()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_uppershelf" );
  cmn.CallEventHandler( "win_uppershelf" );
  common_impl.PassingMgWin();

--  cmn.GotoRm( "" );

end;
--*********************************************************************************************************************
--function private.Win()
--
--  cmn.MiniGameHide();
  --TimerStart( "tmr_uppershelf_win", private.WinEnd, 1.0 );

--end;
--*********************************************************************************************************************
function public.Rotate( number )

  number = tonumber( number );

  local mas_name = "circles_ang_"..number;

  common_impl.Lock(true);

  local func_after = function ()

    common_impl.Lock(false);
    if private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[number] + 1] then

      ng_global.progress["std"]["win_uppershelf"].stage[number] = ng_global.progress["std"]["win_uppershelf"].stage[number]+1;

    else

      ng_global.progress["std"]["win_uppershelf"].stage[number] = 1;
      ObjSet( "spr_uppershelf_circle_"..number, { ang = private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[number]][1] } );

    end;

    public.RotateEnd()

  end;
  local start_ang = private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[number]][1];
  local end_ang = 0;

  for i = 1,4 do

    if ObjGet( "spr_uppershelf_pin_"..i ).alp ~= 0 then

       ObjAnimate( "spr_uppershelf_pin_"..i, "alp", 0, 0, "", {0, 0, 1, 0.3, 3, 0 });
       common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_hide_pintle", 0, "", 0 );

    end;

  end;

  if private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[number] + 1] then

    end_ang = private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[number] + 1 ][1];

    ObjAnimate( "spr_uppershelf_circle_"..number, "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, start_ang,
      1.0, 2, end_ang
    } ); 

--
  else 
    
    end_ang = private[mas_name][1][1] - 6.28;

    ObjAnimate( "spr_uppershelf_circle_"..number, "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, start_ang,
      1.0, 2, end_ang
    } ); 

  end;

    if ( number == 2 and ng_global.progress["std"]["win_uppershelf"].stage[number] == 2 ) or
      ( number == 3 and ng_global.progress["std"]["win_uppershelf"].stage[number] == 3 ) then

      ObjSet( "tmr_uppershelf_playaudio_turn", { playing = true, time = 0.3, endtrig = "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_uppershelf_rotate_slow', 0, '' );" } );

    else

      ObjSet( "tmr_uppershelf_playaudio_turn", { playing = true, time = 0.3, endtrig = "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_uppershelf_rotate_fast', 0, '' );" } );

    end;


end;

function public.RotateEnd()

  --local anim_flag

  for i = 1,4 do 

    local flag = 0;

    for j = 1, 3 do

      local mas_name = "circles_ang_"..j
      for k = 2,#private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[j]] do
        if private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[j]][k] == i then

          flag = flag + 1;
          break;

        end;

      end;
    
    end;


        --end;

    if flag == 3 then 

     local func_after =  function ()
      --if i == 4 then func_after = function ()      
          common_impl.Lock( false );
          
          if ObjGet( "spr_uppershelf_pin_1" ).alp == 1
          and ObjGet( "spr_uppershelf_pin_2" ).alp == 1
          and ObjGet( "spr_uppershelf_pin_3" ).alp == 1
          and ObjGet( "spr_uppershelf_pin_4" ).alp == 1
          and ng_global.progress["std"]["win_uppershelf"].progres[2] == 0 then
            common_impl.Lock( true );
            public.Check();
            --ObjAnimate( "spr_uppershelf_button_2_light", "alp", 0, 0, public.Check, {0,0,0, 0.3,0,0.5, 0.6,3,0, 0.9,3,1 });
            --ObjAnimate( "spr_uppershelf_button_2", "scale_xy", 0, 0, "", {0,0,1,1, 0.6,3,0.7,0.7 });
            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_true", 0, "", 0 );  

          end;

--          if ObjGet( "spr_uppershelf_pin_1" ).alp == 1
--          and ObjGet( "spr_uppershelf_pin_2" ).alp == 1
--          and ObjGet( "spr_uppershelf_pin_3" ).alp == 0 
--          and ObjGet( "spr_uppershelf_pin_4" ).alp == 0
--          and ng_global.progress["std"]["win_uppershelf"].progres[3] == 0 then
--
--            common_impl.Lock( true );
--            ObjAnimate( "spr_uppershelf_button_3_light", "alp", 0, 0, public.Check, {0,0,0, 0.3, 0,0.5,0.6,3,0, 0.9,3,1 });
--            ObjAnimate( "spr_uppershelf_button_3", "scale_xy", 0, 0, "", {0,0,1,1, 0.6,3,0.7,0.7 });
--            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_true", 0, "", 0 );  
--
--          end;
--
--          if ObjGet( "spr_uppershelf_pin_1" ).alp == 0
--          and ObjGet( "spr_uppershelf_pin_2" ).alp == 1
--          and ObjGet( "spr_uppershelf_pin_3" ).alp == 1 
--          and ObjGet( "spr_uppershelf_pin_4" ).alp == 0
--          and ng_global.progress["std"]["win_uppershelf"].progres[4] == 0 then
--
--            common_impl.Lock( true );
--            ObjAnimate( "spr_uppershelf_button_4_light", "alp", 0, 0, public.Check, {0,0,0, 0.3, 0, 0.5, 0.6,3,0, 0.9,3,1 });
--            ObjAnimate( "spr_uppershelf_button_4", "scale_xy", 0, 0, "", {0,0,1,1, 0.6,3,0.7,0.7 });
--            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_true", 0, "", 0 );  
--
--          end;

--          if ObjGet( "spr_uppershelf_pin_1" ).alp == 0
--          and ObjGet( "spr_uppershelf_pin_2" ).alp == 0
--          and ObjGet( "spr_uppershelf_pin_3" ).alp == 0 
--          and ObjGet( "spr_uppershelf_pin_4" ).alp == 1
--          and ng_global.progress["std"]["win_uppershelf"].progres[1] == 0 then
--
--            common_impl.Lock( true );
--            ObjAnimate( "spr_uppershelf_button_1_light", "alp", 0, 0, public.Check, {0,0,0,0.3, 0, 0.5, 0.6,3,0, 0.9,3,1 });
--            ObjAnimate( "spr_uppershelf_button_1", "scale_xy", 0, 0, "", {0,0,1,1, 0.6,3,0.7,0.7 });
--            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_true", 0, "", 0 );            
--
--          end;

       end;
     common_impl.Lock( true );
     ObjAnimate( "spr_uppershelf_pin_"..i, "alp", 0, 0, func_after, {0, 0, 0, 0.4, 0, 1 });
     common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_show_pintle", 0, "", 0.2 );

    end;

  end;

end;

function public.Check()

  common_impl.Lock( false );

  for i = 2,2 do

    --if ng_global.progress["std"]["win_uppershelf"].progres[i] == 0 and ObjGet( "spr_uppershelf_button_"..i.."_light" ).alp == 1 then
    if ng_global.progress["std"]["win_uppershelf"].progres[i] == 0 then

       ng_global.progress["std"]["win_uppershelf"].progres[i] = 1;

    end;

  end;

  local right = 0;

  for i = 1,4 do

    if ng_global.progress["std"]["win_uppershelf"].progres[i] == 1 then

      right = right + 1;      

    end;

  end;

  if right == 4 then

    local func_after = function ()
      common_impl.Lock( false );      
      PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
      private.WinEnd();

    end;
    common_impl.Lock( true );
    ObjAnimate( "obj_uppershelf_mg", "alp", 0, 0, func_after, {0, 0, 1, 0.4, 0, 0 });
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_win", 0, "", 0.2 );   

  end;

end;

function public.Skip()
  port.skip_mg = true;
  --if right == 4 then

    local func_after = function ()

      common_impl.Lock( false );
      PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
      private.WinEnd()

    end;

    common_impl.Lock( true );
    ObjAnimate( "obj_uppershelf_mg", "alp", 0, 0, func_after, {0, 0, 1, 0.4, 0, 0 });
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_win", 0, "", 0.2 );   

  --end;  

end;

function public.Reset()

  ng_global.progress["std"]["win_uppershelf"].stage = { 1, 2, 3 };
  ng_global.progress["std"]["win_uppershelf"].progres = { 1,0,1,1 };

  for i = 1,4 do 

     --ObjSet( "spr_uppershelf_button_"..i.."_light", { alp = 0, scale_x = 1, scale_y = 1 } );
     --ObjSet( "spr_uppershelf_button_"..i, { scale_x = 1, scale_y = 1 } );
     ObjSet( "spr_uppershelf_pin_"..i, { alp = 0 } );

  end;

  for i = 1,3 do

    local mas_name = 'circles_ang_'..i;
    ObjSet( "spr_uppershelf_circle_"..i, { ang = private[mas_name][ng_global.progress["std"]["win_uppershelf"].stage[i]][1] } );

  end;

end;