-- name=level3

function public.Start ( param )


  --  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  if (tostring(GetPlatform())~= "ios") then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  end;
  
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.PanelProvideAdd( 10 );
  interface.BtnProvideAdd( 0 );
  interface.EvidenceAdd( 18 );
  interface.DialogEvidenceAdd( 20 );
  interface.InvestigationButtonAdd( 17 ); 
  interface.SliderAdd( -1 );
  interface.ProvideAdd( 8 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.ProvideEyeAdd( 30 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then


    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/level3/mod_level3_inv" );
  level3_inv.Init();

  common.LevelLoad( "level3", "std", "rm_mine_1_3", param, private.menu_moduls );
  common_impl.SetMorphEventDone();
  common_impl.SetCollectEventDone();
  --if IsCollectorsEdition() then

    common_impl.Collectibles2CoinsLoad();
    common_impl.UpdatePerformanceMode();
  --end;

  private.TutorialSetParams();
  interface.KeyUpdate();

  event_show_investigation = "beg_level3";

  interface.InvestigationButtonCheck();
  
  interface.PanelProvideShow();
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
   "rm_mine_1_3"
  ,"rm_mineentrance_3"
  ,"rm_nightsville_3"
  ,"rm_mansion"
  ,"mg_pathfind"
  ,"rm_hallway"
  ,"ho_ladder"
  ,"rm_chamber"
  ,"ho_hos"
  ,"rm_pier_3"
  ,"rm_fork_3"
  ,"rm_square_3"
  ,"rm_sheriffshouse"
  ,"rm_wincards"
  ,"mg_bottles"
  ,"rm_secretroom"
  ,"ho_intable"
  ,"mg_superpuzzle_3"
  ,"rm_livingroom_3"
  ,"rm_abandoneddistrict_3"
  ,"rm_office_3"
  ,"rm_basement_3"
  ,"rm_nightsvilleentrance_3"
  ,"rm_glade_3"
  };

  game.progress_names_room =
  {
   { "beg_level3"                         }
  ,{ "opn_mine_1_3"                       }
  ,{ "opn_mine_2_3"                       }
  ,{ "opn_glade_3"                        }
  ,{ "opn_nightsvilleentrance_3"          }
  ,{ "opn_mineentrance_3",                }
  ,{ "opn_nightsville_3"                  }
  ,{ "use_map",                           "rm_nightsville_3",         { "opn_nightsville_3"                }}
  -- МГ_поиск
  ,{ "win_pathfind",                      "rm_nightsville_3",         { "opn_nightsville_3"      }}
  ,{ "opn_mansion"                        }
  ,{ "get_collect_item_3_1" }  
  ,{ "get_collect_morph_item_3_1"  }
  ,{ "vid_mansion_owlman",                "rm_mansion",               { "opn_mansion"            }}
  ,{ "get_kidrake",                       "rm_mansion",               { "vid_mansion_owlman"     }}
  ,{ "get_evidence_3_1",                  "rm_mansion",               { "vid_mansion_owlman"     }}
  ,{ "use_elf_8",                         "rm_mansion",               { "vid_mansion_owlman"     }}
  ,{ "get_porcelainowl",                  "rm_mansion",               { "use_elf_8"              }}
  ,{ "get_hammerdrill",                   "rm_mansion",               { "vid_mansion_owlman"     }}
  ,{ "use_kidrake",                       "rm_mansion",               { "get_kidrake"            }}
  ,{ "get_stonesword",                    "rm_mansion",               { "use_kidrake"            }}
  ,{ "use_stonesword",                    "rm_mansion",               { "get_stonesword"         }}
  ,{ "win_statue",                        "rm_mansion",               { "use_stonesword"         }}  -- ММГ_скульптура
  ,{ "get_porcelainkey",                  "rm_mansion",               { "win_statue"             }}
  ,{ "use_porcelainkey",                  }
  ,{ "get_lockpiece",                     }
  ,{ "use_lockpiece",                     "rm_mansion",               { "get_lockpiece"          }}

  ,{ "opn_hallway",                       "rm_mansion",               { "use_lockpiece"          }}
  ,{ "get_collect_morph_item_3_2" }
  ,{ "clk_providence_cape",               "rm_hallway",               { "opn_hallway"    }}
  ,{ "get_prv_curtainrope_silhouette",    "rm_hallway",               { "opn_hallway"    }}
  ,{ "get_prv_flowerpot_silhouette",      "rm_hallway",               { "opn_hallway"    }}

  ,{ "get_tongs",                         "rm_hallway",               { "opn_hallway"    }}
  ,{ "use_tongs",                         "rm_hallway",               { "get_tongs"              }}
  ,{ "get_chisel",                        "rm_hallway",               { "opn_hallway"    }}
  ,{ "use_chisel",                        "rm_hallway",               { "get_chisel"             }}

  ,{ "get_bottle_substance_a",            "rm_hallway",               { "use_chisel"             }}
  ,{ "get_drillbit",                      "rm_hallway",               { "use_chisel"             }}

  ,{ "use_chisel_2",                      "rm_mansion",               { "get_chisel"             }}
  ,{ "get_brush",                         "rm_mansion",               { "use_chisel_2"           }}
  ,{ "get_bottle_substance_b",            "rm_mansion",               { "use_chisel_2"           }}
  ,{ "use_drillbit",                      }
  ,{ "get_workingdrill",                  }

  ,{ "use_workingdrill",                  "rm_hallway",               { "get_workingdrill"       }}
  ,{ "get_stone",                         "rm_hallway",               { "use_workingdrill"       }}
  ,{ "get_statuepiece",                   "rm_hallway",               { "get_stone"              }}
  ,{ "get_bottle_substance_v",            "rm_hallway",               { "get_stone"              }}
  ,{ "use_bottle_substance_a",            "rm_hallway",               { "get_bottle_substance_a" }}
  ,{ "use_bottle_substance_b",            "rm_hallway",               { "get_bottle_substance_b" }}
  ,{ "use_bottle_substance_v",            "rm_hallway",               { "get_bottle_substance_v" }}
  ,{ "use_brush",                         "rm_hallway",               { "get_brush", "use_bottle_substance_a", "use_bottle_substance_b", "use_bottle_substance_v" }}
  ,{ "get_gluedbrush",                    "rm_hallway",               { "use_bottle_substance_a", 
                                                                        "use_bottle_substance_b", 
                                                                        "use_bottle_substance_v", 
                                                                        "use_brush"              }}
  ,{ "use_gluedbrush",                    }
  ,{ "get_statue",                        }

  ,{ "use_statue",                        "rm_mansion",               { "get_statue"        }}
  ,{ "get_prv_curtainrope",               "rm_mansion",               { "use_statue"        }}
  ,{ "use_chisel_3",                      "rm_mansion",               { "get_chisel", "get_stone" }}
  ,{ "use_stone",                         "rm_mansion",               { "use_chisel_3"           }}
  ,{ "get_prv_flowerpot",                 "rm_mansion",               { "use_stone"              }}

  ,{ "use_providence_curtainrope",        "rm_hallway",               { "get_prv_curtainrope"    }}
  ,{ "use_providence_flowerpot",          "rm_hallway",               { "get_prv_flowerpot"      }}
  ,{ "vid_hallway_providence",            "rm_hallway",               { "use_providence_curtainrope", "use_providence_flowerpot"}}
  
  ,{ "opn_ladder",                        "rm_hallway",               { "vid_hallway_providence" }}
  ,{ "win_ladder",                        "rm_hallway",               { "vid_hallway_providence"             }}

  ,{ "use_chamberkey",                    "rm_hallway",               { "win_ladder"             }}
  ,{ "opn_chamber",                       "rm_hallway",               { "use_chamberkey"             }}
  ,{ "clk_providence_chair",              "rm_chamber",               { "opn_chamber"       }}
  ,{ "clk_providence_curtain",            "rm_chamber",               { "opn_chamber"       }}
  ,{ "get_prv_photoalbum_silhouette",     "rm_chamber",               { "opn_chamber"       }}
  ,{ "get_prv_figurine_silhouette",       "rm_chamber",               { "opn_chamber"       }}
  ,{ "get_glasspiece",                    "rm_chamber",               { "opn_chamber"       }}

  ,{ "use_glasspiece",                    "rm_hallway",               { "get_glasspiece"         }}
  ,{ "get_book",                          "rm_hallway",               { "use_glasspiece"         }}

  ,{ "use_book",                          "rm_chamber",               { "get_book"               }}
  ,{ "win_bookcabinet",                   "rm_chamber",               { "use_book"               }}

  ,{ "get_photoalbum",                    "rm_chamber",               { "use_book"               }}
  ,{ "get_opener",                        "rm_chamber",               { "use_book"               }}
  ,{ "use_glasspiece_2",                    }
  ,{ "get_prv_photoalbum",                }
  ,{ "get_evidence_3_2",                  }

  ,{ "use_opener",                        "rm_hallway",               { "get_opener"             }}
  ,{ "win_bolts",                         "rm_hallway",               { "use_opener"             }}  -- ММГ_Пары
  ,{ "get_hatchhandle",                   "rm_hallway",               { "win_bolts"              }}

  ,{ "use_hatchhandle",                   "rm_chamber",               { "get_hatchhandle"        }}
  ,{ "clk_hatchhandle",                   "rm_chamber",               { "use_hatchhandle"        }}
  ,{ "use_elf_9",                         "rm_chamber",               { "clk_hatchhandle"        }}
  ,{ "get_prv_figurine",                  "rm_chamber",               { "use_elf_9"              }}
  ,{ "use_providence_photoalbum",         "rm_chamber",               { "get_prv_photoalbum"     }}
  ,{ "use_providence_figurine",           "rm_chamber",               { "get_prv_figurine"       }}
  ,{ "vid_chamber_providence",            "rm_chamber",               { "use_providence_photoalbum", "use_providence_figurine"}}

  ,{ "clk_hatch",                         "rm_chamber",               { "vid_chamber_providence" }}
  ,{ "vid_chamber_owlman",                "rm_chamber",               { "clk_hatch"              }}
  ,{ "dlg_chamber_owlman",                "rm_chamber",               { "vid_chamber_owlman"     }}
  ,{ "win_evidence_3_3",                  } --блокнот
  ,{ "get_evidence_3_3" }
  ,{ "vid_evidence_6"       }
  ,{ "dlg_chamber_owlman_2",              "rm_chamber",               { "vid_evidence_6"     }}

  ,{ "vid_hos_attack",                 "rm_pier_3",                { "opn_pier_3"             }}
  ,{ "opn_hos",                           }
  ,{ "win_hos",                           }
  ,{ "opn_pier_3"                         }  
  ,{ "get_elf_3",                         "rm_pier_3",                { "opn_pier_3", "win_hos"             }}
  ,{ "clk_bag",                           "rm_pier_3",                { "opn_pier_3", "win_hos"             }}
  ,{ "get_bag_2",                         "rm_pier_3",                { "clk_bag"                }}

  ,{ "use_elf_10",                        "rm_pier_3",                { "get_elf_3"                }}
  ,{ "get_crowbar_4",                     "rm_pier_3",                { "use_elf_10"                }}
  ,{ "use_crowbar_4",                     "rm_pier_3",                { "get_crowbar_4"          }}
  ,{ "get_burner",                        "rm_pier_3",                { "use_crowbar_4"          }}

  ,{ "use_burner",                        "rm_pier_3",                { "get_burner"             }}

  ,{ "opn_fork_3"                         }
  ,{ "vid_fork_3_gathering",              "rm_fork_3",                { "use_burner", "opn_fork_3"             }}
  ,{ "dlg_fork_3_mary",                   "rm_fork_3",                { "vid_fork_3_gathering"   }}
  ,{ "opn_square_3"                       }
  ,{ "opn_sheriffshouse",                 "rm_square_3",              { "dlg_fork_3_mary"   }}
  ,{ "get_collect_item_3_2" }
  ,{ "get_collect_morph_item_3_4" }
  ,{ "get_carkeys",                       "rm_sheriffshouse",         { "opn_sheriffshouse"      }}
  ,{ "opn_livingroom_3"                   }
  ,{ "opn_office_3"                       }
  ,{ "opn_basement_3"                     }
  ,{ "opn_abandoneddistrict_3"            }
  ,{ "use_carkeys",                       "rm_square_3",              { "opn_square_3", 
                                                                        "get_carkeys"            }}
  ,{ "get_hat",                           "rm_square_3",              { "use_carkeys"            }}
  ,{ "get_evidence_3_4",                  "rm_square_3",              { "get_hat"                }}
  ,{ "get_lockpick",                      "rm_square_3",              { "use_carkeys"            }}

  ,{ "use_elf_11",                        "rm_fork_3",                { "vid_fork_3_gathering"   }}
  ,{ "use_hat",                           "rm_fork_3",                { "get_hat", "use_elf_11"             }}
  ,{ "get_fullhat",                       "rm_fork_3",                { "use_hat"                }}

  ,{ "use_fullhat",                       "rm_sheriffshouse",         { "get_fullhat"            }}
  ,{ "use_lockpick",                      "rm_sheriffshouse",         { "get_lockpick"           }}
  ,{ "get_glasscutter",                   "rm_sheriffshouse",         { "use_lockpick"           }}
  ,{ "get_gloveboxhandle",                "rm_sheriffshouse",         { "use_lockpick"           }}
  ,{ "clk_doorknob",                      "rm_square_3",              { "use_carkeys"            }}
  ,{ "use_gloveboxhandle",                "rm_square_3",              { "get_gloveboxhandle"     }}
  ,{ "get_glasscutterpart",               "rm_square_3",              { "use_gloveboxhandle"     }}
  ,{ "use_glasscutterpart",               }
  ,{ "get_workingglasscutter",            }

  ,{ "use_workingglasscutter",            "rm_sheriffshouse",         { "get_workingglasscutter" }}
  ,{ "clk_handle_3",                      "rm_sheriffshouse",         { "use_workingglasscutter" }}
  ,{ "opn_wincards",                      "rm_sheriffshouse",         { "clk_handle_3" }}
  ,{ "get_collect_morph_item_3_5" }
  ,{ "clk_providence_armchair",           "rm_wincards",              { "opn_wincards"           }}
  ,{ "clk_providence_stairs",             "rm_wincards",              { "opn_wincards"           }}
  ,{ "get_prv_handcuffs_silhouette",      "rm_wincards",              { "opn_wincards" }}
  ,{ "get_prv_fuellamp_silhouette",       "rm_wincards",              { "opn_wincards" }}

  ,{ "get_candle",                        "rm_wincards",               { "opn_wincards"          }} 
  ,{ "get_fuelsawchain",                  "rm_wincards",               { "opn_wincards"          }}
  ,{ "use_fuelsawchain",                  }
  ,{ "get_workingfuelsaw",                }

  ,{ "use_workingfuelsaw",                "rm_fork_3",                { "get_workingfuelsaw"     }}
  ,{ "get_stick",                         "rm_fork_3",                { "use_workingfuelsaw"     }}

  ,{ "use_stick",                         "rm_sheriffshouse",         { "get_stick"              }}
  ,{ "get_prv_fuellamp",                  "rm_sheriffshouse",         { "use_stick"              }}
  ,{ "get_button_1",                      "rm_sheriffshouse",         { "use_stick"              }}

  ,{ "use_button_1",                      "rm_wincards",              { "get_button_1"           }}
  ,{ "clk_button_1",                      "rm_wincards",              { "use_button_1"           }}
  ,{ "get_gear_1",                        "rm_wincards",              { "clk_button_1"           }}
  ,{ "get_prv_handcuffs",                 "rm_wincards",              { "clk_button_1"           }}
  ,{ "use_providence_fuellamp",           "rm_wincards",              { "get_prv_fuellamp"       }}
  ,{ "use_providence_handcuffs",          "rm_wincards",              { "get_prv_handcuffs"      }}
  ,{ "vid_wincards_providence",           "rm_wincards",              { "use_providence_fuellamp", "use_providence_handcuffs"}}

  ,{ "get_penknife",                      "rm_wincards",              { "clk_button_1"           }}
  ,{ "use_penknife",                      "rm_sheriffshouse",         { "win_hos", "opn_sheriffshouse" }}
  ,{ "get_bottleofwine",                  "rm_sheriffshouse",         { "use_penknife"           }}

  ,{ "use_bottleofwine",                  "rm_wincards",              { "get_bottleofwine", "opn_wincards" }}
  -- МГ_Бутылки
  ,{ "win_bottles",                       "rm_wincards",              { "use_bottleofwine" }}
  ,{ "clk_tap_bottles",                   "rm_wincards",              { "win_bottles" }}
  ,{ "get_tap",                           "rm_wincards",              { "clk_tap_bottles" }}
  ,{ "use_tap",                           "rm_wincards",              { "get_tap"                }}
  ,{ "clk_tap",                           "rm_wincards",              { "use_tap"                }}

  ,{ "opn_secretroom",                    "rm_wincards",              { "clk_tap"                }}
  ,{ "get_collect_morph_item_3_6" }
  ,{ "get_collect_item_3_3" }
  ,{ "get_lighter",                       "rm_secretroom",            { "opn_secretroom"         }}
  ,{ "use_lighter",                       }
  ,{ "get_litcandle",                     }
  ,{ "use_litcandle",                     "rm_secretroom",            { "get_litcandle"          }}
  ,{ "win_breaker",                       "rm_secretroom",            { "use_litcandle"          }}
  ,{ "clk_switch_1",                      "rm_secretroom",            { "win_breaker"            }}
  ,{ "clk_providence_plate",              "rm_secretroom",            { "opn_secretroom"         }}
  ,{ "clk_providence_towldummy",          "rm_secretroom",            { "opn_secretroom"         }}
  ,{ "get_prv_gnomehead_silhouette",      "rm_secretroom",            { "opn_secretroom" }}
  ,{ "get_prv_gun_silhouette",            "rm_secretroom",            { "opn_secretroom" }}

  ,{ "get_awl",                           "rm_secretroom",            { "clk_switch_1"         }}
  ,{ "get_gnomefragment",                 "rm_secretroom",            { "clk_switch_1"         }}
  ,{ "get_evidence_3_5",                  "rm_secretroom",            { "clk_switch_1"         }}

  ,{ "use_gnomefragment",                 "rm_sheriffshouse",         { "get_gnomefragment"      }}
  ,{ "get_valve",                         "rm_sheriffshouse",         { "use_gnomefragment"      }}
  ,{ "get_prv_gnomehead",                 "rm_sheriffshouse",         { "use_gnomefragment"      }}

  ,{ "use_valve",                         "rm_wincards",              { "get_valve"              }}
  ,{ "opn_intable",                       "rm_wincards",              { "use_valve"              }}
  ,{ "win_intable",                       "rm_wincards",              { "use_valve"            }}
  ,{ "use_vicehandle",                    "rm_secretroom",            { "win_intable"         }}
  ,{ "clk_vicehandle",                    "rm_secretroom",            { "use_vicehandle"         }}
  ,{ "get_button_2",                      "rm_secretroom",            { "clk_vicehandle"         }}

  ,{ "use_button_2",                      "rm_wincards",              { "get_button_2"           }}
  ,{ "clk_button_2",                      "rm_wincards",              { "use_button_2"           }}
  ,{ "get_gear_2",                        "rm_wincards",              { "clk_button_2"           }}
  ,{ "get_prv_gun",                       "rm_wincards",              { "clk_button_2"           }}

  ,{ "use_providence_gun",                "rm_secretroom",            { "get_prv_gun"            }}
  ,{ "use_providence_gnomehead",          "rm_secretroom",            { "get_prv_gnomehead"      }}

  ,{ "vid_secretroom_providence",         "rm_secretroom",            { "use_providence_gun", "use_providence_gnomehead"}}

  ,{ "clk_bearskin",                      "rm_secretroom",            { "clk_switch_1" }}
  ,{ "use_tweezers2",                     "rm_secretroom",            { "get_bag_2", "clk_bearskin" }}
  ,{ "get_gear_3",                        "rm_secretroom",            { "use_tweezers2"           }}
  ,{ "use_awl",                           "rm_secretroom",            { "get_gear_3"             }}

  ,{ "use_gear_1",                        "rm_wincards",              { "get_gear_1"             }}
  ,{ "use_gear_2",                        "rm_wincards",              { "get_gear_2"             }}
  ,{ "use_gear_3",                        "rm_wincards",              { "get_gear_3"             }}
  ,{ "get_ring_2",                        "rm_wincards",              { "use_gear_1", 
                                                                        "use_gear_2",
                                                                        "use_gear_3"             }}
  ,{ "use_ring_2",                        "rm_secretroom",            { "get_ring_2"               }}
  ,{ "get_framedphoto",                   "rm_secretroom",            { "use_ring_2"               }}
  ,{ "use_framedphoto",                   "rm_secretroom",            { "get_framedphoto"        }}
  ,{ "win_pictures",                      "rm_secretroom",            { "use_framedphoto"        }}  
  -- ММГ_Фотографии
  ,{ "use_hexkey",                        "rm_secretroom",            { "win_pictures"        }}
  ,{ "opn_secretroom_door",               "rm_secretroom",             { "use_hexkey"            }}
  ,{ "win_superpuzzle_3",                 "rm_secretroom",            { "use_hexkey"             }}
  -- МГ_Суперпаззл №3,
  ,{ "clk_oliver_1",                      "rm_secretroom",            { "win_superpuzzle_3"             }}
  ,{ "clk_oliver_2",                      "rm_secretroom",            { "clk_oliver_1"             }}

  ,{ "dlg_secretroom_oliver",             "rm_secretroom",            { "clk_oliver_2"  }}
  ,{ "get_evidence_3_6",                  "rm_secretroom",            { "dlg_secretroom_oliver"             }}
  ,{ "vid_evidence_7"              }
  
  ,{ "dlg_fork_3_ending",                 "rm_fork_3",               { "vid_evidence_7"         }}
  ,{ "vid_fork_3_autro",                  "rm_fork_3",                { "dlg_fork_3_ending"      }}
  ,{ "get_collect_morph_item_1_1" }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "get_collect_morph_item_1_5" }
  ,{ "get_collect_morph_item_1_6" }
  ,{ "get_collect_morph_item_1_7" }
  ,{ "get_collect_morph_item_2_1" }
  ,{ "get_collect_morph_item_2_2" }
  ,{ "get_collect_morph_item_2_3" }
  ,{ "get_collect_morph_item_2_4" }
  ,{ "get_collect_morph_item_2_5" }
  ,{ "get_collect_morph_item_2_6" }
  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_item_1_2" }
  ,{ "get_collect_item_1_3" }
  ,{ "get_collect_item_2_1" }
  ,{ "get_collect_item_2_2" }
  ,{ "get_collect_item_2_3" }

  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

  common_impl.CheckPrgRules();

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;