-- name=ho_intent
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "intent" );
  game.relations[ "ho_intent" ].exitroom = "rm_forgottenbastille";
  --------------------------------------------------------------------------------------------------
  private.table_ef_ho = {};
  private.table_ef_ho[ "spr_intent_keys" ] = "spr_intent_keys2";
  private.table_ef_ho[ "spr_intent_bugle" ] = "spr_intent_bugle_mouthpiece2";
  private.table_ef_ho[ "spr_intent_saber" ] = "spr_intent_saber2";
  private.table_ef_ho[ "spr_intent_rider" ] = "spr_intent_rider2";
  private.table_spr_del  = { "","","","","","","","","","","spr_intent_saber2","" };

  local table_multiset = {};

  table.insert( table_multiset, { "spr_intent_backpack3", { event_mdown = function() private.TaskComplete( 'backpack', 'spr_intent_backpack3'  ) end } } );
  table.insert( table_multiset, { "spr_intent_rider", { event_mdown = function() private.TaskComplete( 'rider', 'spr_intent_rider' ) end } } );
  table.insert( table_multiset, { "spr_intent_bugle", { event_mdown = function() private.TaskComplete( 'bugle', 'spr_intent_bugle' ) end } } );
  table.insert( table_multiset, { "spr_intent_knives", { event_mdown = function() private.TaskComplete( 'knives', 'spr_intent_knives' ) end } } );
  table.insert( table_multiset, { "spr_intent_dynamite", { event_mdown = function() private.TaskComplete( 'dynamite', 'spr_intent_dynamite' ) end } } );
  table.insert( table_multiset, { "spr_intent_kettle", { event_mdown = function() private.TaskComplete( 'kettle', 'spr_intent_kettle' ) end } } );
  table.insert( table_multiset, { "spr_intent_holster", { event_mdown = function() private.TaskComplete( 'holster', 'spr_intent_holster' ) end } } );
  table.insert( table_multiset, { "spr_intent_keys", { event_mdown = function() private.TaskComplete( 'keys', 'spr_intent_keys' ) end } } );
  table.insert( table_multiset, { "spr_intent_flask", { event_mdown = function() private.TaskComplete( 'flask', 'spr_intent_flask' ) end } } );
  table.insert( table_multiset, { "spr_intent_wheel", { event_mdown = function() private.TaskComplete( 'wheel', 'spr_intent_wheel' ) end } } );
  table.insert( table_multiset, { "spr_intent_saber", { event_mdown = function() private.TaskComplete( 'saber', 'spr_intent_saber' ) end } } );
  table.insert( table_multiset, { "spr_intent_boots", { event_mdown = function() private.TaskComplete( 'boots', 'spr_intent_boots' ) end } } );
  
  table.insert( table_multiset, { "spr_intent_backpack",
 
    { 
      event_startdrag = function() private.GetItem( 'backpack' ) end, 
      event_dragdrop = function() private.unmark_task( "backpack", "backpack" ) end } } 
    );

  table.insert( table_multiset, { "spr_intent_rider3", 
    {
      event_startdrag = function() private.GetItem( 'rider3' ) end, 
      event_dragdrop = function() private.unmark_task( "rider3", "rider") end } } 
    );

  table.insert( table_multiset, { "spr_intent_bugle_mouthpiece", 

    {
      event_startdrag = function() private.GetItem( 'bugle_mouthpiece' ) end, 
      event_dragdrop = function() private.unmark_task( "bugle_mouthpiece", "bugle" ) end } }
    );

  table.insert( table_multiset, { "spr_intent_knive2",
 
  { 
    event_startdrag = function() private.GetItem( 'knive2' ) end, 
    event_dragdrop = function() private.unmark_task( "knive2", "knives") end } } 
  );

  table.insert( table_multiset, { "spr_intent_dynamite_wick2", 
  {
    event_startdrag = function() private.GetItem( 'dynamite_wick2' ) end, 
    event_dragdrop = function() private.unmark_task( "dynamite_wick2", "dynamite") end } } 
  );
  
table.insert( table_multiset, { "spr_intent_kettle_cover", 

  {
    event_startdrag = function() private.GetItem( 'kettle_cover' ) end, 
    event_dragdrop = function() private.unmark_task( "kettle_cover", "kettle") end } } 
  );
  
table.insert( table_multiset, { "spr_intent_holster_bullet1", 

  {
    event_startdrag = function() private.GetItem( 'holster_bullet1' ) end, 
    event_dragdrop = function() private.unmark_task( "holster_bullet1", "holster") end } } 
  );
  
table.insert( table_multiset, { "spr_intent_keys3", 

  {
    event_startdrag = function() private.GetItem( 'keys3' ) end, 
    event_dragdrop = function() private.unmark_task( "keys3", "keys" ) end } } 
  );
  
table.insert( table_multiset, { "spr_intent_flask_cover", 
  {
    event_startdrag = function() private.GetItem( 'flask_cover' ) end, 
    event_dragdrop = function() private.unmark_task( "flask_cover", "flask" ) end } } 
  );
  
table.insert( table_multiset, { "spr_intent_wheel3", 
  { 
    event_startdrag = function() private.GetItem( 'wheel3' ) end, 
    event_dragdrop = function() private.unmark_task( "wheel3", "wheel") end } }
  );

table.insert( table_multiset, { "spr_intent_saber3", 

  { 
    event_startdrag = function() private.GetItem( 'saber3' ) end, 
    event_dragdrop = function() private.unmark_task( "saber3", "saber", "anm_intent_siber" ) end } } 
  );
  
  table.insert( table_multiset, { "spr_intent_brush", 

  { 
    event_startdrag = function() private.GetItem( 'brush' ) end, 
    event_dragdrop = function() private.unmark_task( "brush", "boots", "anm_intent_anm_shoes" ) end } } 
  );


  ObjMultiSet( table_multiset );
  --*******временная заглушка
  ObjSet( "spr_intent_wick", { event_mdown = function() private.win_intent_temp() end } );
  --*************************************

  common_impl.hint[ "win_intent" ] = {
      type = "win",
      room = "rm_forgottenbastille",
      zz = "ho_intent",
      zz_gate = "gho_forgottenbastille_intent"
  };
  
  local win_intent_func = function ()

    if ( cmn.IsEventDone( "win_intent" ) ) then

      interface.InventoryItemAdd( "inv_wick", "spr_intent_win" );
      ObjDelete( "gho_forgottenbastille_intent" );

    end;

  end;
  cmn.AddSubscriber( "win_intent", win_intent_func );
  --------------------------------------------------------------------------------------------------
  -- function opn_intent () end;
  --------------------------------------------------------------------------------------------
  local opn_intent = function ()

    --

  end;

  cmn.AddSubscriber( "opn_intent", opn_intent, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_intent = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 

      {
        "ho_intent",
      };

    common_impl.TurnChildGfx( mas_parent_gfx, "ho_intent", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_intent", update_game_mode_intent, "ho_intent" );
  --------------------------------------------------------------------------------------------------
  local unmark_backpack = function () 
   
    ObjSet( "spr_intent_backpack2", { alp = 1 } );
    ObjSet( "spr_intent_backpack3", { input = true } );
 
    ObjDelete( "spr_intent_backpack" ); 
    ObjDelete( "obj_intent_backpack" );

  end;

  cmn.AddSubscriber( "unmark_backpack", unmark_backpack, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_rider = function () 
   
    ObjSet( "spr_intent_rider2", { alp = 1, event_mdown = function() private.TaskComplete( 'rider', 'spr_intent_rider' ) end } );
    ObjSet( "spr_intent_rider", { input = true } );

    ObjDelete( "spr_intent_rider3" ); 
    ObjDelete( "obj_intent_rider3" );
    ObjDelete( "spr_intent_rider3_shadow" ); 

  end;

  cmn.AddSubscriber( "unmark_rider", unmark_rider, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_bugle = function () 
   
    ObjSet( "spr_intent_bugle_mouthpiece2", { alp = 1, event_mdown = function() private.TaskComplete( 'bugle', 'spr_intent_bugle' ) end } );
    ObjSet( "spr_intent_bugle", { input = true } );
 
    ObjDelete( "spr_intent_bugle_mouthpiece" ); 
    ObjDelete( "obj_intent_bugle_mouthpiece" );
    
  end;

  cmn.AddSubscriber( "unmark_bugle", unmark_bugle, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_knives = function () 
   
    ObjSet( "spr_intent_knive1", { alp = 1 } );
    ObjSet( "spr_intent_knives", { input = true } );
 
    ObjDelete( "spr_intent_knive2" ); 
    ObjDelete( "spr_intent_knive2_shadow" );
    ObjDelete( "obj_intent_knive2" ) 

  end;

  cmn.AddSubscriber( "unmark_knives", unmark_knives, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_dynamite = function () 
   
    ObjSet( "spr_intent_dynamite_wick1", { alp = 1 } );
    ObjSet( "spr_intent_dynamite", { input = true } );
 
    ObjDelete( "spr_intent_dynamite_wick2" ); 
    ObjDelete( "obj_intent_dynamite_wick2" ); 

  end;

  cmn.AddSubscriber( "unmark_dynamite", unmark_dynamite, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_kettle = function () 
   
    ObjSet( "spr_intent_kettle_cover2", { alp = 1 } );
    ObjSet( "spr_intent_kettle", { input = true } );
 
    ObjDelete( "spr_intent_kettle_cover_shadow" ); 
    ObjDelete( "spr_intent_kettle_cover" ); 
    ObjDelete( "obj_intent_kettle_cover" ); 

  end;

  cmn.AddSubscriber( "unmark_kettle", unmark_kettle, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_holster = function () 
   
    ObjSet( "spr_intent_holster_bullet", { alp = 1 } );
    ObjSet( "spr_intent_holster", { input = true } );
 
    ObjDelete( "spr_intent_holster_bullet1_shadow" ); 
    ObjDelete( "spr_intent_holster_bullet1" ); 
    ObjDelete( "obj_intent_holster_bullet1" );
 
  end;

  cmn.AddSubscriber( "unmark_holster", unmark_holster, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_keys = function () 
   
    ObjSet( "spr_intent_keys2", { alp = 1, event_mdown = function() private.TaskComplete( 'keys', 'spr_intent_keys' ) end } );
    ObjSet( "spr_intent_keys", { input = true } );
  
    ObjDelete( "spr_intent_keys3" );  
    ObjDelete( "obj_intent_keys3" );  

  end;

  cmn.AddSubscriber( "unmark_keys", unmark_keys, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_flask = function () 
   
    ObjSet( "spr_intent_flask_cover2", { alp = 1 } );
    ObjSet( "spr_intent_flask", { input = true } );
 
    ObjDelete( "spr_intent_flask_cover" ); 
    ObjDelete( "obj_intent_flask_cover" );
 
  end;

  cmn.AddSubscriber( "unmark_flask", unmark_flask, "ho_intent" );  
  --------------------------------------------------------------------------------------------------
  local unmark_wheel = function () 
   
    ObjSet( "spr_intent_wheel2", { alp = 1, event_mdown = function() private.TaskComplete( 'wheel', 'spr_intent_wheel' ) end } );
    ObjSet( "spr_intent_wheel", { input = true } );
 
    ObjDelete( "spr_intent_wheel3_shadow" ); 
    ObjDelete( "spr_intent_wheel3" ); 
    ObjDelete( "obj_intent_wheel3" ); 

  end;

  cmn.AddSubscriber( "unmark_wheel", unmark_wheel, "ho_intent" );
  --------------------------------------------------------------------------------------------------
  local unmark_saber = function () 
   
    ObjSet( "spr_intent_saber2", { alp = 1, event_mdown = function() private.TaskComplete( 'saber', 'spr_intent_saber' ) end } );
    ObjSet( "spr_intent_saber", { input = true } );
 
    ObjDelete( "spr_intent_saber3" ); 
    ObjDelete( "spr_intent_saber3_shadow" ); 
    ObjDelete( "anm_intent_siber" );
    ObjDelete( "obj_intent_saber3" ); 

  end;

  cmn.AddSubscriber( "unmark_saber", unmark_saber, "ho_intent" );
  --------------------------------------------------------------------------------------------------
  local unmark_boots = function () 
   
    ObjSet( "spr_intent_boots", { input = true } );
 
    ObjDelete( "spr_intent_boots_dirt" ); 
    ObjDelete( "spr_intent_brush" ); 
    ObjDelete( "spr_intent_brush_shadow" );
    ObjDelete( "anm_intent_anm_shoes" );
    ObjDelete( "obj_intent_brush" ); 

  end;

  cmn.AddSubscriber( "unmark_boots", unmark_boots, "ho_intent" );
  --------------------------------------------------------------------------------------------------
  local start_intent_func = function ()

    if ( cmn.IsEventStart( "win_intent" ) ) then

      --cmn.ProcessHoStart( "intent" );
      local ho_found = ng_global.progress[ "ext" ][ "win_intent" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

        if ( ho_found[ i ][ "object" ] == "spr_intent_saber" ) then

          ObjDelete( "spr_intent_saber2" );

        end;

      end;

     if cmn.IsUnmarkedTask( "intent", "backpack" ) then
          unmark_backpack();
      end;

     if cmn.IsUnmarkedTask( "intent", "rider" ) then
          unmark_rider();
      end;

     if cmn.IsUnmarkedTask( "intent", "bugle" ) then
          unmark_bugle();
      end;

     if cmn.IsUnmarkedTask( "intent", "knives" ) then
          unmark_knives();
      end;

     if cmn.IsUnmarkedTask( "intent", "dynamite" ) then
          unmark_dynamite();
      end;

     if cmn.IsUnmarkedTask( "intent", "kettle" ) then
          unmark_kettle();
      end;

     if cmn.IsUnmarkedTask( "intent", "holster" ) then
          unmark_holster();
      end;

     if cmn.IsUnmarkedTask( "intent", "keys" ) then
          unmark_keys();
      end;

     if cmn.IsUnmarkedTask( "intent", "flask" ) then
          unmark_flask();
      end;

     if cmn.IsUnmarkedTask( "intent", "wheel" ) then
          unmark_wheel();
      end;

     if cmn.IsUnmarkedTask( "intent", "saber" ) then
          unmark_saber();
      end;

     if cmn.IsUnmarkedTask( "intent", "boots" ) then
          unmark_boots();
      end;

    end;

  end;
  cmn.AddSubscriber( "win_intent", start_intent_func, "ho_intent" );  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  common_impl.EnvPlay( { "common/audio/aud_ho_intent_env" }, "", 0.5 );

  int_slider.InitSlider( "ho_intent" );

  if ( not cmn.IsEventDone( "opn_intent" ) ) then
  
    cmn.InitHo( "intent" );
    cmn.SetEventDone( "opn_intent" );

    cmn.SetMarkedTask( "intent", "backpack" );
    cmn.SetMarkedTask( "intent", "rider" );
    cmn.SetMarkedTask( "intent", "bugle" );
    cmn.SetMarkedTask( "intent", "knives" );
    cmn.SetMarkedTask( "intent", "dynamite" );
    cmn.SetMarkedTask( "intent", "kettle" );
    cmn.SetMarkedTask( "intent", "holster" );
    cmn.SetMarkedTask( "intent", "keys" );
    cmn.SetMarkedTask( "intent", "flask" );
    cmn.SetMarkedTask( "intent", "wheel" );
    cmn.SetMarkedTask( "intent", "saber" );
    cmn.SetMarkedTask( "intent", "boots" );

  end;

  local ho_items = {};

   interface.TaskPanelTaskAdd( ho_items, "backpack",       1, 1, {  { "spr_intent_backpack", "obj_intent_backpack" }                   ,{ "spr_intent_backpack3" } } );
   interface.TaskPanelTaskAdd( ho_items, "rider",          1, 1, {  { "spr_intent_rider3", "obj_intent_rider3" }                       ,{ "spr_intent_rider" } } );
   interface.TaskPanelTaskAdd( ho_items, "bugle",          1, 1, {  { "spr_intent_bugle_mouthpiece", "obj_intent_bugle_mouthpiece" }   ,{ "spr_intent_bugle" } } );
   interface.TaskPanelTaskAdd( ho_items, "knives",         1, 1, {  { "spr_intent_knive2", "obj_intent_knive2" }                       ,{ "spr_intent_knives" } } );
   interface.TaskPanelTaskAdd( ho_items, "dynamite",       1, 1, {  { "spr_intent_dynamite_wick2", "obj_intent_dynamite_wick2" }       ,{ "spr_intent_dynamite" } } );
   interface.TaskPanelTaskAdd( ho_items, "kettle",         1, 1, {  { "spr_intent_kettle_cover", "obj_intent_kettle_cover" }           ,{ "spr_intent_kettle" } } );
   interface.TaskPanelTaskAdd( ho_items, "holster",        1, 1, {  { "spr_intent_holster_bullet1", "obj_intent_holster_bullet1" }     ,{ "spr_intent_holster" } } );
   interface.TaskPanelTaskAdd( ho_items, "keys",           1, 1, {  { "spr_intent_keys3", "obj_intent_keys3" }                         ,{ "spr_intent_keys" } } );
   interface.TaskPanelTaskAdd( ho_items, "flask",          1, 1, {  { "spr_intent_flask_cover", "obj_intent_flask_cover" }             ,{ "spr_intent_flask" } } );
   interface.TaskPanelTaskAdd( ho_items, "wheel",          1, 1, {  { "spr_intent_wheel3", "obj_intent_wheel3" }                       ,{ "spr_intent_wheel" } } );
   interface.TaskPanelTaskAdd( ho_items, "saber",          1, 1, {  { "spr_intent_saber3", "obj_intent_saber3" }                       ,{ "spr_intent_saber2" } } );
   interface.TaskPanelTaskAdd( ho_items, "boots",          1, 1, {  { "spr_intent_brush", "obj_intent_brush" }                         ,{ "spr_intent_boots" } } );


  interface.TaskPanelShow( ho_items );


end;
--*********************************************************************************************************************
function public.Open()
  
  common_impl.VisitMapRoom( "forgottenbastille" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  common_impl.PassingHoStop();
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )
 
  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_intent_"..task_name;

  end;
 
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );

  if private.table_ef_ho[ object_name ] then
  
    private.Effect_HO( private.table_ef_ho[ object_name ] );

  end;
end;
--*********************************************************************************************************************
function private.win_intent_temp()

  cmn.SetEventDone( "win_intent" );
  cmn.CallEventHandler( "win_intent" );

  cmn.GotoRoom( "rm_forgottenbastille" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.GetItem( name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 ); 

  if ObjGet( "spr_intent_"..name.."_shadow" ) then

    ObjSet( "spr_intent_"..name.."_shadow", { alp = 0  } );

  end;

  if ( ObjGet( "spr_intent_"..name.."_anm" ) ) then

    ObjSet( "spr_intent_"..name.."_anm", { pos_z = 20 } );

  else

    ObjSet( "spr_intent_"..name, { pos_z = 20 } );

  end;
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------------
function private.unmark_task( obj, task, name_anm )

  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_intent_"..obj, "obj_intent_"..obj ) ) then

    common_impl.Lock(true);

    local func_after = function()

      common_impl.Lock(false);

      cmn.UnmarkTask( "intent", task );
      cmn.CallEventHandler( "unmark_"..task );

    end;
    
    --ObjSet( name_anm, "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_intent_"..task, 0, "", 0 );

    if name_anm then 

      ObjSet( "spr_intent_"..obj, { alp = 0 } );

      ObjSet( name_anm, { alp = 1, playing = true, endtrig = func_after } );

    else

      func_after();

    end;

  else
    
    if ObjGet( "spr_intent_"..obj.."_shadow" ) then

      ObjSet( "spr_intent_"..obj.."_shadow", { alp = 1  } );

    end;

    if ( ObjGet( "obj_intent_"..obj.."_anm" ) ) then

      ObjSet( "obj_intent_"..obj.."_anm", { pos_z = 0 } )

    else

      ObjSet( "spr_intent_"..obj, { pos_z = 0 } ); 

    end;
  
  end;

end;
--------------------------------------------------------------------------------------------------
function private.Effect_HO( object_name )

local collect_pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );

  local collect_drawoff_x = ObjGet( object_name ).drawoff_x;
  local collect_drawoff_y = ObjGet( object_name ).drawoff_y;
  
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;

  ObjAttach( object_name, InterfaceWidget_Top_Name );
  ObjSet( object_name ,{ pos_x = collect_pos[1], pos_y = collect_pos[2], input = false });
  
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho",
    pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
    active = 1, visible = 1, input = 0, pos_z = 10
  } );

  ObjAttach( collect_name, InterfaceWidget_Top_Name );
  ObjSet(collect_name, {blendmode = 2});
  
  PartSysSetMaskObj( collect_name, object_name );

  local endfunc = function()
  
    ObjDelete(object_name);

  end;
  
  ObjAnimate( object_name, "alp",0,0, endfunc,
  { 
      0.0, 0, 1,
      0.5, 0, 1,
      1.0, 0, 0
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--                                             Light_Animations
--*********************************************************************************************************************
ObjAnimate( "obj_intent_anims_light", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    0.8, 3, 0.2, 
    2.0, 3, 1.0, 
    3.0, 3, 0.3, 
    4.1, 3, 1.0, 
    5.2, 3, 0.1, 
    6.3, 3, 0.7, 
    7.4, 3, 1.0, 
    7.6, 3, 0.2, 
    8.0, 3, 1.0, 

  });

ObjAnimate( "spr_intent_lamp", "alp", 1, 0, "", 

  { 
    1.0, 3, 1.0, 
    2.0, 3, 1.0,
    2.5, 3, 0.4,
    3.0, 3, 1.0, 
    3.4, 3, 0.6, 
    4.0, 3, 1.0, 
    4.3, 3, 0.4,
    4.6, 3, 1.0, 
    5.0, 3, 0.8,
    6.3, 3, 0.5, 
    6.7, 3, 1.0,   

  });
--*********************************************************************************************************************
--                                             Branch_Animations
--*********************************************************************************************************************

ObjAnimate( "spr_intent_branch1", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.001, 
    0.8, 3, -0.0015, 
    2.0, 3, 0.0011, 
    3.0, 3, -0.0017, 
    4.1, 3, 0.0013, 
    5.2, 3, -0.0013, 
    6.3, 3, 0.0016, 
    7.4, 3, -0.0015, 
    7.6, 3, -0.001, 
    8.0, 3, 0.001, 

  });

ObjAnimate( "spr_intent_branch2", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.01, 
    1.2, 3, -0.015, 
    2.0, 3, 0.011, 
    5.0, 3, -0.017, 
    7.1, 3, 0.013, 
    8.2, 3, -0.013, 
    9.3, 3, 0.016, 
    9.4, 3, -0.015, 
   10.6, 3, -0.01, 
   11.0, 3, 0.01, 

  });

ObjAnimate( "spr_intent_keys", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.01, 
    1.0, 3, -0.015, 
    2.0, 3, 0.011, 
    3.0, 3, -0.017, 
    4.0, 3, 0.01,

  });

ObjAnimate( "spr_intent_bugle", "ang", 1, 0, "", 

  { 
    0.0, 3, -0.004, 
    1.0, 3, 0.0065, 
    2.0, 3, -0.0051, 
    3.0, 3, 0.0047, 
    4.0, 3, -0.004,

  });


ObjAnimate( "obj_intent_bugle_mouthpiece_anm", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.007, 
    1.2, 3, -0.0085, 
    2.4, 3, 0.0051, 
    3.6, 3, -0.0067, 
    4.8, 3, 0.007,

  });


ObjAnimate( "obj_intent_flask_cover_anm", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.007, 
    1.2, 3, -0.0085, 
    2.4, 3, 0.0051, 
    3.6, 3, -0.0067, 
    4.8, 3, 0.007,

  });

ObjAnimate( "obj_intent_flask_anm", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.007, 
    1.2, 3, -0.0085, 
    2.4, 3, 0.0051, 
    3.6, 3, -0.0067, 
    4.8, 3, 0.007,

  });

ObjAnimate( "obj_intent_dynamite_wick2_anm", "ang", 1, 0, "", 

  { 
    0.0, 3, 0.01, 
    1.0, 3, -0.015, 
    2.0, 3, 0.011, 
    3.0, 3, -0.017, 
    4.0, 3, 0.01,

  });

--*********************************************************************************************************************
--*********************************************************************************************************************