-- name=mg_gate_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_gate_scr";

  for i = 1, 10 do

    ObjSet( "spr_gate_scr_cogs_"..i, { event_startdrag = function() private.DragCogwheel( i ); common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_gate_get_gear', 0, '', 0 ); end, event_dragdrop = function() private.DropCogwheel( i ) end; } );
    ObjSet( "spr_gate_scr_cogs_"..i.."_intersect", { event_mdown = function() ObjStartDrag( "spr_gate_scr_cogs_"..i ); private.DragCogwheel( i ) end, event_dragdrop = function() private.DropCogwheel( i ) end; } );

    ObjSet( "spr_gate_scr_2_cogs_"..i, { event_startdrag = function() private.DragCogwheel( i ); common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_gate_get_gear', 0, '', 0 ); end, event_dragdrop = function() private.DropCogwheel( i ) end; } );
    ObjSet( "spr_gate_scr_2_cogs_"..i.."_intersect", { event_mdown = function() ObjStartDrag( "spr_gate_scr_2_cogs_"..i ); private.DragCogwheel( i ) end, event_dragdrop = function() private.DropCogwheel( i ) end; } );

    ObjSet( "spr_gate_scr_3_cogs_"..i, { event_startdrag = function() private.DragCogwheel( i ); common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_gate_get_gear', 0, '', 0 ); end, event_dragdrop = function() private.DropCogwheel( i ) end; } );
    ObjSet( "spr_gate_scr_3_cogs_"..i.."_intersect", { event_mdown = function() ObjStartDrag( "spr_gate_scr_3_cogs_"..i ); private.DragCogwheel( i ) end, event_dragdrop = function() private.DropCogwheel( i ) end; } );

  end;

  private.coords = { { 58,61 }, { 105,184 }, { 84,327 }, { 149,450 }, { 272,246 }, { 874,139 }, { 869, 262 }, { 954,351 }, { 968,503 }, { 836, 461 } };
  private.number = 0;
  private.state = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  private.win = { 6, 9, 7, 2, 10, 1, 5, 3, 8, 4 };
  private.numstate = { };

  private.coords_2 = { {64,57}, {101,167}, {84,304}, {237,282}, {157,447}, {830,213}, {965,203}, {961,350}, {845,457}, {975,503} };
  private.win_2 = { 4, 8, 9, 3, 1, 10, 2, 7, 5, 6 };

  private.coords_3 = { {114,147}, {176,229}, {204,353}, {182,482}, {46,443}, {915,145}, {964,255}, {964,400}, {844,511}, {764,391} };
  private.win_3 = { 3, 5, 1, 8, 4, 10, 9, 7, 2, 6 };

  local win_gate_scr = function ()

    if ( cmn.IsEventDone( "win_gate_scr" ) ) then  

      --
      
    else

      local infix = "";

      if ng_global.progress[ "scr" ][ "win_gate_scr" ].numb == 2 then

        private.coords = private.coords_2;
        private.win = private.win_2;
        infix = "_2"

      elseif ng_global.progress[ "scr" ][ "win_gate_scr" ].numb == 3 then

        private.coords = private.coords_3;
        private.win = private.win_3;
        infix = "_3"

      end;

      for i = 1, #ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate do
        ObjSet( "spr_gate_scr"..infix.."_cogs_"..ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate[i], { pos_x = private.coords[i][1], pos_y = private.coords[i][2]  } );
      end;

    end;

  end;

  cmn.AddSubscriber( "win_gate_scr", win_gate_scr, private.room_objname );  
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.TutorialShow( "tutorial_page_6_scr" );
  
  if not cmn.IsEventDone( "win_gate_scr" ) then

    cmn.MiniGameShow();
    --common_impl.PassingMgStart();

    for j = 1, 10 do

      private.numstate[j] = ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate[j];
      
    end;

    private.CheckWin();

    int_button_timer.Show();
   
  end;
  
  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_gate_scr" ) and cmn.IsEventStart( "win_gate_scr" )  then
    
    ng_global.progress[ "scr" ][ "win_gate_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_gate_scr" ].start = 0;
    is_repeat = true;

  end; 

  if ( not cmn.IsEventStart( "win_gate_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
    ng_global.progress[ "scr" ][ "win_gate_scr" ].timer = { default = 40, time = 40, diff = 20, extra = 0 };
    ng_global.progress[ "scr" ][ "win_gate_scr" ].numb = 1;

    private.ResetInit();
    
  end;

  common_impl.PlayAudio( "env", "common/audio/aud_mg_gate_broken_gears_env", 1, "", 0 );
  
  interface.InvestigationButtonCheck();

  if ng_global.progress[ "scr" ][ "win_gate_scr" ].numb == 1 then

    ObjSet( "obj_gate_scr_mg",       { alp = 1, input = true,  visible = true  } );
    ObjSet( "obj_gate_scr_mg_2",     { alp = 0, input = false, visible = false } );
    ObjSet( "obj_gate_scr_mg_3",     { alp = 0, input = false, visible = false } );

  elseif ng_global.progress[ "scr" ][ "win_gate_scr" ].numb == 2 then

    ObjSet( "obj_gate_scr_mg",       { alp = 0, input = false, visible = false } );
    ObjSet( "obj_gate_scr_mg_2",     { alp = 1, input = true,  visible = true  } );
    ObjSet( "obj_gate_scr_mg_3",     { alp = 0, input = false, visible = false } );

  elseif ng_global.progress[ "scr" ][ "win_gate_scr" ].numb == 3 then

    ObjSet( "obj_gate_scr_mg",       { alp = 0, input = false, visible = false } );
    ObjSet( "obj_gate_scr_mg_2",     { alp = 0, input = false, visible = false } );
    ObjSet( "obj_gate_scr_mg_3",     { alp = 1, input = true,  visible = true  } );

  end;

  if is_repeat then
 
    public.ResetStart();

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_gate_scr" ) then

    cmn.MiniGameHide();
    --common_impl.PassingMgStop();

  end;

  int_button_timer.Hide();
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function public.Reset()

  ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
  private.numstate = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };

  local numb = ng_global.progress[ "scr" ][ "win_gate_scr" ].numb;
  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  for i = 1, #ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate do
     ObjSet( "spr_gate_scr"..infix.."_cogs_"..ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate[i], { pos_x = private.coords[i][1], pos_y = private.coords[i][2], input = true  } );
     ObjSet( "spr_gate_scr"..infix.."_cogs_"..ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate[i].."_light", { visible = false  } );
  end;

end;
--*********************************************************************************************************************
function private.ResetInit()

  local numb = math.random( 1, 3 );
  ng_global.progress[ "scr" ][ "win_gate_scr" ].numb = numb;

  if numb == 1 then

    private.coords = { { 58,61 }, { 105,184 }, { 84,327 }, { 149,450 }, { 272,246 }, { 874,139 }, { 869, 262 }, { 954,351 }, { 968,503 }, { 836, 461 } };
    private.win = { 6, 9, 7, 2, 10, 1, 5, 3, 8, 4 };
    
  elseif numb == 2 then

    private.coords = private.coords_2;
    private.win = private.win_2;

  elseif numb == 3 then

    private.coords = private.coords_3;
    private.win = private.win_3;

  end;

end;
--*********************************************************************************************************************
function public.ResetStart()

  ObjMultiSet( {
    { "obj_gate_scr_mg", { alp = 1 } },
    { "anm_gate_scr_loop", { alp = 1 } },
    { "obj_gate_scr_decor", { alp = 1 } },
    { "anm_gate_scr_win", { alp = 0 } },
    { "anm_gate_scr_win_2", { alp = 0 } },
    { "anm_gate_scr_win_3", { alp = 0 } },
    { "spr_gate_scr_wings", { alp = 1 } }
  } );

  public.Reset();

end;
--*********************************************************************************************************************
function public.Skip()

  

end;
--*********************************************************************************************************************
function private.WinEnd()
  
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_gate_scr" );
  --common_impl.PassingMgWin();

  common_impl.Lock( false );
  cmn.CallEventHandler( "win_gate_scr" );
  
  rm_mysteryroom.WinTask();
  
  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function private.Win()

  local numb = ng_global.progress[ "scr" ][ "win_gate_scr" ].numb;

  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  ObjMultiSet( {

  { "obj_gate_scr_mg", { alp = 0 } },
  { "obj_gate_scr_mg_2", { alp = 0 } },
  { "obj_gate_scr_mg_3", { alp = 0 } },
  { "anm_gate_scr_loop", { alp = 0 } },
  { "obj_gate_scr_decor", { alp = 0 } },
  { "anm_gate_scr_win"..infix, { alp = 1 } },
  { "spr_gate_scr_wings", { alp = 0 } }

  } );

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_win", 0, "", 0 );

  common_impl.StopAudio( "env", "common/audio/aud_mg_gate_broken_gears_env", 0.5 );
  
  AnimPlay( "anm_gate_scr_win"..infix, "DoAnim", private.WinEnd );

end;

private.pos_start_drag_x = 0;
private.pos_start_drag_y = 0;
--*********************************************************************************************************************
function private.DragCogwheel( number )

  local numb = ng_global.progress[ "scr" ][ "win_gate_scr" ].numb;
  
  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  ObjSet( "spr_gate_scr"..infix.."_cogs_"..number, { pos_z = 5 } );
  private.pos_start_drag_x = ObjGet( "spr_gate_scr"..infix.."_cogs_"..number ).pos_x;
  private.pos_start_drag_y = ObjGet( "spr_gate_scr"..infix.."_cogs_"..number ).pos_y;
  
  
  for i = 1, #private.coords do

    if ObjGet( "spr_gate_scr"..infix.."_cogs_"..number ).pos_x == private.coords[i][1] and ObjGet( "spr_gate_scr"..infix.."_cogs_"..number ).pos_y == private.coords[i][2] then

       private.number = i;

       break;

    end;

  end;
 
end;
--*********************************************************************************************************************
function private.DropCogwheel( number )
    
  local new_number = 0;
  local change_flag = false;
  local param_old = GetGameCursorPos();

  if (tostring(GetPlatform()) == "ios") or (tostring(GetPlatform()) == "android") then
    param_old[2] = param_old[2]+50;
  end;
  
  local numb = ng_global.progress[ "scr" ][ "win_gate_scr" ].numb;

  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  local func_after = function( num )

    common_impl.Lock( false );

    --ObjStartDrag( "spr_gate_scr"..infix.."_cogs_"..new_number );
    ObjSet("spr_gate_scr"..infix.."_cogs_"..num,{ pos_x = private.pos_start_drag_x, pos_y = private.pos_start_drag_y });
    private.DropCogwheel(num);
    
    common_impl.SetCursor( CURSOR_HAND );
    private.state[new_number] = 0;
       
    if private.CheckWin() == true then

      private.Win();

    end;

  end;

  for i = 1, 10 do

    if ( common.ApplyObj( "spr_gate_scr"..infix.."_cogs_"..number.."_intersect", "spr_gate_scr"..infix.."_cogs_"..i.."_intersect" ) and i ~= number and ObjGet( "spr_gate_scr"..infix.."_cogs_"..i ).input == true ) then
       
        local param_new = ObjGet( "spr_gate_scr"..infix.."_cogs_"..i );  
        new_number = i;
        change_flag = true;

        common_impl.Lock( true );

        for j = 1, #private.coords do

          if param_new.pos_x == private.coords[j][1] and param_new.pos_y == private.coords[j][2] then

             private.numstate[j] = number;

             if private.numstate[j] == private.win[j] then

              common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear_true", 0, "", 0 );

             else

              common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear", 0, "", 0 );

             end;

          end;

        end;

        ObjSet( "spr_gate_scr"..infix.."_cogs_"..i, { pos_z = 5 } );
        ObjSet( "spr_gate_scr"..infix.."_cogs_"..number, { pos_z = 0 } );

        ObjAnimate( "spr_gate_scr"..infix.."_cogs_"..number, "pos_xy", 0, 0, function() func_after(i) end, { 0,0,param_old[1],param_old[2], 0.3,0,param_new.pos_x,param_new.pos_y } ); 
        ObjAnimate( "spr_gate_scr"..infix.."_cogs_"..i, "pos_xy", 0, 0, "", { 0,0,param_new.pos_x,param_new.pos_y, 0.3,0,param_old[1],param_old[2] } );    

        break;

    end;

  end;


  if change_flag == false then

    common_impl.Lock( true );

    local func_2_after = function()

      common_impl.Lock( false );
      ObjSet( "spr_gate_scr"..infix.."_cogs_"..number, { pos_z = 0 } );
      common_impl.SetCursor( CURSOR_DEFAULT );
      private.numstate[private.number] = number;
      

      if private.CheckWin() == true then

        private.Win();

      else

        for j = 1, 10 do

          ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate[j] = private.numstate[j];

        end;      

      end;

    end;

    if private.win[private.number] == number then

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear_true", 0, "", 0 );

    else

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear", 0, "", 0 );

    end;

    ObjAnimate( "spr_gate_scr"..infix.."_cogs_"..number, "pos_xy", 0, 0, func_2_after, { 0,0,param_old[1],param_old[2], 0.4,0, private.coords[private.number][1], private.coords[private.number][2] } ); 
    
  end;

end;
--*********************************************************************************************************************
function private.CheckWin()

  local win_counter = 0;
  local numb = ng_global.progress[ "scr" ][ "win_gate_scr" ].numb;

  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  for i = 1, #ng_global.progress[ "scr" ][ "win_gate_scr" ].numstate do
   
    if private.numstate[i] == private.win[i] then

      ObjSet( "spr_gate_scr"..infix.."_cogs_"..private.numstate[i], { input = false } );
      ObjSet( "spr_gate_scr"..infix.."_cogs_"..private.numstate[i].."_light", { visible = true } );
      win_counter = win_counter + 1;

    end;
  end;

  if win_counter == 10 then

    return true;
  
  end;

end;
--*********************************************************************************************************************