-- name=menu
 --*********************************************************************************************************************
function public.Start( param )

  interface.WidgetAdd( InterfaceWidget_Window );
  --  interface.WidgetAdd( InterfaceWidget_Pause, 666 );
  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_Effects );
  if (tostring(GetPlatform())~= "ios") then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  end;
  interface.WidgetAdd( InterfaceWidget_Popup );
  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);
  interface.LockAdd();
  local modules = 
  {
     "rm_intro"
    ,"rm_menu"
    ,"rm_extra"
    --,"rm_moregames"
    ,"rm_achievements"
    ,"rm_collectibles2"
    ,"rm_collectibles"
    ,"rm_credits"
    ,"rm_sequel"
    ,"rm_unlock"
  };


  if tostring(GetPlatform()) == "android" then
    private.SubscribeAndroidBackPressed();
  end;

  common.MenuLoad( param, modules );
  common.ProjectSet();
  if tostring(GetPlatform()) == "android" then
  	private.SubscribeAndroidBackPressed();
  end;

end;
-------------------------------------------------------------------------------------
--подписка на нажатие кнопки Back на Андройде

function private.SubscribeAndroidBackPressed ( )

  if not ( private.subscribe_android_back_pressed ) then

    private.subscribe_android_back_pressed = true;
    MsgSubscribe( Event_Android_BackPressed, private.AndroidBackPressed );

  end;

end;
---------------
function private.UnsubscribeAndroidBackPressed ( )

  MsgUnsubscribe( Event_Android_BackPressed, private.AndroidBackPressed );

end;
---------------
function private.AndroidBackPressed ( )

  common_impl.AndroidBackPressed();

end;
-------------------------------------------------------------------------------------
--*********************************************************************************************************************