-- name=rm_extra
--******************************************************************************************
function public.Init()

  if port.isPortable() == 1 and port.ios_lang() == "ja" then
    ObjSet( "txt_extra_music_1",{ fontsize = 22}); 
    ObjSet( "txt_extra_music_2",{ fontsize = 22});
    ObjSet( "txt_extra_music_3",{ fontsize = 22});
    ObjSet( "txt_extra_music_4",{ fontsize = 22});
  end;
  
  ObjSet( "btn_extra_set",{ input = 0, visible = 0, alp = 0, active = 0 });
  ObjSet( "btn_extra_wallpapers", 
    {
      event_mdown =  function () private.ChangeScreen( "wallpapers" ); end,
      event_menter = function () private.ButtonMouseEnter( "wallpapers" ); end,
      event_mleave = function () private.ButtonMouseLeave( "wallpapers" ); end
    } 
  );

  ObjSet( "btn_extra_conceptart", 
    {
      event_mdown =  function () private.ChangeScreen( "conceptart" ); end,
      event_menter = function () private.ButtonMouseEnter( "conceptart" ); end,
      event_mleave = function () private.ButtonMouseLeave( "conceptart" ); end
    } 
  );

  ObjSet( "btn_extra_music", 
    {
      event_mdown =  function () private.ChangeScreen( "music" ); end,
      event_menter = function () private.ButtonMouseEnter( "music" ); end,
      event_mleave = function () private.ButtonMouseLeave( "music" ); end
    } 
  );

  ObjSet( "btn_extra_bonus_chapter", 
    {
      event_mdown =  function () private.ChangeScreen( "bonus_chapter" ); end,
      event_menter = function () private.ButtonMouseEnter( "bonus_chapter" ); end,
      event_mleave = function () private.ButtonMouseLeave( "bonus_chapter" ); end
    } 
  );

  ObjSet( "btn_extra_play", 
    {
      event_mdown =  function () private.BonusChapterPlay();common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" );  end,
      event_menter = function () private.ButtonMouseEnter( "play" ); end,
      event_mleave = function () private.ButtonMouseLeave( "play" ); end
    } 
  );
  
  ObjSet( "btn_extra_mainmenu", 
    {
      event_mdown =  function () common.GotoRoom( "rm_menu" );common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" ); end,
      event_menter = function () private.ButtonMouseEnter( "mainmenu" ); end,
      event_mleave = function () private.ButtonMouseLeave( "mainmenu" ); end
    } 
  );
  
  ObjSet( "btn_extra_achievements", 
    {
      event_mdown =  function () common.GotoRoom( "rm_achievements" );common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" ); end,
      event_menter = function () private.ButtonMouseEnter( "achievements" ); end,
      event_mleave = function () private.ButtonMouseLeave( "achievements" ); end
    } 
  );
  
  ObjSet( "btn_extra_collectibles", 
    {
      event_mdown =  function () common.GotoRoom( "rm_collectibles" );common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" ); end,
      event_menter = function () private.ButtonMouseEnter( "collectibles" ); end,
      event_mleave = function () private.ButtonMouseLeave( "collectibles" ); end
    } 
  );
  ObjSet( "btn_extra_collectibles_2", 
    {
      event_mdown =  function () common.GotoRoom( "rm_collectibles2" );common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" ); end,
      event_menter = function () private.ButtonMouseEnter( "collectibles_2" ); end,
      event_mleave = function () private.ButtonMouseLeave( "collectibles_2" ); end
    } 
  );
  ObjSet( "btn_extra_change_lft", 
    {
      event_mdown =  function () private.ArrowClick( true ) end,
      event_menter = function () private.ButtonMouseEnter( "change_lft" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_lft" ); end
    } 
  );
  ObjSet( "btn_extra_change_rgt", 
    {
      event_mdown =  function () private.ArrowClick( false ) end,
      event_menter = function () private.ButtonMouseEnter( "change_rgt" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_rgt" ); end
    } 
  );

  ObjSet( "btn_extra_set", 
    {
      event_mdown =  function () private.ButtonSetClick() end,
      event_menter = function () private.ButtonMouseEnter( "set" ); end,
      event_mleave = function () private.ButtonMouseLeave( "set" ); end
    } 
  );

  ObjSet( "btn_extra_save", 
    {
      event_mdown =  function () private.ButtonSaveClick() end,
      event_menter = function () private.ButtonMouseEnter( "save" ); end,
      event_mleave = function () private.ButtonMouseLeave( "save" ); end
    } 
  );

  ObjSet( "btn_extra_secretroom", 
    {
      --event_mdown =  function () private.ChangeScreen( "secretroom" ) end, 
      event_mdown =  function () private.SecretRoomPlay() end,
      event_menter = function () private.ButtonMouseEnter( "secretroom" ) end,
      event_mleave = function () private.ButtonMouseLeave( "secretroom" ) end
    } 
  );

  --local saveart = { left = nil, center = { text = "ok", func = "save" }, right = nil };
  --local setwallpaper = 
  common.dialog.common.buttons[ "savemusic" ] = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  common.dialog.common.buttons[ "saveart" ] = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  common.dialog.common.buttons[ "setwallpaper" ] = { left = { text = "ok", func = "set" }, center = nil, right = { text = "no", func = "Close" } };
  common.dialog.common.buttons[ "unlockextra" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
  common.dialog.common.buttons[ "unlocksecret" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
  common.dialog.common.buttons[ "demoextra" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };

  --table.insert ( common.dialog.common.buttons,
  --                setwallpaper
  --              )

  local set_table = {};

  for i = 1,4 do

    table.insert( set_table, {"btn_extra_music_"..i, 
      {
        event_mdown = function() private.BtnMusicPlay( i ); end ,
      event_menter = function () private.ButtonMouseEnter( "music_"..i ); end,
      event_mleave = function () private.ButtonMouseLeave( "music_"..i ); end
      } 
    } );

  end;

  ObjMultiSet( set_table );

  private.current_screen = "wallpapers";  
  private.wallpapers = {};
  private.wallpapers.current_number = 1;
  private.wallpapers.MAX_COUNT = 9;
  private.conceptart = {};
  private.conceptart.current_number = 1;
  private.conceptart.MAX_COUNT = 9;
  private.music = {};
  private.music.current_number = 1;
  private.music.MAX_COUNT = 4;
  private.music.vid_number = 1;
  private.music.is_playing = "";
  private.StartAnims();
  private.music.light_pos = { -54, -14, 28, 70 }
  ObjSet( "txt_extra_play", { text = "1/"..private.wallpapers.MAX_COUNT } );
  
end;
--******************************************************************************************
function public.PreOpen()
 
  --common_impl.PlayAudio(  "mus", "common/audio/aud_mt8_maintheme_mus", 1 );
  --if ( ng_global.progress[ "std" ].common.gamewin ) then
  --  ObjSet( "btn_extra_bonus_chapter", { color_r = 1.0, color_g = 1.0, color_b = 1.0, input = true } );
  --else
  --  ObjSet( "btn_extra_bonus_chapter", { color_r = 0.5, color_g = 0.5, color_b = 0.5, input = false } );
  --end;

  
end;
--******************************************************************************************
function public.Open()

  --private.music.is_playing

end;

function public.Close()

  if private.music.is_playing ~= "" then

    common_impl.StopAudio( "mus",  "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 )
    ObjMultiSet( {
                   { "spr_extra_stop_"..private.music.is_playing , { alp = 0 } };
                   { "spr_extra_play_"..private.music.is_playing , { alp = 1 } };
                   { "vid_extra_plates_"..private.music.vid_number.."_return", { visible = false } },
                   { "vid_extra_plates_"..private.music.vid_number, { visible = true, frame = 0 } } 
                 } );
    private.music.is_playing = "";

  end;

end;
--******************************************************************************************
function private.ChangeScreen ( new_screen )

  if  new_screen == "music" or new_screen == "bonus_chapter" then
    ObjSet( "btn_extra_save",{ input = 0, visible = 0, alp = 0, active = 0 });
  else
    ObjSet( "btn_extra_save",{ input = 1, visible = 1, alp = 1, active = 1 });
  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" );
  if ( private.current_screen == new_screen ) then
    return;
  end;
  
  ------------------------------------

  if ( private.current_screen == "music" ) or ( new_screen == "music" ) then
    
    
    local func_end = function ()

      private.current_screen = new_screen;
      if new_screen == "music" then
        ObjSet( "txt_extra_play", { text = private[new_screen].current_number.."/"..private[new_screen].MAX_COUNT, fontsize = 30 } );
      end;
      common_impl.Lock( false );

    end;

    local func_change = function ()

      local new_y, window, param = 250, 1, false;

      if ( private.current_screen == "music" ) then
        new_y, window, param = 250, 2, true;
      end;
      
      ObjSet( "obj_extra_music_list", { input = not param, visible = not param} );
      ObjSet( "spr_extra_window", { res = "assets/levels/menu/rm_extra/layers/window_"..window, input = not param } );
      ObjSet( "spr_extra_window_picture", { 
                                            visible = param
                                            --res = "assets/levels/menu/rm_extra/layers/"..private.current_screen.."/"..private[private.current_screen].current_number
                                          } );

      ObjAnimate( "spr_extra_window", "pos_y", 0, 0, func_end,
      {
        0.0, 0, -39,
        0.3, 0, new_y
      } );

    end;

    ObjAnimate( "spr_extra_window", "pos_y", 0, 0, func_change,
    {
      0.0, 0, ObjGet( "spr_extra_window" ).pos_y,
      0.3, 0, -39
    } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_move" ); 
    common_impl.Lock( true );

  end;

  ------------------------------------

  if ( private.current_screen == "bonus_chapter" ) or ( new_screen == "bonus_chapter" ) then

    local func_end = function ()

      private.current_screen = new_screen;

    end;

    local func_change = function ()

      local new_txt, fontsize, disprawtext = "str_extra_play", 15, false;
      local shadow = "assets/levels/menu/rm_extra/layers/play_now_shadow";
      if ( new_screen == "bonus_chapter" ) then
        
        ObjSet( "btn_extra_play", { input = true } );
        ObjSet( "btn_extra_change_lft", { input = false } );
        ObjSet( "btn_extra_change_rgt", { input = false } );
        ObjSet( "spr_extra_window_picture", { 
                                            res = "assets/levels/menu/rm_extra/layers/picture_1"
                                            } );

      else

        ObjSet( "btn_extra_play", { input = false, alp=0 } );
        ObjSet( "btn_extra_change_lft", { input = true } );
        ObjSet( "btn_extra_change_rgt", { input = true } );
        shadow = "assets/levels/menu/rm_extra/layers/numbers_shadow";
        new_txt = private[new_screen].current_number.."/"..private[new_screen].MAX_COUNT;
        fontsize = 30;
        disprawtext = true;

      end;

      ObjSet( "spr_extra_play_shadow", { res = shadow } );
      ObjSet( "txt_extra_play", { text = new_txt, fontsize = fontsize, disprawtext = disprawtext } );

      ObjAnimate( "btn_extra_play", "alp", 0, 0, func_end,
      {
        0.0, 0, 0,
        0.2, 0, 1
      } );

      ObjAnimate( "spr_extra_play_shadow", "alp", 0, 0, "",
      {
        0.0, 0, 0,
        0.2, 0, 1
      } );

    end;

    ObjAnimate( "btn_extra_play", "alp", 0, 0, func_change,
    {
      0.0, 0, 1,
      0.2, 0, 0
    } );

    ObjAnimate( "spr_extra_play_shadow", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.2, 0, 0
    } );

  end;

  ------------------------------------

  if not ( private.current_screen == "wallpapers" ) and ( new_screen == "wallpapers" ) or
    not ( private.current_screen == "conceptart" ) and ( new_screen == "conceptart" ) then

      common_impl.Lock( true );

      local anm_after = function ()

         local func_after = function ()

          common_impl.Lock( false );

        end; 

         ObjSet( "spr_extra_window_picture", 
         { 
           res = "assets/levels/menu/rm_extra/layers/"..new_screen.."/mini/"..private[new_screen].current_number
         } );

          ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, func_after, { 0,0,0, 0.4,0,1 });

          if not ( new_screen == "bonus_chapter" ) then
            ObjSet( "txt_extra_play", { text = private[new_screen].current_number.."/"..private[new_screen].MAX_COUNT } );
            private.current_screen = new_screen;
          end;
          DbgTrace( private.current_screen );

      end;

      ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, anm_after, { 0,0,1, 0.4,0,0});

  end;

  
  ------------------------------------

  if ( new_screen == "secretroom" ) then

    private.ButtonSecretroom();

  end;

end;
--******************************************************************************************
function private.ArrowClick ( direction )

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" );

  local new_res = 1;

  if not direction then

    if private[private.current_screen].current_number < private[private.current_screen].MAX_COUNT then

      new_res = private[private.current_screen].current_number + 1;

    end;

  else 

    if private[private.current_screen].current_number == 1 then

      new_res = private[private.current_screen].MAX_COUNT;

    else

      new_res = private[private.current_screen].current_number - 1;      

    end;

  end;

  if private.current_screen == "music" then

    common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" );
    private.BtnMusicPlay( new_res );

  else

    common_impl.Lock( true );

    local anm_after = function ()

      local func_after = function ()

        common_impl.Lock( false );
        private[private.current_screen].current_number = new_res;

      end;

      ObjSet( "spr_extra_window_picture",
      {
        res = "assets/levels/menu/rm_extra/layers/"..private.current_screen.."/mini/"..new_res
      } );
      ObjSet( "txt_extra_play", { text = new_res.."/"..private[private.current_screen].MAX_COUNT } );

      ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, func_after, { 0,0,0, 0.4,0,1 });

    end;

    ObjAnimate( "spr_extra_window_picture", "alp", 0, 0, anm_after, { 0,0,1, 0.4,0,0});
    common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_change" );

  end;

end;
--******************************************************************************************
function private.BtnMusicPlay( track_number )

  local new_vid;

  if private.music.vid_number == 1 then

    new_vid = 2;

  else

    new_vid = 1;

  end;

  if private.music.is_playing == "" then

    local vid_after = function ()

      private.music.vid_number = new_vid;
      common_impl.Lock( false );

      ObjSet( "spr_extra_stop_"..track_number , { alp = 1 } );
      ObjSet( "spr_extra_play_"..track_number , { alp = 0 } );

      private.music.current_number = track_number;
      private.music.is_playing = track_number;

      common_impl.PlayAudio( "mus", "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 );

    end;

    ObjMultiSet( {
                   { "vid_extra_plates_"..private.music.vid_number, { visible = false } },
                   { "vid_extra_plates_"..private.music.vid_number.."_return", { visible = false } },
                   { "vid_extra_plates_"..new_vid, { visible = true, frame = 0 } } 
                 } );
    ObjSet( "txt_extra_play", { text = track_number.."/"..private[private.current_screen].MAX_COUNT } );
    VidPlay( "vid_extra_plates_"..new_vid,  vid_after );
    ObjAnimate( "spr_extra_music_choise_light", "pos_y", 0, 0, "", {0, 0, private.music.light_pos[private.music.current_number], 0.6, 0, private.music.light_pos[track_number]});
    common_impl.PlayAudio( "sfx", "common/audio/aud_music_disc_on" ); 
    common_impl.Lock( true );

  else

    common_impl.StopAudio( "mus",  "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 )

    local vid_after;

    if private.music.is_playing == track_number then

       vid_after = function ()

       common_impl.Lock( false );
       ObjSet( "spr_extra_stop_"..private.music.is_playing , { alp = 0 } );
       ObjSet( "spr_extra_play_"..private.music.is_playing , { alp = 1 } );
       private.music.current_number = track_number;
       private.music.is_playing = "";

      end;

    else

      vid_after = function ()

        common_impl.Lock( false );
        ObjSet( "spr_extra_stop_"..private.music.is_playing , { alp = 0 } );
        ObjSet( "spr_extra_play_"..private.music.is_playing , { alp = 1 } );
        private.music.is_playing = "";
        private.BtnMusicPlay( track_number )
        --common_impl.PlayAudio( "sfx", "common/audio/aud_music_disc_on" ); 

      end;

    end;

    common_impl.Lock( true );

    ObjMultiSet( {
                   { "vid_extra_plates_"..private.music.vid_number.."_return", { visible = true, frame = 0 } },
                   { "vid_extra_plates_"..private.music.vid_number, { visible = false } } 
                 });
   
    VidPlay( "vid_extra_plates_"..private.music.vid_number.."_return", vid_after  );
    common_impl.PlayAudio( "sfx", "common/audio/aud_music_disc_off" );

  end;

end;
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_extra_"..but_name.."_focus";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  --cmn.PlayAudio( "sfx", "common/audio/aud_menter_sfx" );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_extra_"..but_name.."_focus";

  if ( not ObjGet( obj ) ) then return; end;

  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.ButtonSetClick()

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" );
  if IsDemoEdition() then

    common.DialogWindowShow( "common", "demoextra" );

  elseif private.current_screen == "conceptart" or private.current_screen == "wallpapers"  then

    common.DialogWindowShow( "common", "setwallpaper" );

  end;

end;
--******************************************************************************************
function private.ButtonSaveClick()

  common_impl.PlayAudio( "sfx", "common/audio/aud_bonus_click" );

  if IsDemoEdition() then

    common.DialogWindowShow( "common", "demoextra" );

  elseif private.current_screen == "music" then

    common.DialogWindowShow( "common", "savemusic" );

  elseif private.current_screen == "conceptart" or private.current_screen == "wallpapers"  then

    common.DialogWindowShow( "common", "saveart" );

  else

  end;

end;
--******************************************************************************************
function private.ButtonSecretroom()

  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu" );
  SetCursor( CURSOR_DEFAULT );

--  if ng_global.progress[ "secretroom" ].common.gamewin == true  then
--    
--    common.DialogWindowShow( "common", "finishsecretroom", true )
--
--  elseif ng_global.progress[ "ext" ].common.gamewin == true then
--
--    private.SecretRoomPlay(); 
--
--  else
--
--    if IsDemoEdition() == 1 or IsSurveyEdition() == 1 then
--
--      common.DialogWindowShow( "common", "demoextra" );
--
--    else
--    
--      common.DialogWindowShow( "common", "unlocksecret" );
--
--    end;
--   
--  end;

end;
--******************************************************************************************
function private.SecretRoomPlay () 

  if not IsDemoEdition() then

    if ng_global.progress[ "ext" ].common.gamewin then

      local prg = "scr";
      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else

      common.DialogWindowShow( "common", "unlocksecret" );

    end;

  else

      common.DialogWindowShow( "common", "demoextra" );

  end;
 
end;
--******************************************************************************************
function private.BonusChapterPlay () 

  if not IsDemoEdition() then

    if ng_global.progress[ "std" ].common.gamewin then

      ng_global.currentprogress = "ext";

      if ( not ng_global.progress[ "ext" ].common.gamestart ) then
        ng_global.progress[ "ext" ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ "ext" ].common.chapter;
      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else

      common.DialogWindowShow( "common", "unlockextra" );

    end;

  else

      common.DialogWindowShow( "common", "demoextra" );

  end;
end;

--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims ()

  ObjAnimate( "spr_extra_lamp", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0,
    1.8, 0, 0.5,
    2.9, 0, 0.9,
    4.0, 3, 0.45,
    5.7, 2, 1.0
  } );

  ObjAnimate( "spr_extra_light", "alp", 1, 0, "",
  {
    0.0,  0, 1.0,
    2.5,  0, 0.6,
    4.8,  0, 0.93,
    7.0,  3, 0.5,
    9.0,  2, 1.0
  } );

end;

function common.dialog.common.save()

  if private.current_screen == "music" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/music/soundtrack_"..private[private.current_screen].current_number..".mp3" );


  elseif private.current_screen == "conceptart" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/conceptart/"..private[private.current_screen].current_number );

  else

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/wallpapers/"..private[private.current_screen].current_number.."_art" );

  end;

  common.DialogWindowHide( "common" );

end;

function common.dialog.common.set()

  if private.current_screen == "conceptart" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/conceptart/"..private[private.current_screen].current_number );
    
  elseif private.current_screen == "wallpapers" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/wallpapers/"..private[private.current_screen].current_number.."_art" );
    
  end;

  common.DialogWindowHide( "common" );

end;